=== Safari-111 ===

2003-10-24  Richard Williamson   <rjw@apple.com>

	Fixed 3425358.  Don't try to create page cache for pages that
	have a nil view().

        Reviewed by Hyatt.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge saveDocumentToPageCache]):

2003-10-24  David Hyatt  <hyatt@apple.com>

	Fix for 3133375, the minwidth computation for pres is wrong.  There were a couple of bugs here.
	One is that pres only should have a breakable character if they contain a newline.  Otherwise they're
	treated essentially like nowrap.  The other was that m_beginMinWidth and m_endMinWidth needed to be
	set to the maxwidth of the first line and the maxwidth of the last line respectively for pres instead of
	being only the first and last words.
	
        Reviewed by mjs

        * khtml/rendering/render_text.cpp:
        (RenderText::calcMinMaxWidth):

2003-10-24  David Hyatt  <hyatt@apple.com>

	Two fixes to the computation of min/max width for text runs.
	(1) Make sure that pre runs don't add in word-spacing to the last word on a line (e.g., when a newline explicitly
	breaks a pre).
	(2) Fix a bug where breakable characters weren't getting factored into minwidth properly.  When a word got broken
	because of a breakable character, we were treating the breakable character like a space, and not including its
	width as part of the minimum width of the text run.
	
        Reviewed by john

        * khtml/rendering/render_text.cpp:
        (RenderText::calcMinMaxWidth):

2003-10-23  David Hyatt  <hyatt@apple.com>

	This patch fixes the pseudo-elements ::first-line and ::first-letter to inherit styles properly.  More
	specifically it does the following:

	(1) Implements caching of pseudo-styles once computed off the style() which originated the pseudo-style.
	The old code did this, and this was a regression from my previous patch.

	(2) Fixes first-letter checking so that it happens at layout time rather than during render object
	construction time, since that makes first-letter more dynamic and causes it to be discovered in cases
	where it was being missed before.  This fixes the front page of meyerweb.com.

	(3) Make first-letter inherit from first-line like it's supposed to, and also make first-line styles
	cross blocks and inherit properly from enclosing containers.

	(4) Make first-letter changes cause a detach/attach to fire just as when the display changes.  I generalized
	the notion of needing to detach on a style change by making it a new kind of hint in dom_nodeimpl's style
	diff function.

	(5) Fixed isBlockFlow to return true for inline-blocks.
	
        Reviewed by john

        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::addChildToFlow):
        (khtml::RenderBlock::layoutBlock):
        (khtml::RenderBlock::getFirstLineBox):
        (khtml::RenderBlock::firstLineBlock):
        (khtml::RenderBlock::updateFirstLetter):
        * khtml/rendering/render_block.h:
        (khtml::RenderBlock::isBlockFlow):
        * khtml/rendering/render_line.cpp:
        (InlineFlowBox::paintBackgroundAndBorder):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::setStyle):
        * khtml/rendering/render_object.cpp:
        (RenderObject::RenderObject):
        (RenderObject::firstLineBlock):
        (RenderObject::updateFirstLetter):
        (RenderObject::dump):
        (RenderObject::setStyle):
        (RenderObject::recalcMinMaxWidths):
        (RenderObject::style):
        (RenderObject::getPseudoStyle):
        * khtml/rendering/render_object.h:
        (khtml::RenderObject::overhangingContents):
        * khtml/rendering/render_style.cpp:
        (pseudoBit):
        * khtml/rendering/render_style.h:
        (khtml::RenderStyle::):
        * khtml/rendering/render_table.cpp:
        (RenderTable::firstLineBlock):
        (RenderTable::updateFirstLetter):
        * khtml/rendering/render_table.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::paintObject):
        (RenderText::htmlFont):
        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::recalcStyle):
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::diff):
        * khtml/xml/dom_nodeimpl.h:
        (DOM::NodeImpl::):

2003-10-23  Ken Kocienda  <kocienda@apple.com>

        Reviewed by David

	Fix for these bugs:

	<rdar://problem/3171929>: Safari picks a different button in a 
	form when you hit return if the first button has no name
	<rdar://problem/3200386>: investigate which button is activated 
	when hitting return in form text input fields

	HTML spec says that buttons must have names to be considered
	successful. However, other browsers do not impose this constraint.
	Therefore, we behave differently, and can use different buttons than
	the author intended.

        * khtml/html/html_formimpl.cpp:
        (HTMLButtonElementImpl::isSuccessfulSubmitButton)
        (HTMLInputElementImpl::isSuccessfulSubmitButton)

2003-10-22  David Hyatt  <hyatt@apple.com>

	Fix for 3460726, the user agent string was returning nil.  

	Fix for 3386544, empty documents did not get a layout, and so they looked white.  Also fixed the positioning
	of widgets to account for border/padding in updateWidgetPositions.

	Fix for espn.com crasher, 3458143, caused by layout object not being properly cleared when layouts were
	unscheduled.
	
        Reviewed by darin

        * khtml/khtmlview.cpp:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::RenderCanvas):
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::updateWidgetPositions):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::userAgent):

2003-10-22  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by 

	- fixed 3460664 - Exception handlers not properly removed
	
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::mouseMoved): Don't return from exception block
        (KWQKHTMLPart::khtmlMouseReleaseEvent): Add exception blocking (whoops)

2003-10-22  John Sullivan  <sullivan@apple.com>

	- fixed 3460652 -- REGRESSION (100-110+): Can't tab out of a 
	frameset page

        Reviewed by Darin (actually he made the change on my machine)

        * khtml/html/html_baseimpl.cpp:
        (HTMLFrameSetElementImpl::defaultEventHandler):
	only set defaultHandled for the one event that we actually
	handle (mouse event to resize frame borders); this was always
	being set, hence preventing key events from being used elsewhere.

2003-10-22  Richard Williamson   <rjw@apple.com>

	Fixed 3454067.  RenderText's repaint wasn't called because of recent changes to de-virtualize repaint.  Modified getAbsoluteRepaintRect() to return containing block's getAbsoluteRepaintRect().
	
	Also removed the long standing +1 from QFontMetrics::height().

        Reviewed by Hyatt.

        * khtml/rendering/render_text.cpp:
        (RenderText::getAbsoluteRepaintRect):
        * khtml/rendering/render_text.h:
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::height):

2003-10-22  David Hyatt  <hyatt@apple.com>

	Fix visibility to be done when widgets are added or when styles are set rather than at paint time.  Fixes
	the ads painting on top of content at tvguide.com.
	
        Reviewed by cblu

        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::setQWidget):
        (RenderWidget::setStyle):
        (RenderWidget::paintObject):
        * kwq/KWQWidget.h:
        * kwq/KWQWidget.mm:
        (QWidget::QWidget):
        (QWidget::show):
        (QWidget::hide):

2003-10-21  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	Finished exception blocking changes, so now I can finally say:

	- fixed 3137084 - Many non-reproducible crashers in ContextImp::mark / ScopeChain::mark
	- fixed 3308848 - nil-deref in KHTMLView::topLevelWidget
	- fixed 3311511 - nil deref inside KJS::Screen
	- fixed 3397422 - 7B51: Safari crashed in KJS::ObjectImp::mark()
	- fixed 3408373 - Panther7B58 : Safari Crashed in KJS::ObjectImp::mark
	- fixed 3409307 - 7B55: safari crashed in KJS::Interpreter::globalExec() (idle, nothing particular going on)
	- fixed 3410160 - 7B60 Safari crashed in KHTMLPart::parentPart called from JS while in the background
	- fixed 3413224 - unrepro crash in KJS::Window::mark
	- fixed 3419940 - unrepro crash in KJS::Collector::allocate trying to access http://www.lindyinthepalms.com
	- fixed 3420123 - Panther7B66: Safari crashed while going to http://www.tangents.co.uk/index2.html
	- fixed 3423225 - Safari crash in vtable for KWQMapImpl (vtable for KWQMapImpl + 8).
	- fixed 3437190 - nil-deref on quit in calling marked() from ScopeChain::mark()

        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQFontMetrics.mm:
        * kwq/KWQPainter.mm:
        (QPainter::drawPixmap):
        (QPainter::drawTiledPixmap):
        (QPainter::_updateRenderer):
        * kwq/WebCoreTextRenderer.h:

2003-10-21  David Hyatt  <hyatt@apple.com>

	http://placenamehere.com/safari/fixedbgtest.html is now fixed with a patch from the KHTML trunk.
	Fixed backgrounds repeated when they weren't supposed to.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::paintBackgroundExtended):

2003-10-21  David Hyatt  <hyatt@apple.com>

	Change pseudo-element style resolution to be lazy and to not occur until the style is actually asked
	for by the front end render objects.  Also fix first-letter to inherit properly from first-line styles.
	
        Reviewed by mjs

        * khtml/css/cssstyleselector.cpp:
        (khtml::CSSStyleSelector::initForStyleResolve):
        (khtml::CSSStyleSelector::styleForElement):
        (khtml::CSSStyleSelector::pseudoStyleForElement):
        (khtml::CSSStyleSelector::checkSelector):
        (khtml::CSSStyleSelector::checkOneSelector):
        * khtml/css/cssstyleselector.h:
        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::addChildToFlow):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_object.cpp:
        (RenderObject::setStyle):
        (RenderObject::createInlineBox):
        (RenderObject::style):
        (RenderObject::getPseudoStyle):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_style.cpp:
        (pseudoBit):
        (RenderStyle::hasPseudoStyle):
        (RenderStyle::setHasPseudoStyle):
        (RenderStyle::getPseudoStyle):
        (RenderStyle::addPseudoStyle):
        * khtml/rendering/render_style.h:
        (khtml::RenderStyle::NonInheritedFlags::operator==):
        (khtml::RenderStyle::setBitDefaults):
        * khtml/rendering/render_text.cpp:
        (InlineTextBox::paintSelection):
        (RenderText::paintObject):
        (RenderText::htmlFont):

2003-10-21  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	More exception blocking.

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::~KWQKHTMLPart):
        (KWQKHTMLPart::generateFrameName):
        (KWQKHTMLPart::openURL):
        (KWQKHTMLPart::openURLRequest):
        (regExpForLabels):
        (KWQKHTMLPart::clearRecordedFormValues):
        (KWQKHTMLPart::recordFormValue):
        (KWQKHTMLPart::submitForm):
        (KHTMLPart::frameDetached):
        (KWQKHTMLPart::urlSelected):
        (KWQKHTMLPart::createPart):
        (KWQKHTMLPart::setTitle):
        (KWQKHTMLPart::setStatusBarText):
        (KWQKHTMLPart::scheduleClose):
        (KWQKHTMLPart::unfocusWindow):
        (KWQKHTMLPart::jumpToSelection):
        (KWQKHTMLPart::redirectionTimerStartedOrStopped):
        (KWQKHTMLPart::userAgent):
        (KWQKHTMLPart::mimeTypeForFileName):
        (KWQKHTMLPart::nextKeyView):
        (KWQKHTMLPart::currentEventIsMouseDownInWidget):
        (KWQKHTMLPart::openURLFromPageCache):
        (KWQKHTMLPart::saveDocumentState):
        (KWQKHTMLPart::restoreDocumentState):
        (KWQKHTMLPart::requestedURLString):
        (KWQKHTMLPart::incomingReferrer):
        (KWQKHTMLPart::runJavaScriptAlert):
        (KWQKHTMLPart::runJavaScriptConfirm):
        (KWQKHTMLPart::runJavaScriptPrompt):
        (KWQKHTMLPart::createEmptyDocument):
        (KWQKHTMLPart::keyEvent):
        (KWQKHTMLPart::khtmlMousePressEvent):
        (KWQKHTMLPart::passWidgetMouseDownEventToWidget):
        (KWQKHTMLPart::lastEventIsMouseUp):
        (findViewInSubviews):
        (KWQKHTMLPart::khtmlMouseMoveEvent):
        (KWQKHTMLPart::passSubframeEventToSubframe):
        (KWQKHTMLPart::buttonForCurrentEvent):
        (KWQKHTMLPart::stateForCurrentEvent):
        (KWQKHTMLPart::mouseDown):
        (KWQKHTMLPart::mouseDragged):
        (KWQKHTMLPart::mouseUp):
        (KWQKHTMLPart::sendFakeEventsAfterWidgetTracking):
        (KWQKHTMLPart::mouseMoved):
        (KWQKHTMLPart::sendContextMenuEvent):
        (fileWrapperForElement):
        (KWQKHTMLPart::attributedString):
        (KWQKHTMLPart::keyboardUIMode):

2003-10-21  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3176170>: OBJECT tag with no or empty TYPE is mishandled

        Reviewed by rjw.

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::createPart): call renamed frameRequiredForMIMEType:URL:
        * kwq/WebCoreBridge.h: renamed frameRequiredForMIMEType: to frameRequiredForMIMEType:URL:

2003-10-20  David Hyatt  <hyatt@apple.com>

	Fix generated content (before/after) so that it no longer has any restrictions on it.   CSS2.1 lifted 
	restrictions preventing the floating/positioning of generated content.
	
        Reviewed by rjw

        * khtml/css/cssstyleselector.cpp:
        (khtml::CSSStyleSelector::adjustRenderStyle):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):

2003-10-20  Ken Kocienda  <kocienda@apple.com>

        Reviewed by David

        * khtml/dom/dom2_events.cpp:
        (UIEvent::keyCode): Change over to use ascii value for key code.
        (UIEvent::which): Ditto.
        (KeyboardEvent::KeyboardEvent): New key event class which
	tracks the DOM Level 3 spec more closely.
        (KeyboardEvent::operator = ): New function.
        (KeyboardEvent::~KeyboardEvent): New function.
        (KeyboardEvent::ctrlKey): New function.
        (KeyboardEvent::shiftKey): New function.
        (KeyboardEvent::altKey): New function.
        (KeyboardEvent::metaKey): New function.
        (KeyboardEvent::altGraphKey): New function.
        (KeyboardEvent::initKeyboardEvent): New function.
        * khtml/dom/dom2_events.h: Ditto.
        * khtml/html/html_formimpl.cpp:
        (HTMLGenericFormElementImpl::defaultEventHandler): Use key 
	identifiers to test which key was pressed, instead of removed keyVal().
        (HTMLInputElementImpl::defaultEventHandler): Ditto.
        (HTMLSelectElementImpl::defaultEventHandler): Ditto.
        * khtml/html/html_inlineimpl.cpp:
        (HTMLAnchorElementImpl::defaultEventHandler): Change casts to match new
	class name. Use key identifiers to test which key was pressed, 
	instead of removed keyVal(). Use new modifier accessors.
        * khtml/xml/dom2_eventsimpl.cpp:
        (EventImpl::typeToId): Some reorganization of the constants in the
	switch statements. Name change for these to remove the KHTML_ prefix
	from the key up and key down events will happen soon.
        (EventImpl::idToType): Ditto.
        (KeyboardEventImpl::KeyboardEventImpl): New key event class which
        tracks the DOM Level 3 spec more closely.
        (KeyboardEventImpl::~KeyboardEventImpl): Ditto.
        (KeyboardEventImpl::initKeyboardEvent): Ditto.
        * khtml/xml/dom2_eventsimpl.h:
        (DOM::EventImpl::): Some reorganization of the constants in the
        switch statements. Name change for these to remove the KHTML_ prefix
        from the key up and key down events will happen soon.
        (DOM::KeyboardEventImpl::keyIdentifier): New function.
        (DOM::KeyboardEventImpl::keyLocation): New function.
        (DOM::KeyboardEventImpl::ctrlKey): New function.
        (DOM::KeyboardEventImpl::shiftKey): New function.
        (DOM::KeyboardEventImpl::altKey): New function.
        (DOM::KeyboardEventImpl::metaKey): New function.
        (DOM::KeyboardEventImpl::altGraphKey): New function.
        (DOM::KeyboardEventImpl::qKeyEvent): New function.
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::createEvent): Now can create keyboard events.
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::dispatchKeyEvent): Class name changes.
        * kwq/KWQEvent.h: Added QString identifier member.
        * kwq/KWQEvent.mm:
        (hexDigit): Added helper.
        (identifierForKeyText): Added new function to map keys to DOM
	key identifiers as listed in the DOM spec.
        (QKeyEvent::identifier): Added accessor.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::stateForCurrentEvent): Added check to see if
	a key press is on one of the numeric keypad keys.
        * kwq/KWQLogging.h: Added log constant for DOM events.
        * kwq/KWQLogging.m: Ditto

2003-10-20  David Hyatt  <hyatt@apple.com>

	Make first-letter and before/after work with text transforms.
	
        Reviewed by mjs

        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::addChildToFlow):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_text.cpp:
        (RenderText::setStyle):
        (RenderText::isTextFragment):
        (RenderText::originalString):
        (RenderText::setText):
        (m_generatedContentStr):
        (m_start):
        (RenderTextFragment::~RenderTextFragment):
        (RenderTextFragment::isTextFragment):
        (RenderTextFragment::originalString):
        * khtml/rendering/render_text.h:
        (khtml::RenderTextFragment::start):
        (khtml::RenderTextFragment::end):
        (khtml::RenderTextFragment::contentString):
        * khtml/xml/dom_nodeimpl.h:
        (DOM::NodeImpl::setRenderer):

2003-10-19  David Hyatt  <hyatt@apple.com>

	Remove the "flow-around-floats" hack for lists.  Other browsers don't do this.
	
        Reviewed by darin

        * khtml/css/quirks.css:

2003-10-19  David Hyatt  <hyatt@apple.com>

	Fix for a regression/crash on tivocommunity.com caused by faulty border-collapse code in the collapsedRightBorder
	case.  I forgot to deal with colspans.
	
        Reviewed by darin

        * khtml/rendering/render_table.cpp:
        (RenderTable::cellRight):
        (RenderTableCell::collapsedRightBorder):

2003-10-19  David Hyatt  <hyatt@apple.com>

	Patch from KHTML trunk that makes textareas work properly even when they have no render objects.

        * khtml/html/html_formimpl.cpp:
        (HTMLTextAreaElementImpl::encoding):
        (HTMLTextAreaElementImpl::value):

2003-10-18  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3454444 -- contents of mailto form shows up in Mail title instead of body (IE sends mail directly)

        * kwq/KWQKURL.mm: (KURL::parse): Changed non-hierarchical code to consider everything
        after a question mark as a query, just the way the hierarchical code does. This makes
        the code that constructs the mailto URL work properly.

2003-10-18  David Hyatt  <hyatt@apple.com>

	Fix the intrinsic minmax width computation for blocks and XUL boxes to actually check fixed min/max CSS widths.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::calcMinMaxWidth):
        * khtml/rendering/render_flexbox.cpp:
        (khtml::RenderFlexibleBox::calcMinMaxWidth):

2003-10-18  David Hyatt  <hyatt@apple.com>

	Change the names of the border-spacing properties to border-horizontal-spacing and border-vertical-spacing.
	
        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssproperties.c:
        (findProp):
        * khtml/css/cssproperties.h:
        * khtml/css/cssproperties.in:
        * khtml/css/cssstyleselector.cpp:
        (khtml::CSSStyleSelector::applyRule):

2003-10-18  David Hyatt  <hyatt@apple.com>

	Fix for diveintomark className parsing bug.  class="bigblue blue" would fail to match a rule with .blue.
	The bug was in the selector matching code for class attributes.

	Also fixing a minmax width bug for blocks on the mozilla.org Web site.  XUL boxes had the same bug as
	well.
	
        Reviewed by darin

        * khtml/css/cssstyleselector.cpp:
        (khtml::CSSStyleSelector::checkOneSelector):
        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::calcMinMaxWidth):
        * khtml/rendering/render_flexbox.cpp:
        (khtml::RenderFlexibleBox::calcMinMaxWidth):

2003-10-18  David Hyatt  <hyatt@apple.com>

	Fix for 3443502, generated content sometimes doesn't generate.  The bug is caused by an
	uninitialized variable.  m_isContinuation needed to be set to false in the RenderInline
	constructor.
	
        * khtml/rendering/render_inline.cpp:
        (m_isContinuation):

2003-10-17  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - make text areas set the base writing direction based on the direction in the CSS style

        * kwq/KWQTextArea.h: Added setBaseWritingDirection method.
        * kwq/KWQTextArea.mm:
        (-[KWQTextArea _createTextView]): Use _KWQ_setTypingParagraphStyle.
        (-[KWQTextArea setWordWrap:]): Use _KWQ_setTypingParagraphStyle.
        (-[KWQTextArea setBaseWritingDirection:]): Added. New method that sets the base writing
        direction in both the style of the text and the typing attributes.
        (-[NSTextView _KWQ_typingParagraphStyle]): Added. Helper method to make setBaseWritingDirection:
        a little less gigantic.
        (-[NSTextView _KWQ_setTypingParagraphStyle:]): Ditto.
        (-[NSTextStorage _KWQ_setBaseWritingDirection:]): Ditto.

        * kwq/KWQTextEdit.mm: (QTextEdit::setAlignment): Set both alignment and base writing direction.

2003-10-17  David Hyatt  <hyatt@apple.com>

	Implement horizontal and vertical border-spacing.  Allow them to be specified individually.

        Reviewed by mjs

	------

	Fix the calcWidth method of tables to account for horizontal margins properly.

	Reviewed by john

	------

	Implement border collapsing in tables.

	Reviewed by kocienda

        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssproperties.c:
        (hash_prop):
        (findProp):
        * khtml/css/cssproperties.h:
        * khtml/css/cssproperties.in:
        * khtml/css/cssstyleselector.cpp:
        (khtml::CSSStyleSelector::applyRule):
        * khtml/css/cssvalues.c:
        * khtml/css/cssvalues.h:
        * khtml/css/cssvalues.in:
        * khtml/rendering/bidi.cpp:
        (khtml::RenderBlock::layoutInlineChildren):
        * khtml/rendering/render_box.cpp:
        (RenderBox::paintBoxDecorations):
        * khtml/rendering/render_form.cpp:
        (RenderFieldset::paintBorderMinusLegend):
        * khtml/rendering/render_object.cpp:
        (RenderObject::paintBorder):
        (RenderObject::collectBorders):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_style.cpp:
        (StyleInheritedData::StyleInheritedData):
        (StyleInheritedData::operator==):
        (RenderStyle::diff):
        * khtml/rendering/render_style.h:
        (khtml::):
        (khtml::CollapsedBorderValue::precedence):
        (khtml::CollapsedBorderValue::width):
        (khtml::CollapsedBorderValue::style):
        (khtml::CollapsedBorderValue::exists):
        (khtml::CollapsedBorderValue::color):
        (khtml::CollapsedBorderValue::isTransparent):
        (khtml::CollapsedBorderValue::operator==):
        (khtml::RenderStyle::borderLeft):
        (khtml::RenderStyle::borderRight):
        (khtml::RenderStyle::borderTop):
        (khtml::RenderStyle::borderBottom):
        (khtml::RenderStyle::horizontalBorderSpacing):
        (khtml::RenderStyle::verticalBorderSpacing):
        (khtml::RenderStyle::setHorizontalBorderSpacing):
        (khtml::RenderStyle::setVerticalBorderSpacing):
        * khtml/rendering/render_table.cpp:
        (RenderTable::RenderTable):
        (RenderTable::setStyle):
        (RenderTable::calcWidth):
        (RenderTable::paint):
        (RenderTable::borderLeft):
        (RenderTable::borderRight):
        (RenderTable::borderTop):
        (RenderTable::borderBottom):
        (RenderTable::cellAbove):
        (RenderTable::cellBelow):
        (RenderTable::cellLeft):
        (RenderTable::cellRight):
        (RenderTableSection::setCellWidths):
        (RenderTableSection::calcRowHeight):
        (RenderTableSection::layoutRows):
        (compareBorders):
        (RenderTableCell::collapsedLeftBorder):
        (RenderTableCell::collapsedRightBorder):
        (RenderTableCell::collapsedTopBorder):
        (RenderTableCell::collapsedBottomBorder):
        (RenderTableCell::borderLeft):
        (RenderTableCell::borderRight):
        (RenderTableCell::borderTop):
        (RenderTableCell::borderBottom):
        (collapsedBorderStyle):
        (CollapsedBorder::CollapsedBorder):
        (CollapsedBorders:::count):
        (CollapsedBorders::addBorder):
        (CollapsedBorders::nextBorder):
        (addBorderStyle):
        (RenderTableCell::collectBorders):
        (RenderTableCell::paintCollapsedBorder):
        (RenderTableCell::paintObject):
        (RenderTableCell::paintBoxDecorations):
        * khtml/rendering/render_table.h:
        (khtml::RenderTable::hBorderSpacing):
        (khtml::RenderTable::vBorderSpacing):
        (khtml::RenderTable::bordersPaddingAndSpacing):
        (khtml::RenderTable::currentBorderStyle):
        * khtml/rendering/table_layout.cpp:
        (FixedTableLayout::layout):
        (AutoTableLayout::calcEffectiveWidth):
        (AutoTableLayout::layout):

2003-10-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	More exception blocking.
	
        * kwq/KWQFont.mm:
        (QFont::isFixedPitch):
        (QFont::getNSFont):
        * kwq/KWQKJobClasses.mm:
        (KIO::TransferJob::~TransferJob):
        * kwq/KWQLoader.mm:
        (KWQServeRequest):
        (KWQCheckIfReloading):
        (KWQCheckCacheObjectStatus):
        (KWQRetainResponse):
        (KWQReleaseResponse):
        (KWQResponseMIMEType):

=== Safari-110 ===

2003-10-16  Darin Adler <darin@apple.com>

        Reviewed by vicki. 

	- fix buildit build failure 

        * kwq/KWQScrollView.mm: 
        (QScrollView::resizeContents):


2003-10-15  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - change "volatile X * volatile" to "X * volatile" in cases where the
          pointer needs to be volatile but the object pointed to do does not

        * kwq/KWQKConfigBase.mm: (KConfig::readEntry):
        * kwq/KWQKCursor.mm: (+[NSCursor _WebCore_cursorWithName:hotSpot:]):
        * kwq/KWQKLocale.mm:
        (inputElementAltText):
        (resetButtonDefaultLabel):
        (searchableIndexIntroduction):
        (submitButtonDefaultLabel):
        (KLocale::language):
        * kwq/KWQLineEdit.mm: (QLineEdit::text):
        * kwq/KWQScrollView.mm:
        (QScrollView::setContentsPos):
        (QScrollView::addChild):
        (QScrollView::updateContents):
        (QScrollView::contentsToViewport):
        (QScrollView::viewportToContents):
        (QScrollView::getDocumentView):
        * kwq/KWQTextEdit.mm:
        (QTextEdit::text):
        (QTextEdit::textWithHardLineBreaks):
        * kwq/KWQWidget.mm: (QWidget::getOuterView):
        Removed the excess volatiles and excess casts that go with them.

        * kwq/KWQKCookieJar.mm: (KWQKCookieJar::cookie): Do the same, but also
        remove an unnecessary nil check that is the same as QString::fromNSString's
        default behavior.

2003-10-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	More objc-exception-blocking excitement.

        * kwq/KWQKConfigBase.mm:
        (KConfig::readEntry):
        (KConfig::readNumEntry):
        (RefreshPlugins):
        * kwq/KWQKCursor.mm:
        (+[NSCursor _WebCore_cursorWithName:hotSpot:]):
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::showApplet):
        * kwq/KWQKLocale.mm:
        (inputElementAltText):
        (resetButtonDefaultLabel):
        (searchableIndexIntroduction):
        (submitButtonDefaultLabel):
        (KLocale::language):
        * kwq/KWQRegion.mm:
        (QRegion::QRegion):

2003-10-14  David Hyatt  <hyatt@apple.com>

	Fix an obvious little typo with smallCaps inheritance.  Richard reviewed.

	Also merge in Dirk's patch to fix a crasher caused by an obvious deref mistake.
	
        Reviewed by rjw and nobody

        * khtml/css/cssstyleselector.cpp:
        (khtml::convertToLength):
        (khtml::CSSStyleSelector::applyRule):

2003-10-14  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Hyatt

        * khtml/dom/dom_misc.h: Declared TristateFlag enum used to implement
	inheritance behavior for inheritable attributes like designMode.
        * khtml/dom/html_document.cpp:
        (HTMLDocument::designMode): Added getter.
        (HTMLDocument::setDesignMode): Added setter.
        * khtml/dom/html_document.h: Added declarations for designMode getter and setter.
        * khtml/dom/html_element.cpp:
        (HTMLElement::isContentEditable): Added convenience.
        (HTMLElement::contentEditable): Added getter.
        (HTMLElement::setContentEditable): Added setter.
        * khtml/dom/html_element.h: Added declarations for contentEditable accessors.
        * khtml/ecma/kjs_html.cpp: Added js support for contentEditable and designMode.
        (KJS::HTMLDocument::tryGet)
        (KJS::HTMLDocument::putValue)
        (KJS::HTMLElement::getValueProperty)
        (KJS::HTMLElement::putValue)
        * khtml/ecma/kjs_html.h:
        (KJS::HTMLDocument::): Added DesignMode to attribuute enum.
        (KJS::HTMLElement::): Added ContentEditable to attribute enum.
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::designMode): Added getter.
        (HTMLDocumentImpl::setDesignMode): Added setter.
        * khtml/html/html_documentimpl.h: Declared designMode accessors.
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::HTMLElementImpl):
        (HTMLElementImpl::parseAttribute): Added support for contentEditable.
        (HTMLElementImpl::isContentEditable): Added. Implements inheritance feature
	for this attribute.
        (HTMLElementImpl::contentEditable): Getter for contentEditable attribute.
        (HTMLElementImpl::setContentEditable): Setter for contentEditable attribute.
        * khtml/html/html_elementimpl.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::setEditMode): Added.
        (KHTMLPart::editMode): Added. Implements inheritance behavior for
	attribute.
        (KHTMLPart::inEditMode): Helper that calls on editMode function.
        (KHTMLPart::parentPart): Made const.
        * khtml/khtml_part.h: Rolled in a couple of typo fixes. Added
	declarations for the changes made in the implementation file.
        * khtml/khtmlpart_p.h:
        (KHTMLPartPrivate::KHTMLPartPrivate): Declared editMode flag.
	Also added support for editMode flag in initializers and copy function.
        * khtml/misc/htmlattrs.in: Added contentEditable as an attribute name.

2003-10-13  David Hyatt  <hyatt@apple.com>

	Fix for a small-caps rendering error when used in conjunction with ::first-line.  Always update
	the Font variable even when QFonts are the same, since small-caps is not stored in QFonts.
	
        Reviewed by rjw

        * khtml/rendering/render_text.cpp:
        (RenderText::paintObject):

2003-10-13  Richard Williamson (Home0  <rjw@apple.com>

	Updated layout tests actuals to reflect implementation of small-caps style.

        * layout-tests/css1/font_properties/font-expected.txt:
        * layout-tests/css1/font_properties/font_variant-expected.txt:
        * layout-tests/css1/pseudo/firstline-expected.txt:
        * layout-tests/css1/pseudo/multiple_pseudo_elements-expected.txt:

2003-10-13  Richard Williamson <rjw@apple.com>

	Added support for small-caps.

        Reviewed by John.

        * khtml/rendering/font.h:
        (khtml::Font::isSmallCaps):
        * khtml/rendering/render_text.cpp:
        (RenderText::shouldUseMonospaceCache):

2003-10-12  Darin Adler  <darin@apple.com>

        * layout-tests/fast/js/date-parse-test.html: Fixed a couple of silly mistakes.

        * kwq/character-sets.txt: New version of file from www.iana.org. No substantive change.
        Also, now that we don't use MIB numbers any more, I could leave out our one local change,
        the MIB number we added for ISO-10646-J-1.

2003-10-10  David Hyatt  <hyatt@apple.com>

	Beginning of work on border collapsing.  This patch makes sure that cell spacing between cells is
	ignored and that padding on tables is ignored.  This ensures that there is no space between cells
	or between the edges of cells and the border of the table itself.  

        Reviewed by john

        * khtml/rendering/render_style.h:
        (khtml::RenderStyle::setBitDefaults):
        * khtml/rendering/render_table.cpp:
        (RenderTable::setStyle):
        (RenderTable::layout):
        * khtml/rendering/render_table.h:
        (khtml::RenderTable::collapseBorders):
        (khtml::RenderTable::bordersPaddingAndSpacing):

2003-10-10  David Hyatt  <hyatt@apple.com>

	Fix for table regression 3449444, as well as a patch to support padding on tables and to stop
	honoring borders on row groups (both of which are correct for the "separate" border model).
	
	* khtml/rendering/render_table.cpp:
        (RenderTable::layout):
        (RenderTableSection::calcRowHeight):
        (RenderTableSection::layoutRows):
        * khtml/rendering/render_table.h:
        (khtml::RenderTable::bordersPaddingAndSpacing):
        * khtml/rendering/table_layout.cpp:
        (FixedTableLayout::calcMinMaxWidth):
        (FixedTableLayout::layout):
        (AutoTableLayout::calcMinMaxWidth):
        (AutoTableLayout::layout):

	Reviewed by darin

2003-10-10  David Hyatt  <hyatt@apple.com>
	
	Patch to move the widgets during layout instead of at paint time.
	
        Reviewed by darin

        * khtml/khtmlview.cpp:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::repaintViewRectangle):
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::baselinePosition):
        (RenderFormElement::layout):
        * khtml/rendering/render_object.cpp:
        (RenderObject::updateWidgetPositions):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::layout):
        (RenderWidget::updateWidgetPositions):
        * khtml/rendering/render_replaced.h:
        * kwq/KWQCheckBox.h:
        * kwq/KWQCheckBox.mm:
        (QCheckBox::baselinePosition):
        * kwq/KWQComboBox.h:
        * kwq/KWQComboBox.mm:
        (QComboBox::baselinePosition):
        * kwq/KWQFileButton.h:
        * kwq/KWQFileButton.mm:
        (KWQFileButton::baselinePosition):
        * kwq/KWQLineEdit.h:
        * kwq/KWQLineEdit.mm:
        (QLineEdit::baselinePosition):
        * kwq/KWQPushButton.h:
        * kwq/KWQPushButton.mm:
        (QPushButton::baselinePosition):
        * kwq/KWQRadioButton.h:
        * kwq/KWQRadioButton.mm:
        (QRadioButton::baselinePosition):
        * kwq/KWQWidget.h:
        * kwq/KWQWidget.mm:
        (QWidget::baselinePosition):
        (QWidget::setFrameGeometry):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:

2003-10-10  David Hyatt  <hyatt@apple.com>

	Make sure the i-beam cursor is only forced if you have a selection.

	Reviewed by John

	* khtml/khtmlview.cpp
	
2003-10-10  Ken Kocienda  <kocienda@apple.com>

        Reviewed by John

	Fix for this bug:

	<rdar://problem/3440703>: Textarea form controls do not respect disabled attribute

        * khtml/rendering/render_form.cpp:
        (RenderTextArea::updateFromElement): Check for disabled attribute.
        * kwq/KWQTextArea.h:
        * kwq/KWQTextArea.mm:
        (-[KWQTextArea setEnabled:]): Added. 
        (-[KWQTextArea isEnabled]): Added.
        (-[KWQTextArea drawRect:]): Draws a disabled-looking  bezel when disabled.
        (-[KWQTextAreaTextView becomeFirstResponder]): Return NO if disabled.
        (-[KWQTextAreaTextView mouseDown:]): Block events if disabled.
        (-[KWQTextAreaTextView keyDown:]): Ditto.
        (-[KWQTextAreaTextView keyUp:]): Ditto.
        (-[KWQTextAreaTextView setEnabled:]): Added. Pass value through to editable
	attribute on text view.
        (-[KWQTextAreaTextView isEnabled]): Added.
        (-[KWQTextAreaTextView drawRect:]): Set the text color to a disabled color
	when disabled.
        * kwq/KWQTextEdit.h:
        * kwq/KWQTextEdit.mm:
        (QTextEdit::isDisabled): Added.
        (QTextEdit::setDisabled): Added.

2003-10-10  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3449405 - REGRESSION: reproducible crash changing focus w/ button on page, e.g. on www.aa.com
	
	More fallout from the exception blocking.

        * kwq/KWQButton.mm:
        (QButton::focusPolicy): Don't return from exception block (caught
	by Darin).

2003-10-09  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3449280 -- REGRESSION: crash copying a selection that ends in a <br>

        * khtml/rendering/render_br.h: Add checkSelectionPointIgnoringContinuations.
        * khtml/rendering/render_br.cpp: (RenderBR::checkSelectionPointIgnoringContinuations):
        Override to never return an offset of 1. We can't use a character offset because the
        DOM doesn't know that we're implemented as a text object. So an offset of 1 turns into
        "after this element".

2003-10-09  Maciej Stachowiak  <mjs@apple.com>

        - fixed crash I just added.

        * kwq/KWQWidget.mm:
        (QWidget::setCursor): Move BLOCK_NS_EXCEPTIONS macros so
	you don't `break' out of the blocking code.

2003-10-09  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	More Cocoa exception blocking work.

        * kwq/KWQFrame.mm:
        (QFrame::setFrameStyle):
        * kwq/KWQLineEdit.mm:
        (QLineEdit::QLineEdit):
        (QLineEdit::~QLineEdit):
        (QLineEdit::setEchoMode):
        (QLineEdit::setFont):
        (QLineEdit::setText):
        (QLineEdit::text):
        (QLineEdit::isReadOnly):
        (QLineEdit::setReadOnly):
        (QLineEdit::maxLength):
        (QLineEdit::selectAll):
        (QLineEdit::edited):
        (QLineEdit::setEdited):
        (QLineEdit::sizeForCharacterWidth):
        (QLineEdit::baselinePosition):
        (QLineEdit::setAlignment):
        * kwq/KWQListBox.mm:
        (QListBox::QListBox):
        (QListBox::~QListBox):
        (QListBox::count):
        (QListBox::clear):
        (QListBox::setSelectionMode):
        (QListBox::insertItem):
        (QListBox::insertGroupLabel):
        (QListBox::endBatchInsert):
        (QListBox::setSelected):
        (QListBox::isSelected):
        (QListBox::setEnabled):
        (QListBox::sizeForNumberOfLines):
        (QListBox::focusPolicy):
        * kwq/KWQPushButton.mm:
        (QPushButton::QPushButton):
        (QPushButton::sizeHint):
        (QPushButton::baselinePosition):
        (QPushButton::dimensions):
        * kwq/KWQRadioButton.mm:
        (QRadioButton::QRadioButton):
        (QRadioButton::setChecked):
        (QRadioButton::isChecked):
        (QRadioButton::dimensions):
        * kwq/KWQScrollBar.mm:
        (-[KWQScrollBar initWithQScrollBar:]):
        (:m_valueChanged):
        (QScrollBar::~QScrollBar):
        (QScrollBar::setValue):
        (QScrollBar::setKnobProportion):
        (QScrollBar::scrollbarHit):
        * kwq/KWQScrollView.mm:
        (QScrollView::visibleWidth):
        (QScrollView::visibleHeight):
        (QScrollView::contentsWidth):
        (QScrollView::contentsHeight):
        (QScrollView::contentsX):
        (QScrollView::contentsY):
        (QScrollView::setContentsPos):
        (QScrollView::setVScrollBarMode):
        (QScrollView::setHScrollBarMode):
        (QScrollView::setScrollBarsMode):
        (QScrollView::vScrollBarMode):
        (QScrollView::hScrollBarMode):
        (QScrollView::hasVerticalScrollBar):
        (QScrollView::hasHorizontalScrollBar):
        (QScrollView::suppressScrollBars):
        (QScrollView::addChild):
        (QScrollView::removeChild):
        (QScrollView::resizeContents):
        (QScrollView::updateContents):
        (QScrollView::contentsToViewport):
        (QScrollView::viewportToContents):
        (QScrollView::setStaticBackground):
        (QScrollView::ensureVisible):
        (QScrollView::getDocumentView):
        * kwq/KWQTextEdit.mm:
        (QTextEdit::QTextEdit):
        (QTextEdit::setText):
        (QTextEdit::text):
        (QTextEdit::textWithHardLineBreaks):
        (QTextEdit::getCursorPosition):
        (QTextEdit::setCursorPosition):
        (QTextEdit::wordWrap):
        (QTextEdit::setWordWrap):
        (QTextEdit::isReadOnly):
        (QTextEdit::setReadOnly):
        (QTextEdit::selectAll):
        (QTextEdit::setFont):
        (QTextEdit::setAlignment):
        (QTextEdit::sizeWithColumnsAndRows):
        * kwq/KWQWidget.mm:
        (QWidget::QWidget):
        (QWidget::~QWidget):
        (QWidget::setActiveWindow):
        (QWidget::setEnabled):
        (QWidget::isEnabled):
        (QWidget::frameGeometry):
        (QWidget::hasFocus):
        (QWidget::setFocus):
        (QWidget::focusPolicy):
        (QWidget::isVisible):
        (QWidget::setCursor):
        (QWidget::cursor):
        (QWidget::setFrameGeometry):
        (QWidget::mapFromGlobal):
        (QWidget::setView):
        (QWidget::getOuterView):
        (QWidget::lockDrawingFocus):
        (QWidget::unlockDrawingFocus):
        (QWidget::disableFlushDrawing):
        (QWidget::enableFlushDrawing):
        (QWidget::setDrawingAlpha):
        (QWidget::paint):
        (QWidget::sendConsumedMouseUp):

2003-10-09  David Hyatt  <hyatt@apple.com>

	Stop printing extra spaces before list items.  Fixes ordered lists with list-style-position: inside.
	
        Reviewed by mjs

        * khtml/rendering/render_list.cpp:

2003-10-09  David Hyatt  <hyatt@apple.com>

	Make definition of kMin and kMax match the KHTML trunk.  Someone still needs to eliminate uses of QMIN
	and QMAX from the code.

        * kwq/KWQDef.h:
        (kMin):
        (kMax):

2003-10-09  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3333897>: should support navigator.plugins.refresh as a way to add a plugin without restarting Safari

        Reviewed by rjw.

        * khtml/ecma/kjs_navigator.cpp:
        (PluginBase::refresh): new
        (PluginsFunc::tryCall): call refresh
        * kwq/KWQKConfigBase.h:
        * kwq/KWQKConfigBase.mm:
        (RefreshPlugins): new
        * kwq/WebCoreViewFactory.h:

=== Safari-109 ===

2003-10-08  David Hyatt  <hyatt@apple.com>

	Fix for 3436723, the shrink-to-fit algorithm for positioned elements did not match
	the algorithm specified in section 10.3.7 of the CSS2.1 specification.  The min-width
	of the element was not being taken into account like it should have been.
	
        Reviewed by mjs

        * khtml/rendering/render_box.cpp:
        (RenderBox::calcAbsoluteHorizontal):

2003-10-08  David Hyatt  <hyatt@apple.com>

	Implement min/max width and min/max height support for replaced elements.
	
        Reviewed by ken

        * khtml/rendering/render_box.cpp:
        (RenderBox::calcReplacedWidth):
        (RenderBox::calcReplacedWidthUsing):
        (RenderBox::calcReplacedHeight):
        (RenderBox::calcReplacedHeightUsing):
        (RenderBox::availableHeight):
        (RenderBox::availableHeightUsing):
        * khtml/rendering/render_box.h:

2003-10-08  Maciej Stachowiak  <mjs@apple.com>

	Fix development build.
	
        * kwq/KWQExceptions.h: Correct assertion args.

2003-10-08  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	Start on blocking Cocoa exceptions when calling ObjC from C++ to
	avoid unreproducible crashes when this happens.

        * kwq/KWQExceptions.h: Added. Helper macros for exception blocking.
        * WebCore.pbproj/project.pbxproj: Add new header

	In all these files, block exceptions when calling ObjC from C++,
	or explain why not.
	
        * kwq/KWQAccObjectCache.mm:
        * kwq/KWQApplication.mm:
        * kwq/KWQButton.mm:
        (QButton::QButton):
        (QButton::~QButton):
        (QButton::setText):
        (QButton::text):
        (QButton::clicked):
        (QButton::simulateClick):
        (QButton::setFont):
        (QButton::focusPolicy):
        * kwq/KWQCheckBox.mm:
        (QCheckBox::QCheckBox):
        (QCheckBox::setChecked):
        (QCheckBox::isChecked):
        (QCheckBox::dimensions):
        * kwq/KWQColor.mm:
        * kwq/KWQComboBox.mm:
        (QComboBox::QComboBox):
        (QComboBox::~QComboBox):
        (QComboBox::insertItem):
        (QComboBox::sizeHint):
        (QComboBox::setCurrentItem):
        (QComboBox::updateCurrentItem):
        (QComboBox::setFont):
        (QComboBox::dimensions):
        * kwq/KWQCursor.mm:
        * kwq/KWQFile.mm:
        * kwq/KWQFileButton.mm:
        (KWQFileButton::KWQFileButton):
        (KWQFileButton::~KWQFileButton):
        (KWQFileButton::setFilename):
        (KWQFileButton::sizeForCharacterWidth):
        (KWQFileButton::frameGeometry):
        (KWQFileButton::setFrameGeometry):
        (KWQFileButton::baselinePosition):
        (KWQFileButton::filenameChanged):
        * kwq/KWQKCookieJar.mm:
        (KWQKCookieJar::cookie):
        (KWQKCookieJar::setCookie):
        (KWQKCookieJar::cookieEnabled):
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow):
        (KHTMLPartBrowserExtension::setIconURL):
        (KHTMLPartBrowserExtension::setTypedIconURL):
        * kwq/KWQKHistoryProvider.mm:
        (KParts::HistoryProvider::contains):
        * kwq/KWQKPartsBrowserInterface.mm:
        (KParts::BrowserInterface::callMethod):
        * kwq/KWQKStandardDirs.mm:
        * kwq/KWQKURL.mm:
        * kwq/KWQKWinModule.mm:
        (KWinModule::workArea):
        * kwq/KWQObject.mm:
        * kwq/KWQString.mm:
        (QString::getNSString):
        * kwq/KWQTimer.mm:
        * kwq/KWQWindowWidget.mm:

2003-10-07  David Hyatt  <hyatt@apple.com>

	Fix for link dragging regression in the titles of links.  More accessibility 
	improvements.
	
        Reviewed by darin

        * khtml/khtml_part.cpp:
        (KHTMLPart::text):
        * kwq/KWQAccObject.mm:
        (-[KWQAccObject role]):
        (-[KWQAccObject roleDescription]):
        (-[KWQAccObject helpText]):
        (-[KWQAccObject textUnderElement]):
        (-[KWQAccObject value]):
        (-[KWQAccObject title]):
        (-[KWQAccObject accessibilityIsIgnored]):
        (-[KWQAccObject accessibilityAttributeValue:]):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]):

2003-10-07  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

	Fix for these bugs:

	<rdar://problem/3443296>: REGRESSION: pop-up menu gets focus, but once it has 	
	focus doesn't work right
	<rdar://problem/3444873>: Select widgets that use list views do not take part in tab order
	<rdar://problem/3446306>: Text area form widgets do not accept DOM focus correctly
	<rdar://problem/3446323>: Using keyboard to work popup button select form 
	widget causes a crash

	The intention of this patch is to add keyboard navigation support for
	HTML form select widgets. This includes the two visual representations
	for these widgets: popup buttons and lists. Many keyboard, focus, and
	tabbing fixes are included in this work, as indicated below.

        * khtml/html/html_formimpl.cpp:
        (HTMLSelectElementImpl::defaultEventHandler): Added. Submit form when
	return or enter key is pressed when focused on a select widget.
        * khtml/html/html_formimpl.h: Make HTMLSelectElementImpl a friend class
	of HTMLInputElementImpl. This is done so that an HTMLSelectElementImpl
	can call the private method which simulates a form submit.
	Also add declaration of defaultEventHandler function.
        * kwq/KWQButton.h: Clean up focusPolicy declaration.
        * kwq/KWQComboBox.h: Add focusPolicy declaration.
        * kwq/KWQComboBox.mm:
        (QComboBox::focusPolicy): Added. Widget will focus if full keyboard
	access is on.
        (-[KWQPopUpButtonCell trackMouse:inRect:ofView:untilMouseUp:]): Now
	calls sendFakeEventsAfterWidgetTracking instead of 
	doFakeMouseUpAfterWidgetTracking now that name has changed.
        (-[KWQPopUpButton becomeFirstResponder]): Added. Needed for setting
	focus correctly.
        (-[KWQPopUpButton resignFirstResponder]): Ditto.
        (-[KWQPopUpButton nextKeyView]): Added. Makes tabbing work correctly
	for this widget.
        (-[KWQPopUpButton previousKeyView]): Ditto.
        (-[KWQPopUpButton nextValidKeyView]): Ditto.
        (-[KWQPopUpButton previousValidKeyView]): Ditto.
        * kwq/KWQKHTMLPart.h: Change name of doFakeMouseUpAfterWidgetTracking
	to sendFakeEventsAfterWidgetTracking now that it handles key events
	as well.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::sendFakeEventsAfterWidgetTracking): Name change as
	noted above. Also handles sending simulated key up events.
        * kwq/KWQLineEdit.h:
        (QLineEdit::checksDescendantsForFocus): Added. This is a big
	part of the fiz for <rdar://problem/3446306>.
        * kwq/KWQListBox.h:
        (QListBox::checksDescendantsForFocus): Ditto. Yes for this widget.
        * kwq/KWQListBox.mm:
        (QListBox::focusPolicy): Added. Widget will focus if full keyboard
        access is on.
        (-[KWQListBoxScrollView becomeFirstResponder]): Added. Needed for setting
        focus correctly. This sets the focus to its document view.
        (-[KWQTableView becomeFirstResponder]): Added. Needed for setting
        focus correctly.
        (-[KWQTableView resignFirstResponder]): Added. Needed for setting
        focus correctly.
        (-[KWQTableView nextKeyView]): Added. Makes tabbing work correctly
        for this widget.
        (-[KWQTableView previousKeyView]): Ditto.
        (-[KWQTableView nextValidKeyView]): Ditto.
        (-[KWQTableView previousValidKeyView]): Ditto.
        (-[KWQTableView _KWQ_setKeyboardFocusRingNeedsDisplay]): Added.
        * kwq/KWQTextArea.mm:
        (-[KWQTextAreaTextView becomeFirstResponder]): Other part of fix for
	<rdar://problem/3446306>. The recursion guards were bad and wrong.
	The checksDescendantsForFocus improvement prevents the erroneous
	recursion from happening.
        * kwq/KWQTextEdit.h:
        (QTextEdit::checksDescendantsForFocus): Added. Yes for this widget.
        * kwq/KWQWidget.h:
        (QWidget::checksDescendantsForFocus): Added. No by default.
        * kwq/KWQWidget.mm:
        (QWidget::hasFocus): Now uses checksDescendantsForFocus to perform
	proper checks for views that may have a subview which is first
	responder.

2003-10-07  David Hyatt  <hyatt@apple.com>

	Fix for 3363421, event handlers could be triggered for content outside an overflow:hidden
	area.  The layer checks that test for intersection/point containment need to only include
	layers with overhanging floats if the element is overflow:visible.

	Fix for 3366801, assignment to scrollLeft/Top of an overflow:hidden layer makes the layer
	disappear.  overflow:hidden blocks actually were never computing their scroll dimensions,
	and so had bogus answers for those values.

	Fix for 3366686, no reliable scrollHeight/Width reporting for overflow:hidden or
	overflow:visible elements.  The former was caused by the same bug as 3366801.  The
	latter was just me using the wrong method (clientWidth/Height instead of
	overflowWidth/Height).

	This patch also tightens the assignment to scrollLeft/Top to not do anything if you don't 
	have an overflow value other than visible.
	
        Reviewed by darin

        * khtml/ecma/kjs_dom.cpp:
        (DOMNode::putValue):
        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::layoutBlock):
        * khtml/rendering/render_flexbox.cpp:
        (khtml::RenderFlexibleBox::layoutBlock):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::RenderLayer):
        (RenderLayer::scrollToOffset):
        (RenderLayer::scrollWidth):
        (RenderLayer::scrollHeight):
        (RenderLayer::computeScrollDimensions):
        (RenderLayer::updateScrollInfoAfterLayout):
        (RenderLayer::intersectsDamageRect):
        (RenderLayer::containsPoint):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::scrollWidth):
        (RenderObject::scrollHeight):
        * khtml/rendering/render_object.h:

2003-10-07  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

        - fixed some exceptions I was seeing with my recent text change

        * khtml/khtml_part.cpp:
        (KHTMLPart::text): Return an empty string for a null range rather than raising an exception.
        (KHTMLPart::selection): Return a null range rather than raising an exception if there is
        no selection.

2003-10-07  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - removed code that mutates \n into a space so we can pass more W3C DOM Level 1 Core tests

        * khtml/rendering/bidi.cpp:
        (khtml::addRun): Treat \n as a space.
        (khtml::RenderBlock::computeHorizontalPositionsForLine): Treat \n as a space.
        (khtml::RenderBlock::findNextLineBreak): Treat \n outside <pre> as a space.
        Removed code that mutates the \n into a space.

        * khtml/rendering/render_text.cpp:
        (RenderText::trimmedMinMaxWidth): Treat \n outside <pre> as a space.
        (RenderText::calcMinMaxWidth): Treat \n outside <pre> as a space.
        Removed code that mutates the \n into a space.
        (RenderText::position): Detect a <br> with isBR instead of assuming a 1-character
        string with a \n in it is a <br>.

2003-10-06  David Hyatt  <hyatt@apple.com>

	Several fixes preparing for the incremental repainting patch to be enabled.

	(1) Make layers update their positions after layout instead of during layout or
	during painting.

	(2) Fix a regression from the overflow:hidden body quirk landing.  Make sure repaint()
	understands that quirk exists and avoids clipping when it shouldn't.

	(3) Fix a regression from the scrollbar improvements.  The vertical scrollbar repainted
	on every layout.

	(4) Make sure outside list bullets are repainted when a list item needs to repaint.
	
	(5) A whole bunch of INCREMENTAL_REPAINTING code that isn't turned on yet.
	
        Reviewed by kocienda

        * khtml/khtmlview.cpp:
        (KHTMLViewPrivate::KHTMLViewPrivate):
        (KHTMLViewPrivate::reset):
        (KHTMLView::resetScrollBars):
        (KHTMLView::needsFullRepaint):
        * khtml/khtmlview.h:
        * khtml/rendering/bidi.cpp:
        (khtml::RenderBlock::layoutInlineChildren):
        * khtml/rendering/render_block.cpp:
        (khtml::RenderBlock::layoutBlock):
        (khtml::RenderBlock::layoutBlockChildren):
        (khtml::RenderBlock::getAbsoluteRepaintRectIncludingFloats):
        (khtml::RenderBlock::repaintFloatingDescendants):
        (khtml::RenderBlock::repaintObjectsBeforeLayout):
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::computeAbsoluteRepaintRect):
        (RenderBox::repaintDuringLayoutIfMoved):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::layout):
        * khtml/rendering/render_canvas.h:
        (khtml::RenderCanvas::hasOverhangingFloats):
        * khtml/rendering/render_flexbox.cpp:
        (khtml::RenderFlexibleBox::layoutBlock):
        (khtml::RenderFlexibleBox::layoutHorizontalBox):
        (khtml::RenderFlexibleBox::layoutVerticalBox):
        (khtml::RenderFlexibleBox::placeChild):
        * khtml/rendering/render_flexbox.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::getAbsoluteRepaintRect):
        * khtml/rendering/render_image.cpp:
        (RenderImage::setPixmap):
        (RenderImage::layout):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::RenderLayer):
        (RenderLayer::computeRepaintRects):
        (RenderLayer::updateLayerPositions):
        (RenderLayer::updateLayerPosition):
        (RenderLayer::checkScrollbarsAfterLayout):
        (RenderLayer::paintLayer):
        (RenderLayer::calculateClipRects):
        (RenderLayer::calculateRects):
        * khtml/rendering/render_layer.h:
        (khtml::RenderLayer::relativePositionOffset):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::getAbsoluteRepaintRect):
        * khtml/rendering/render_list.h:
        (khtml::RenderListMarker::listImage):
        * khtml/rendering/render_object.cpp:
        (RenderObject::repaint):
        (RenderObject::repaintRectangle):
        (RenderObject::repaintAfterLayoutIfNeeded):
        (RenderObject::repaintDuringLayoutIfMoved):
        (RenderObject::repaintFloatingDescendants):
        (RenderObject::checkForRepaintDuringLayout):
        (RenderObject::repaintObjectsBeforeLayout):
        (RenderObject::getAbsoluteRepaintRectIncludingFloats):
        (RenderObject::container):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_table.cpp:
        (RenderTable::layout):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::passWidgetMouseDownEventToWidget):

2003-10-06  Darin Adler  <darin@apple.com>

        Reviewed by Ken.
        
        - preparation for the upcoming whitespace patch; refactored some of the code that extracts text

        * khtml/khtml_part.h: Added text() member function.
        * khtml/khtml_part.cpp:
        (KHTMLPart::text): Added. Refactored from selectedText; takes a DOM::Range as a parameter.
        Also added code to change newlines to spaces when extracting text from the DOM.
        (KHTMLPart::selectedText): Now calls text().
        (KHTMLPart::selection): Removed stray declaration.

        * kwq/KWQAccObject.mm: (-[KWQAccObject value]): Changed to call KHTMLPart::text.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge elementAtPoint:]): Changed to call KHTMLPart::text
        instead of doing it ourselves.
        
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::attributedString): Added code to change change '\n'
        newlines to spaces when extracting text from the DOM.

2003-10-05  Maciej Stachowiak  <mjs@apple.com>

	Reviewed by Ken.

	- fixed 3444255 - REGRESSION: www.aa.com crashes (innerHTML)

        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::createContextualFragment): Keep the fragment
	ref'd since the tokenizer will ref and deref it. Then turn
	TreeShared's evil against itself to get the fragment back in the
	floating 0-ref state.
        * khtml/html/html_elementimpl.h: Remove stray whitespace.
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::KHTMLParser): Initialize current to 0 in the other
	constructor too.

2003-10-06  Darin Adler  <darin@apple.com>

        * khtml/ecma/kjs_css.lut.h:
        * khtml/ecma/kjs_dom.lut.h:
        * khtml/ecma/kjs_events.lut.h:
        * khtml/ecma/kjs_html.lut.h:
        * khtml/ecma/kjs_navigator.lut.h:
        * khtml/ecma/kjs_range.lut.h:
        * khtml/ecma/kjs_traversal.lut.h:
        * khtml/ecma/kjs_views.lut.h:
        * khtml/ecma/kjs_window.lut.h:
        Regenerated, without stray semicolon.

2003-10-03  Darin Adler  <darin@apple.com>

        - updated layout tests for recent WebTextRenderer changes

        * layout-tests/apple-only/base/www.cnn.com/index-expected.txt:
        * layout-tests/apple-only/base/www.sun.com/index-expected.txt:
        * layout-tests/css1/font_properties/font_weight-expected.txt:

2003-10-03  Chris Blumenberg  <cblu@apple.com>

        Removed eastCursor.tiff because it was added by mistake.

        * Resources/eastCursor.tiff: Removed.
        * WebCore.pbproj/project.pbxproj:

2003-10-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.
	
	- fixed 3398420 - crash when creating a new document.body object in <body>

	Also included David Faure's improvement to throw an exception.
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::setBody): Don't remove the body when null is passed in,
	as this means type error at the higher level, so throw an exception.
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::KHTMLParser): Initialize current to 0.
        (KHTMLParser::setCurrent): Ref new current and deref old; we need to
	keep it ref'd because script execution could drop the current node on the
	floor.
	(KHTMLParser::reset): Use setCurrent.
        (KHTMLParser::insertNode): Likewise.
        (KHTMLParser::reopenResidualStyleTags): Likewise.
        (KHTMLParser::popOneBlock): Likewise.
        (KHTMLParser::finished): Likewise.
        * khtml/html/htmlparser.h: Prototype setCurrent.

2003-10-03  Chris Blumenberg  <cblu@apple.com>

	Ran compress-tiffs on new cursor images.

        * Resources/eastCursor.tiff:
        * Resources/eastResizeCursor.tiff:
        * Resources/helpCursor.tiff:
        * Resources/moveCursor.tiff:
        * Resources/northEastResizeCursor.tiff:
        * Resources/northResizeCursor.tiff:
        * Resources/northWestResizeCursor.tiff:
        * Resources/southEastResizeCursor.tiff:
        * Resources/southResizeCursor.tiff:
        * Resources/southWestResizeCursor.tiff:
        * Resources/waitCursor.tiff:
        * Resources/westResizeCursor.tiff:

2003-10-03  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin, with much help from Maciej and Hyatt

        Fix for these bugs:

        <rdar://problem/3441321>: Form buttons do not respond to key events when focused
        <rdar://problem/3441060>: Form buttons do not scroll to view when focused

        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::simulateMouseClickForEvent): Added helper to simulate
        mouse clicks in elements. Used to trigger button actions in response to
        keyboard events.
        (HTMLInputElementImpl::defaultEventHandler): Improved handler to process
        key press events for radio, checkbox, image, reset, and submit buttons.
        * khtml/html/html_formimpl.h: Added simulateMouseClickForEvent function.
        * khtml/xml/dom2_eventsimpl.h:
        (DOM::EventImpl::isKeyboardEvent): Added type check virtual function.
        (DOM::KeyEventImpl::isKeyboardEvent): Ditto.
        * kwq/KWQButton.h:
        * kwq/KWQButton.mm:
        (-[KWQButton simulateClick]): New method. This makes AppKit do a 
	button click programatically for button types. For <input type=image>, 
	we just simulate a the click in the DOM since there is no real "clickable"
	AppKit widget.
        (-[KWQButton becomeFirstResponder]): Fixes the button scroll to visible when
        focused issue.
        (-[KWQButton resignFirstResponder]): Correctly give up focus when user clicks
        into the page body when a button has the focus.
        (QButton::simulateClick): QWidget bridge to the KWQButton simulateClick
	method.

2003-10-03  David Hyatt  <hyatt@apple.com>

	Removing redundant layouts and adding a few !needsLayout and !normalChildNeedsLayout
	checks to prevent extra layouts.

	Also, fixing the recalcStyle changed() bottleneck to go through view's layout and to
	not do a full repaint.  The layout method will then do the right thing (full repaint
	without INCREMENTAL_REPAINTING turned on, the precise repainting needed otherwise).
	
        Reviewed by darin

        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::parseAttribute):
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::appendChildNode):
        (RenderContainer::insertChildNode):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):

2003-10-02  David Hyatt  <hyatt@apple.com>

	Remove the speed hit from using the UC break locators by not using them when
	checking if the current character is &nbsp; and by also using a global text
	break locator object.
	
        Reviewed by rjw

        * khtml/rendering/break_lines.cpp:

=== Safari-108 ===

2003-10-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3398622 - Crash when JavaScript changes display style

	This was a problem with one of the many global variables in
	bidi.cpp, last, having a stale value from the last layout that
	pointed to a dead node. I fixed this by refactoring the code to
	put most of the global variables in a struct allocated on the
	stack, and pass around a reference to the struct. Seems much
	cleaner (if somewhat wordier) this way. There are still more
	global variables to kill here.
	
        * khtml/rendering/bidi.cpp:
        (khtml::BidiIterator::BidiIterator):
        (khtml::BidiStatus::BidiStatus):
        (khtml::BidiInfo::BidiInfo):
        (khtml::Bidinext):
        (khtml::first):
        (khtml::BidiIterator::increment):
        (khtml::checkMidpoints):
        (khtml::appendRunsForObject):
        (khtml::appendRun):
        (khtml::embed):
        (khtml::RenderBlock::computeHorizontalPositionsForLine):
        (khtml::RenderBlock::bidiReorderLine):
        (khtml::buildCompactRuns):
        (khtml::RenderBlock::layoutInlineChildren):
        (khtml::RenderBlock::findNextLineBreak):
        * khtml/rendering/bidi.h:
        * khtml/rendering/render_block.h:

2003-10-02  David Hyatt  <hyatt@apple.com>

	Work on exposing elements to the Acc API.  This patch gets us to the point where text
	under the mouse is voiced.
	
        Reviewed by darin

        * kwq/KWQAccObject.h:
        * kwq/KWQAccObject.mm:
        (-[KWQAccObject initWithRenderer:]):
        (-[KWQAccObject parentObject]):
        (-[KWQAccObject parentObjectUnignored]):
        (-[KWQAccObject addChildrenToArray:]):
        (-[KWQAccObject role]):
        (-[KWQAccObject roleDescription]):
        (-[KWQAccObject value]):
        (-[KWQAccObject title]):
        (-[KWQAccObject position]):
        (-[KWQAccObject size]):
        (-[KWQAccObject accessibilityIsIgnored]):
        (-[KWQAccObject accessibilityAttributeNames]):
        (-[KWQAccObject accessibilityActionNames]):
        (-[KWQAccObject accessibilityIsAttributeSettable:]):
        (-[KWQAccObject accessibilityAttributeValue:]):
        (-[KWQAccObject accessibilityHitTest:]):
        * kwq/KWQAccObjectCache.mm:
        (KWQAccObjectCache::accObject):
        (KWQAccObjectCache::setAccObject):
        (KWQAccObjectCache::removeAccObject):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge accessibilityTree]):

2003-10-02  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        * kwq/KWQRenderTreeDebug.cpp: (quoteAndEscapeNonPrintables): Since our text rendering renders
        non-breaking spaces the same as spaces, dump them as spaces. Do the same with newlines since
        I am about to change our text rendering to do the same with newlines.

        * layout-tests: Updated test results.

2003-10-01  David Hyatt  <hyatt@apple.com>

	Avoid doing extra work when tearing down the document by checking to see if
	we're in the destruction of the document.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::removeChildNode):

2003-10-01  Richard Williamson   <rjw@apple.com>

	Fixed 3438441.  Pass extra info up to WebKit about load type, specifically is a load is triggered by JS running in an onLoad handler.

        Reviewed by Ken.

        * khtml/ecma/kjs_binding.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURL):
        (KWQKHTMLPart::openURLRequest):
        (KWQKHTMLPart::submitForm):
        (KWQKHTMLPart::urlSelected):
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow):

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge saveDocumentToPageCache]):
	Nothing changed.  Tweaked spacing.

2003-10-01  Chris Blumenberg  <cblu@apple.com>

	<rdar://problem/2942589>: CSS cursors are not implemented

        Reviewed by Dave.

        * Resources/eastCursor.tiff: Added.
        * Resources/eastResizeCursor.tiff: Added.
        * Resources/helpCursor.tiff: Added.
        * Resources/moveCursor.tiff: Added.
        * Resources/northEastResizeCursor.tiff: Added.
        * Resources/northResizeCursor.tiff: Added.
        * Resources/northWestResizeCursor.tiff: Added.
        * Resources/southEastResizeCursor.tiff: Added.
        * Resources/southResizeCursor.tiff: Added.
        * Resources/southWestResizeCursor.tiff: Added.
        * Resources/waitCursor.tiff: Added.
        * Resources/westResizeCursor.tiff: Added.
        * WebCore.pbproj/project.pbxproj:
        * khtml/css/cssparser.cpp: special-case the hand cursor to mean pointer
        (CSSParser::parseValue):
        * khtml/css/cssvalues.c: generated changes
        (hash_val):
        (findValue):
        * khtml/css/cssvalues.h: generated changes
        * khtml/css/cssvalues.in: removed the progress cursor from the list because it was messing up the mapping
        * khtml/khtmlview.cpp: call new cursor methods
        * kwq/KWQKCursor.h:
        * kwq/KWQKCursor.mm:
        (+[NSCursor _WebCore_cursorWithName:hotSpot:]): new, loads and caches cursors
        (KCursor::crossCursor): get the AppKit cross hair cursor
        (KCursor::handCursor): call _WebCore_cursorWithName:hotSpot:
        (KCursor::sizeAllCursor): ditto
        (KCursor::waitCursor): ditto
        (KCursor::whatsThisCursor): ditto
        (KCursor::eastResizeCursor): new, call _WebCore_cursorWithName:hotSpot:
        (KCursor::northResizeCursor): ditto
        (KCursor::northEastResizeCursor): ditto
        (KCursor::northWestResizeCursor): ditto
        (KCursor::southResizeCursor): ditto
        (KCursor::southEastResizeCursor): ditto
        (KCursor::southWestResizeCursor): ditto
        (KCursor::westResizeCursor): ditto

2003-10-01  David Hyatt  <hyatt@apple.com>

	Clean up our detach model so that you can always get to a document, even for
	anonymous content.  Also stubbing out and adding the accessibility objects.
	
        Reviewed by darin, mjs, john

        * ChangeLog:
        * WebCore.pbproj/project.pbxproj:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::detach):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::RenderCanvas):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::detach):
        (RenderContainer::addChild):
        (RenderContainer::updatePseudoChild):
        (RenderContainer::insertChildNode):
        (RenderContainer::removeLeftoverAnonymousBoxes):
        * khtml/rendering/render_container.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::createAnonymousFlow):
        (RenderFlow::deleteLineBoxes):
        (RenderFlow::detach):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_form.cpp:
        (RenderTextArea::detach):
        * khtml/rendering/render_form.h:
        * khtml/rendering/render_image.cpp:
        (RenderImage::RenderImage):
        (RenderImage::detach):
        * khtml/rendering/render_image.h:
        * khtml/rendering/render_inline.cpp:
        (RenderInline::addChildToFlow):
        (RenderInline::splitFlow):
        (RenderInline::renderName):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::setStyle):
        (RenderListItem::detach):
        (RenderListItem::updateMarkerLocation):
        (RenderListMarker::RenderListMarker):
        * khtml/rendering/render_list.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::RenderObject):
        (RenderObject::information):
        (RenderObject::dump):
        (RenderObject::createAnonymousBlock):
        (RenderObject::remove):
        (RenderObject::detach):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::detach):
        * khtml/rendering/render_replaced.h:
        * khtml/rendering/render_table.cpp:
        (RenderTable::addChild):
        (RenderTableSection::detach):
        (RenderTableSection::addChild):
        (RenderTableRow::detach):
        (RenderTableRow::addChild):
        (RenderTableCell::detach):
        * khtml/rendering/render_table.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::detach):
        (RenderText::deleteRuns):
        * khtml/rendering/render_text.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::DocumentImpl):
        (DocumentImpl::~DocumentImpl):
        (DocumentImpl::detach):
        (DocumentImpl::getOrCreateAccObjectCache):
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::detach):
        * kwq/KWQAccObject.h: Added.
        * kwq/KWQAccObject.mm: Added.
        (-[KWQAccObject x]):
        (-[KWQAccObject y]):
        (-[KWQAccObject width]):
        (-[KWQAccObject height]):
        (-[KWQAccObject detached]):
        (-[KWQAccObject detach]):
        (-[KWQAccObject data]):
        (-[KWQAccObject setData:]):
        (-[KWQAccObject firstChild]):
        (-[KWQAccObject lastChild]):
        (-[KWQAccObject previousSibling]):
        (-[KWQAccObject nextSibling]):
        (-[KWQAccObject parentObject]):
        * kwq/KWQAccObjectCache.h: Added.
        * kwq/KWQAccObjectCache.mm: Added.
        (KWQAccObjectCache::KWQAccObjectCache):
        (KWQAccObjectCache::~KWQAccObjectCache):
        (KWQAccObjectCache::accObject):
        (KWQAccObjectCache::setAccObject):
        (KWQAccObjectCache::removeAccObject):
        (KWQAccObjectCache::detach):
        * layout-tests/css1/pseudo/firstletter-expected.txt:
        * layout-tests/css1/pseudo/multiple_pseudo_elements-expected.txt:
        * layout-tests/fast/css-generated-content/002-expected.txt:
        * layout-tests/fast/css-generated-content/004-expected.txt:
        * layout-tests/fast/css-generated-content/005-expected.txt:
        * layout-tests/fast/css-generated-content/006-expected.txt:
        * layout-tests/fast/selectors/039-expected.txt:
        * layout-tests/fast/selectors/039b-expected.txt:
        * layout-tests/fast/selectors/041-expected.txt:
        * layout-tests/fast/selectors/042-expected.txt:
        * layout-tests/fast/selectors/166a-expected.txt:
        * layout-tests/fast/selectors/168-expected.txt:
        * layout-tests/fast/selectors/168a-expected.txt:
        * layout-tests/fast/selectors/169-expected.txt:
        * layout-tests/fast/selectors/169a-expected.txt:
        * layout-tests/fast/text/firstline/002-expected.txt:
        * layout-tests/fast/text/firstline/003-expected.txt:

2003-10-01  David Hyatt  <hyatt@apple.com>

	Fix for 3163840, the images are mispositioned on the DHTML menus at the top of
	www.aa.com (and in many other places).  We needed to support returning the right
	value from hasProperty and tryGet for 'cssFloat'.  

	This patch also adds support for getting/setting our custom CSS properties (-khtml-*)
	and just factors the code a bit better for all the special values.
	
        Reviewed by darin

        * khtml/ecma/kjs_css.cpp:
        (cssPropertyName):
        (DOMCSSStyleDeclaration::hasProperty):
        (DOMCSSStyleDeclaration::tryGet):
        (DOMCSSStyleDeclaration::tryPut):

2003-10-01  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3437309 -- REGRESSION (100-107): Javascript menu doesn't work at www.aa.com

        * khtml/xml/dom_elementimpl.cpp: (ElementImpl::removeAttribute): Restored the old behavior
        for removeAttribute and removeAttributeNS; these don't give NOT_FOUND_ERR. But keep the
        NOT_FOUND_ERR for removeAttributeNode and removedNamedItem.

2003-10-01  Ken Kocienda  <kocienda@apple.com>

        Reviewed by me

        * kwq/KWQWidget.mm:
        (QWidget::focusPolicy): Improved comment.

2003-10-01  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Maciej

	Fix for these bugs:

	<rdar://problem/3439736>: WebCore form button widgets do not accept focus
	<rdar://problem/3440770>: WebCore form button widgets do not take part in tabbing order

        * kwq/KWQButton.h: Add focusPolicy function declaration.
        * kwq/KWQButton.mm: 
        (-[KWQButton nextKeyView]): Add tabbing support for buttons.
        (-[KWQButton previousKeyView]): Ditto
        (-[KWQButton nextValidKeyView]): Ditto
        (-[KWQButton previousValidKeyView]): Ditto
        (QButton::focusPolicy): Add focusPolicy implementation. This calls through
        to the recently-added accessor for full keyboard access to help in the
        determination for focus policy. For now, full keyboard access must be
        turned on for buttons to receive focus.
        * kwq/KWQTextEdit.h: Remove focusPolicy specialization from this class. The
	implementation in QWidget now serves this class well.
        * kwq/KWQTextEdit.mm: Ditto
        * kwq/KWQWidget.h: Added isEnabled function. Small, unrelated cleanup to 
	move the no-implementation setFocusPolicy() and setFocusProxy() functions
	fully into the header file.
        * kwq/KWQWidget.mm:
        (QWidget::isEnabled): Added. Calls through to the Cocoa view to retrieve
	this information.
        (QWidget::focusPolicy): Much improved focus policy function is now more
	general in stipulating the conditions for focus policy, and will work for
	more widgets.

2003-10-01  David Hyatt  <hyatt@apple.com>

	Fix for 3440804, broken scrollbars in downloads window.  Make Auto be the default
	value in the enum, so that all scrollviews will be automatically initialized to be
	auto.

	Reviewed by cblu

        * kwq/KWQScrollView.h:
        * kwq/WebCoreFrameView.h:

2003-09-30  Ken Kocienda  <kocienda@apple.com>

        Reviewed by me

        * WebCore.pbproj/project.pbxproj: Made WebCoreKeyboardAccess.h a private header.

2003-09-30  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Maciej
        
        Fix for this bug:
        
        <rdar://problem/3439688>: WebKit needs to retrieve full keyboard access preference
        
        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQKHTMLPart.h: Declare keyboardUIMode accessor.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::keyboardUIMode): Implement keyboardUIMode accessor (calls through the bridge).
        * kwq/WebCoreBridge.h: Declare the bridge accessor.
        * kwq/WebCoreKeyboardAccess.h: Added. Header defines keyboard UI mode constants.
        
2003-09-30  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	- fixed 3375281 - Keyboard event handlers not fired if focus not in form field
	- fixed 3242927 - KeyPressed Event in Javascript don't work
	- fixed 3375353 - keyboard event.target not updated when blurring from form items
	- fixed 3183754 - returning false from key press handlers does not prevent typing or form submission
	
        * khtml/xml/dom_nodeimpl.cpp:
	(NodeImpl::dispatchKeyEvent): Force false when defaultHandled instead of
	based on a weird rule appropriate for KDE but not for us.
        * kwq/KWQKHTMLPart.mm:
	(KWQKHTMLPart::keyEvent): If there's no focus node, give the event
	to the body element instead of giving up. Also, reverse
	expectedsense of return value dispatchKeyEvent, since it returns
	true if it *didn't* swallow the event. And finally, let the key press
	event as well as the key down event for the initial NSKeyDown block
	default handling.
	* kwq/KWQListBox.mm:
        (-[KWQTableView keyDown:]): Respect return value from interceptKeyEvent:
        (-[KWQTableView keyUp:]): ditto
        * kwq/KWQTextArea.mm:
        (-[KWQTextAreaTextView keyDown:]): ditto
        (-[KWQTextAreaTextView keyUp:]): ditto
        * kwq/KWQTextField.mm:
        (-[KWQTextField textView:shouldHandleEvent:]): ditto

2003-09-30  David Hyatt  <hyatt@apple.com>

	Improvements to layout transitions and scrollbar appearance/disappearance.  
	Also implementing a fix for 3264346, overflow applied to body should apply to
	the document's scrollers.
	
        Reviewed by darin

        * khtml/html/html_baseimpl.cpp:
        (HTMLFrameElementImpl::parseAttribute):
        * khtml/khtmlview.cpp:
        (KHTMLView::KHTMLView):
        (KHTMLView::~KHTMLView):
        (KHTMLView::resetScrollBars):
        (KHTMLView::clear):
        (KHTMLView::initScrollBars):
        (KHTMLView::applyBodyScrollQuirk):
        (KHTMLView::inLayout):
        * khtml/khtmlview.h:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::layout):
        * khtml/rendering/render_form.cpp:
        (TextAreaWidget::TextAreaWidget):
        * khtml/rendering/render_frames.cpp:
        (RenderFrame::slotViewCleared):
        (RenderPartObject::slotViewCleared):
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::calcMinMaxWidth):
        * khtml/rendering/render_object.cpp:
        (RenderObject::repaint):
        (RenderObject::repaintRectangle):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::setInPageCache):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::createPart):
        * kwq/KWQRenderTreeDebug.cpp:
        (write):
        (externalRepresentation):
        * kwq/KWQScrollView.h:
        * kwq/KWQScrollView.mm:
        (QScrollView::setVScrollBarMode):
        (QScrollView::setHScrollBarMode):
        (QScrollView::setScrollBarsMode):
        (QScrollView::vScrollBarMode):
        (QScrollView::hScrollBarMode):
        (QScrollView::hasVerticalScrollBar):
        (QScrollView::hasHorizontalScrollBar):
        (QScrollView::suppressScrollBars):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge installInFrame:]):
        * kwq/WebCoreFrameView.h:

2003-09-30  David Hyatt  <hyatt@apple.com>

	Fix for 3437260, nil deref of the render style because it hasn't been set yet.
	Fallout from my incremental repainting landing.
	
        Reviewed by darin

        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::setQWidget):

2003-09-29  David Hyatt  <hyatt@apple.com>

	Fix for 3438479, tables expand on every layout when a cell has percentage height
	children.
	
        Reviewed by darin

        * khtml/rendering/render_table.cpp:
        (RenderTableSection::calcRowHeight):
        (RenderTableRow::layout):

2003-09-29  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3332460>: nil-deref in khtml::RenderWidget::eventFilter with onchange handler

        Reviewed by darin.

        * kwq/KWQTextField.mm:
        (-[KWQTextField controlTextDidEndEditing:]): call setHasFocus:NO last so we have the widget that lets us get to the bridge and lets us call controlTextDidEndEditing

2003-09-29  David Hyatt  <hyatt@apple.com>

	Fix for 3425053, text past the bottom of a positioned table doesn't repaint.
	3426847 is the same bug.  Both are fixed by ensuring that calcHeight doesn't actually
	do anything other than margin computation and position determination for positioned
	elements.  In reality, for weird edge cases like implying the height via explicit top and
	bottom properties, we'll still be wrong.
	
        Reviewed by darin

        * ChangeLog:
        * khtml/rendering/render_table.cpp:
        (RenderTable::layout):

2003-09-29  David Hyatt  <hyatt@apple.com>

	Make sure that timeouts updateRendering after they execute the scheduled timer
	action.  

	Also fixing 3429455, maxwidth of pres miscomputed when two blank lines occur at
	the end of a pre text run.
	
        Reviewed by darin, mjs (setTimeout fix), darin (pre fix)

        * khtml/ecma/kjs_window.cpp:
        (ScheduledAction::execute):
        * khtml/rendering/render_text.cpp:
        (RenderText::trimmedMinMaxWidth):
        (RenderText::calcMinMaxWidth):

2003-09-29  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3437292 -- Safari uses wrong characters for &and; and &or; entities

        * khtml/html/kentities.gperf: Corrected values for &and; and &or; entities.
        Checked all the rest against a list on the W3C site, and those are the only two that were wrong.
        * khtml/html/kentities.c: Regnenerated.

2003-09-26  Ken Kocienda  <kocienda@apple.com>

        Reviewed by John

	Fix for this bug:

	<rdar://problem/3435532>: REGRESSION: tabbing to textareas causes infinite recursion

	Add recursion guards to the becomeFirstResponder method, otherwise calling
	eventFilter with a FocusIn event will cause the infinite recursion
	described in the bug.

        * kwq/KWQTextArea.mm:
        (-[KWQTextAreaTextView becomeFirstResponder]):

2003-09-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

        * khtml/ecma/kjs_window.cpp:
        (Window::installTimeout): Variant that takes a function and args.
	(WindowFunc::tryCall): If the argument is a function, call the
	function variant of installTimeout instead of pointlessly passing
	the string. Also, correctly implement the code to pass extra args
	along.
        * khtml/ecma/kjs_window.h:

2003-09-25  Maciej Stachowiak  <mjs@apple.com>

	Roll out build system change since it did not actually work. :-(
	
        * WebCore.pbproj/project.pbxproj:

2003-09-25  David Hyatt  <hyatt@apple.com>

	Landing the new repainting code.  This code eliminates many redundant layouts, makes
	layout scheduling work properly when called from WebKit, cleans up relpositioned inlines
	that act as containing blocks for absolute positioned children, and eliminates the
	repaint timer.
	
        Reviewed by kocienda

        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/khtmlview.cpp:
        (KHTMLView::KHTMLView):
        * khtml/khtmlview.h:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::setPixmap):
        (RenderBox::getAbsoluteRepaintRect):
        (RenderBox::computeAbsoluteRepaintRect):
        (RenderBox::repaintIfMoved):
        (RenderBox::calcAbsoluteHorizontal):
        (RenderBox::calcAbsoluteVertical):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::layout):
        (RenderCanvas::repaintViewRectangle):
        (RenderCanvas::getAbsoluteRepaintRect):
        (RenderCanvas::computeAbsoluteRepaintRect):
        * khtml/rendering/render_canvas.h:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        (RenderContainer::removeChildNode):
        (RenderContainer::removeChild):
        (RenderContainer::appendChildNode):
        (RenderContainer::insertChildNode):
        * khtml/rendering/render_flexbox.cpp:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::getAbsoluteRepaintRect):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_image.cpp:
        (RenderImage::setPixmap):
        (RenderImage::layout):
        * khtml/rendering/render_inline.cpp:
        (RenderInline::addChildToFlow):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::convertToLayerCoords):
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::setPixmap):
        * khtml/rendering/render_object.cpp:
        (RenderObject::RenderObject):
        (RenderObject::setNeedsLayout):
        (RenderObject::setChildNeedsLayout):
        (RenderObject::markContainingBlocksForLayout):
        (RenderObject::containingBlock):
        (RenderObject::repaint):
        (RenderObject::repaintRectangle):
        (RenderObject::repaintAfterLayoutIfNeeded):
        (RenderObject::repaintIfMoved):
        (RenderObject::repaintPositionedAndFloatingDescendants):
        (RenderObject::getAbsoluteRepaintRect):
        (RenderObject::getAbsoluteRepaintRectIncludingDescendants):
        (RenderObject::computeAbsoluteRepaintRect):
        (RenderObject::setStyle):
        (RenderObject::container):
        (RenderObject::detach):
        (RenderObject::scheduleRelayout):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_style.cpp:
        (RenderStyle::diff):
        * khtml/rendering/render_table.cpp:
        (RenderTable::layout):
        (RenderTableRow::getAbsoluteRepaintRect):
        (RenderTableCell::computeAbsoluteRepaintRect):
        * khtml/rendering/render_table.h:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeBaseImpl::insertBefore):
        (NodeBaseImpl::replaceChild):
        (NodeBaseImpl::appendChild):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::clearTimers):
        * kwq/KWQRenderTreeDebug.cpp:
        (write):
        (externalRepresentation):
        * kwq/KWQRenderTreeDebug.h:

2003-09-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

        * WebCore.pbproj/project.pbxproj: Don't hack install name. Instead
	of embedding into Safari, embed into WebKit as sub-umbrella.

=== Safari-107 ===

2003-09-25  Darin Adler  <darin@apple.com>

        - rolled out change to fix 3390850 because it caused a performance regression

        * khtml/misc/decoder.cpp: (Decoder::decode): Rolled out change.

2003-09-25  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Dave

	Name change: TextRun is now InlineTextBox. Some related names
	have been changed as well. There should be no change in
	behavior as a result of this patch.

        * khtml/khtml_part.cpp:
        (KHTMLPart::selectedText):
        (firstRunAt):
        (lastRunAt):
        (startAndEndLineNodesIncludingNode):
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::paintLineBoxDecorations):
        * khtml/rendering/render_line.cpp:
        (InlineFlowBox::placeBoxesHorizontally):
        (InlineFlowBox::placeBoxesVertically):
        * khtml/rendering/render_line.h:
        * khtml/rendering/render_text.cpp:
        (InlineTextBox::detach):
        (throw):
        (InlineTextBox::operator delete):
        (InlineTextBox::paintSelection):
        (InlineTextBox::paintDecoration):
        (InlineTextBox::checkSelectionPoint):
        (InlineTextBoxArray::InlineTextBoxArray):
        (InlineTextBoxArray::compareItems):
        (InlineTextBoxArray::findFirstMatching):
        (RenderText::deleteRuns):
        (RenderText::findNextInlineTextBox):
        (RenderText::nodeAtPoint):
        (RenderText::checkSelectionPointIgnoringContinuations):
        (RenderText::cursorPos):
        (RenderText::posOfChar):
        (RenderText::paintObject):
        (RenderText::createInlineBox):
        (RenderText::position):
        (RenderText::width):
        * khtml/rendering/render_text.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):
        * kwq/KWQRenderTreeDebug.cpp:
        (writeTextRun):
        (write):

2003-09-25  Darin Adler  <darin@apple.com>

        Added a new layout test.

        * layout-tests/fast/forms/form-element-geometry-expected.txt: Added.
        * layout-tests/fast/forms/form-element-geometry.html: Added.

2003-09-24  Darin Adler  <darin@apple.com>

        * layout-tests/fast/table/003-expected.txt: Updated for textarea width change.

2003-09-24  David Hyatt  <hyatt@apple.com>

	Fix for 3429646, <img src="blah"<img src="foo"> should show up as two images.
	
        Reviewed by darin

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::handleResidualStyleCloseTagAcrossBlocks):
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::parseTag):

2003-09-24  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed a recent regression, and ...
        - fixed 3386544 -- ARCH: <object>s don't support transclusion like <iframe>s do

        * khtml/khtml_part.cpp: (KHTMLPart::childFrame): Added back a cast I should
        not have removed to fix the function.

2003-09-24  David Hyatt  <hyatt@apple.com>

	Fix for 3430612, crash on about:blank in updateHoverActiveState.  Just missing
	a null-check.  Also remove a hover optimization that was bogus.
	
        Reviewed by darin

        * khtml/rendering/render_layer.cpp:
        (RenderLayer::updateHoverActiveState):

2003-09-24  Richard Williamson   <rjw@apple.com>

	Fixed 3420736.  Clear renderer caches when get an ATS font changed notification.  This fix may be moot depending on progress toward fixing 2695906.

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (+[WebCoreBridge updateAllViews]):

2003-09-24  Darin Adler  <darin@apple.com>

        - a new test for JavaScript date parsing

        * layout-tests/fast/js/date-parse-test-expected.txt: Added.
        * layout-tests/fast/js/date-parse-test.html: Added.

2003-09-24  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed ownerElement for documents in HTML objects (helpful for some work Dave is doing)

        * khtml/khtml_part.h: Change name of frame function to childFrame for clarity.
        * khtml/khtml_part.cpp:
        (KHTMLPart::slotChildStarted): Call the frame function by its new name, childFrame.
        (KHTMLPart::slotChildCompleted): Ditto.
        (KHTMLPart::slotChildURLRequest): Ditto.
        (KHTMLPart::childFrame): Change name from frame to childFrame for clarity, and make it work
        for parts inside HTML objects, not just normal frames and iframes. The change in behavior is
        the actual fix. Note that for the three callers above, it's an error to call this when the
        result would be 0, so there's no harm in doing the extra search of HTML objects in those cases.

        * khtml/xml/dom_docimpl.cpp: (DocumentImpl::ownerElement): Call the frame function by its new
        name, childFrame. This is the caller that will benefit most from the change in behavior.

        * kwq/KWQKHTMLPart.h: Remove childFrameForPart function, which is superseded by the
        childFrame function now.
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::nextKeyViewInFrameHierarchy): Use childFrame instead
        of childFrameForPart.

2003-09-23  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3390850 -- Shift_JIS in meta tag ignored because <img> tag in JavaScript comes first (vintagecomp.com)

        * khtml/misc/decoder.cpp: (Decoder::decode): Don't let tags inside a script make us think we're in the body.
        Later we can enhance this even more.

2003-09-22  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3292723 -- onBlur() getting called twice on <input type=text>

        * khtml/rendering/render_replaced.cpp: (RenderWidget::eventFilter):
        Call setFocusNode(0) instead of explicitly sending a blur event, otherwise
        setFocusNode will send a second blur event later.

2003-09-22  Darin Adler  <darin@apple.com>

        - fixed 3391837 -- we list ISO-8859-8-E as visual ordering for Hebrew; it's "explicit ordering", not supported

        * kwq/mac-encodings.txt: Removed ISO-8859-8-E.
        * kwq/KWQCharsetData.c: Regenerated.

2003-09-22  Darin Adler  <darin@apple.com>

        * kwq/KWQTextEdit.mm: (QTextEdit::sizeWithColumnsAndRows): Made it compile.

2003-09-22  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3306041 -- Airborne tracking number field too narrow, tracking doesn't work (textare col property)

        * khtml/rendering/render_form.cpp: (RenderTextArea::calcMinMaxWidth): Call the QTextEdit
        to ask it what size, rather than trying to compute it. This is the same thing we do with
        other widgets, I just hadn't done textarea yet.

        * kwq/KWQTextEdit.h: Added sizeWithColumnsAndRows function.
        * kwq/KWQTextEdit.mm: (QTextEdit::sizeWithColumnsAndRows): Added. Calls through to the
        KWQTextArea object.

        * kwq/KWQTextArea.h: Added sizeWithColumns:rows: method.
        * kwq/KWQTextArea.mm:
        (-[KWQTextArea _createTextView]): Make consistent with other callers of the size mapping methods
        by using [self class] instead of NSScrollView, and getting hasHorizontalScroller and
        hasVerticalScroller from the view.
        (-[KWQTextArea setFrame:]): Make consistent with other callers of the size mapping methods
        by using [self class] instead of NSScrollView.
        (-[KWQTextArea sizeWithColumns:rows:]): Added. Starts by computing the width and height of the
        columns specified, using a canonical width of a "0" character. Then converts that to a container
        size by adding line fragment padding. Then converts that into the text view size by adding the
        text container inset. Then converts that into the scroll view size by calling frameSizeForContentSize:.

2003-09-22  Darin Adler  <darin@apple.com>

        * WebCore.pbproj/project.pbxproj: Rename Mixed build style to OptimizedWithSymbols.

2003-09-22  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - research determined we were using nothing defined in config.h, so I got rid of it

        * Makefile.am: Removed rules to generate config.h.
        * config.h: Removed.

        * WebCore.pbproj/project.pbxproj: Removed define of HAVE_CONFIG_H.

        * WebCorePrefix.h: Removed include of <config.h>.

        * ForwardingHeaders/config.h: Emptied this file out. Can't remove this because there are
        some includes of <config.h> without HAVE_CONFIG_H wrappers.

2003-09-21  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3106411 -- show title attribute for page elements in tooltip on mouseover (important for PeopleSoft)

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge elementAtPoint:]): Set the value of a new element dictionary
        key, WebCoreElementTitleKey. This gives the title for an element, walking up the DOM tree as necessary
        to find it. It's used for tool tips at the WebKit level.
        * kwq/WebCoreBridge.h: Added WebCoreElementTitleKey and WebCorePageCacheStateKey.

        * WebCore.exp: Added all the constants from WebCoreBridge.h; these should be exported even though they
        are not being used at the moment because the "WebCore and WebKit use the same constant keys" hack we
        are doing at the WebKit level means we can just use the WebKit keys on the WebKit side.
        * WebCore-combined.exp: Regenerated.

2003-09-20  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3328481 -- selection in select element list box does not scroll into view when set programatically

        * kwq/KWQListBox.mm: (QListBox::setSelected): Scroll newly-selected item into view.

2003-09-20  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3429384 -- REGRESSION (89-90): nil-deref in KHTMLPart::write() (cheshiremotorcyclesalvage.com)

        * khtml/khtml_part.cpp: (KHTMLPart::write): Add a nil check.

2003-09-20  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - more fixes for the W3C DOM tests

        * khtml/dom/dom_doc.cpp: (Document::createAttributeNS): Check that the attribute name
        is valid and throw INVALID_CHARACTER_ERR if not.

        * khtml/dom/dom_element.cpp:
        (Element::removeAttributeNode): Get the attribute name properly. The old code would always
        get a 0, so this function would always fail.
        (Element::setAttributeNS): Check that the attribute name is valid and throw
        INVALID_CHARACTER_ERR if not.
        (Element::setAttributeNodeNS): Remove redundant exception checks that are also done by
        setNamedItem in the implementation. I had to change the implementation of one, so I decided
        it was better not to have any duplication.

        * khtml/xml/dom_docimpl.h: Added isValidName function.
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::createHTMLElement): Check that the attribute name is valid and throw
        INVALID_CHARACTER_ERR if not.
        (DocumentImpl::isValidName): Added. Used to check for valid names.

        * khtml/xml/dom_elementimpl.cpp:
        (NamedAttrMapImpl::setNamedItem): Don't do the document check until after checking for
        the "replace self" case. Otherwise we raise a spurious "in use" exception.
        (NamedAttrMapImpl::addAttribute): Point the new attribute at the element.

2003-09-19  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	Roll out old fix for 3410980 and do a new better fix.

        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/khtml_part.h:
        * kwq/KWQKHTMLPart.mm:
        * kwq/WebCoreBridge.h:

2003-09-19  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - update layout tests for Dave's change

        * layout-tests/apple-only/base/www.excite.com/index-expected.txt:
        * layout-tests/fast/block/positioning/051-expected.txt:
        * layout-tests/fast/overflow/003-expected.txt:

        - fixed 3426272 -- sites that use text-shadow cause leaks (QPainter::setShadow)

        * kwq/KWQPainter.mm: (QPainter::setShadow): Release the color space and color.

        - fixed some errors that caused failures in the W3C DOM suite

        * khtml/ecma/kjs_binding.cpp:
        (DOMObject::get): Put "code" in the error object.
        (DOMObject::put): Put "code" in the error object.
        (DOMFunction::get): Put "code" in the error object.

        * khtml/ecma/kjs_dom.cpp: (DOMCharacterDataProtoFunc::tryCall):
        Add checks for negative count values. Not clear whether this change is
        really great, but it helps us pass W3C DOM tests and clearly won't affect
        normal pages in any bad way.

        * khtml/xml/dom_elementimpl.cpp:
        (AttrImpl::AttrImpl): Set m_specified to true. Since we never set up the
        attributes from the DTD anyway, this is fine for now. If we ever go crazy
        and implement that, then the bit field is sitting here waiting for us.
        (NamedAttrMapImpl::removeNamedItem): The comment from KHTML says they
        don't raise the not found exception because "the DOM 2 spec doesn't say
        you should". But the DOM Level 1 specification clearly does, and the W3C
        DOM Level 1 Core test requires it, so I'm putting it in.

        * khtml/xml/dom_nodeimpl.cpp: (NodeImpl::checkAddChild): Typo; this was
        returning the wrong error code in the "wrong document" case.

        * khtml/xml/dom_stringimpl.cpp:
        (DOMStringImpl::remove): Fix overflow case.
        (DOMStringImpl::substring): Fix overflow case.
        
2003-09-19  David Hyatt  <hyatt@apple.com>

	Fix for 3401409, fix negative z-index.  This code actually substantially
	reworks layers to be more efficient in both painting and event handling.
	It also fixes bugs with clipping as well as with negative z-indices.
	
        Reviewed by kocienda

        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::repaintRectangle):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::nodeAtPoint):
        * khtml/rendering/render_frames.h:
        * khtml/rendering/render_image.cpp:
        (RenderImage::nodeAtPoint):
        * khtml/rendering/render_image.h:
        * khtml/rendering/render_inline.cpp:
        (RenderInline::nodeAtPoint):
        * khtml/rendering/render_inline.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::RenderLayer):
        (RenderLayer::~RenderLayer):
        (RenderLayer::updateLayerPosition):
        (RenderLayer::stackingContext):
        (RenderLayer::enclosingPositionedAncestor):
        (RenderLayer::transparentAncestor):
        (RenderLayer::addChild):
        (RenderLayer::removeChild):
        (RenderLayer::convertToLayerCoords):
        (RenderLayer::checkScrollbarsAfterLayout):
        (RenderLayer::paintScrollbars):
        (RenderLayer::paint):
        (setClip):
        (restoreClip):
        (RenderLayer::paintLayer):
        (RenderLayer::nodeAtPoint):
        (RenderLayer::nodeAtPointForLayer):
        (RenderLayer::calculateClipRects):
        (RenderLayer::calculateRects):
        (RenderLayer::intersectsDamageRect):
        (RenderLayer::containsPoint):
        (hoverAncestor):
        (commonAncestor):
        (RenderLayer::updateHoverActiveState):
        (sortByZOrder):
        (RenderLayer::dirtyZOrderLists):
        (RenderLayer::updateZOrderLists):
        (RenderLayer::collectLayers):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::setStyle):
        (RenderObject::document):
        (RenderObject::renderArena):
        (RenderObject::nodeAtPoint):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::nodeAtPoint):
        * khtml/rendering/render_text.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::DocumentImpl):
        (DocumentImpl::~DocumentImpl):
        (DocumentImpl::recalcStyleSelector):
        (DocumentImpl::setHoverNode):
        * khtml/xml/dom_docimpl.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::paint):
        (KWQKHTMLPart::paintSelectionOnly):
        (KWQKHTMLPart::adjustPageHeight):
        * kwq/KWQRect.h:
        * kwq/KWQRenderTreeDebug.cpp:
        (write):
        (writeLayers):
        (externalRepresentation):

2003-09-19  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        * layout-tests: Updated for my mini-controls change.

2003-09-19  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - do the prep work for the mini controls feature; Dave will finish this

        * khtml/rendering/render_form.cpp: (RenderFormElement::updateFromElement):
        Tell the widget about the font size. Our widgets use the font size to
        decide whether to use Aqua normal, small, or mini.

        * kwq/KWQButton.h: Add setFont.
        * kwq/KWQButton.mm:
        (QButton::setFont): Set control size based on font.
        (KWQNSControlSizeForFont): Determine control size given a font. Dave is going
        to tweak this later.

        * kwq/KWQCheckBox.h: Add dimensions function for metrics for each control size.
        * kwq/KWQCheckBox.mm:
        (QCheckBox::sizeHint): Use dimensions.
        (QCheckBox::frameGeometry): Use dimensions.
        (QCheckBox::setFrameGeometry): Use dimensions.
        (QCheckBox::baselinePosition): Use dimensions.
        (QCheckBox::dimensions): Added. Has newly tweaked values for all dimensions for
        all three control sizes.

        * kwq/KWQComboBox.h: Add setFont and dimensions.
        * kwq/KWQComboBox.mm:
        (QComboBox::sizeHint): Use dimensions.
        (QComboBox::frameGeometry): Use dimensions.
        (QComboBox::setFrameGeometry): Use dimensions.
        (QComboBox::baselinePosition): Use dimensions.
        (QComboBox::setFont): Use dimensions.
        (QComboBox::dimensions): Added. Has newly tweaked values for all dimensions for
        all three control sizes.

        * kwq/KWQFileButton.mm: (KWQFileButton::baselinePosition): Change to adapt to
        flipped version of file button NSControl.

        * kwq/KWQPushButton.h: Add dimensions function for metrics for each control size.
        * kwq/KWQPushButton.mm:
        (QPushButton::sizeHint): Use dimensions.
        (QPushButton::frameGeometry): Use dimensions.
        (QPushButton::setFrameGeometry): Use dimensions.
        (QPushButton::baselinePosition): Use dimensions.
        (QPushButton::dimensions): Added. Has newly tweaked values for all dimensions for
        all three control sizes.

        * kwq/KWQRadioButton.h: Add dimensions function for metrics for each control size.
        * kwq/KWQRadioButton.mm:
        (QRadioButton::sizeHint): Use dimensions.
        (QRadioButton::frameGeometry): Use dimensions.
        (QRadioButton::setFrameGeometry): Use dimensions.
        (QRadioButton::baselinePosition): Use dimensions.
        (QRadioButton::dimensions): Added. Has newly tweaked values for all dimensions for
        all three control sizes.

2003-09-19  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.
	
	- fixed 3410980 - FileMaker: going forward with an empty forward list makes a frame come out blank sometimes
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close): Remove redundant check removed.
        * khtml/khtml_part.h:
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::scheduleHistoryNavigation): Only call the base class
	method to actually schedule when it's possible to go back or forward
	that number of steps.
        * kwq/WebCoreBridge.h:

2003-09-17  John Sullivan  <sullivan@apple.com>

	- WebCore part of fix for 3157018 -- Would like option to
	not print backgrounds	

        Reviewed by Darin

        * kwq/KWQKHTMLSettings.h:
	add _shouldPrintBackgrounds field and accessors

        * kwq/WebCoreSettings.h:
	add shouldPrintBackgrounds field and accessors
        * kwq/WebCoreSettings.mm:
        (-[WebCoreSettings setShouldPrintBackgrounds:]):
	new method, passes value to KHTMLSettings
        (-[WebCoreSettings shouldPrintBackgrounds]):
	new method

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge styleSheetForPrinting]):
	new method, returns a style sheet that has backgrounds
	turned off if preference is set that way.
        (-[WebCoreBridge reapplyStylesForDeviceType:]):
	if printing, set the printStyleSheet to the one we
	created based on the preferences. (KHTML has always
	had support for a special printStyleSheet, but it was
	only being used in !APPLE_CHANGES code.)

        * khtml/rendering/render_style.h:
	add shouldCorrectTextColor boolean field and accessors 

        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):
	tell style to correct text colors if backgrounds aren't being printed

        * khtml/rendering/render_text.cpp:
        (TextRun::paintSelection):
	added comment
        (simpleDifferenceBetweenColors):
	new function, computes a quick measure of difference
	between colors
        (correctedTextColor):
	if text and background colors are too similar, returns
	lightened or darkened text color
        (RenderText::paintObject):
	if style says to correct text colors, call correctedTextColor

2003-09-17  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3423404 -- REGRESSION: Japanese page appears blank due to unexpected kTECPartialCharErr

        * kwq/KWQTextCodec.mm: (KWQTextDecoder::convertOneChunkUsingTEC): In the case where we're already
        going from the small buffer back to the large one, treat kTECPartialCharErr the same as noErr.
        Otherwise we'll get confused and drop the contents of the big buffer.
        (KWQTextDecoder::convert): Improve the debugging code a bit (still turned off).

=== WebCore-105 ===

2003-09-15  Ken as Darin  <darin@apple.com>

        Reviewed by Darin and Don.

        - fixed 3419957 -- REGRESSION: lines drawn across multiple columns at washingtonpost.com

        * khtml/rendering/render_box.cpp: (RenderBox::calcWidth): Always use the width of the line
        rather than the width of the containing block for "flow around floats" blocks (<hr>).
        This undoes half of the change made to fix bug 3384609.

2003-09-15  Darin Adler  <darin@apple.com>

        Reviewed by Ken and Don.

        - fixed 3417604 -- REGRESSION: dragging scroll thumb causes textarea contents to vanish

        * kwq/KWQTextArea.mm: (-[KWQTextArea initWithFrame:]): Deallocated cached graphics state for
        the text view as well as for the clip view.

2003-09-13  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3420547 -- REGRESSION: repro crash in khtml::RenderBlock::findNextLineBreak (wisdomtips.com)

        * khtml/rendering/render_block.cpp: (RenderBlock::addChildToFlow): Exclude BR elements when looking for
        an element to process first-letter style.

2003-09-13  Darin Adler  <darin@apple.com>

        * layout-tests/fast/frames/empty-frame-src-expected.txt: Updated test results that changed
        due to the change in our handling of frame borders.

=== WebCore-104 ===

2003-09-12  Richard Williamson   <rjw@apple.com>

	Fixed 3420097.  Pass flag up to WebKit indicating that redirects are being cancelled during a pending load.

        Reviewed by Darin.

        * khtml/khtml_part.cpp:
        (KHTMLPart::cancelRedirection):
        * khtml/khtml_part.h:
        * khtml/khtmlpart_p.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::provisionalLoadStarted):
        (KWQKHTMLPart::redirectionTimerStartedOrStopped):
        * kwq/WebCoreBridge.h:

=== WebCore-103 ===

2003-09-12  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

        * khtml/css/html4.css: Use the same hardcoded default size for
	OBJECT and EMBED tags as for IFRAME.

2003-09-12  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3403223 -- <input type=file> with initial value causes exception, bad results afterwards, when submitted

        * kwq/KWQFile.mm: (QFile::QFile): Don't pass an empty string to fileSystemRepresentation,
        because that will cause an exception.

=== WebCore-101 ===

2003-09-11  Richard Williamson   <rjw@apple.com>

	Fixed 3406671.  Added a private method for Mail to get selection
	rect.

	Fixed 3417688.  Don't allow https page into page cache.

        Reviewed by Darin.

        * kwq/KWQFrame.h:
        * kwq/KWQFrame.mm:
        (QFrame::setFrameStyle):
        (QFrame::frameWidth):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::canCachePage):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge selectionRect]):
        (-[WebCoreBridge visibleSelectionRect]):
        (-[WebCoreBridge selectionImage]):
        (-[WebCoreBridge adjustViewSize]):

=== Safari-100 ===

2003-09-09  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

        - fixed 3373654 -- REGRESSION: Yahoo chat applet reloads over and over due to "baseURL" param name conflict

        After some research by the Java team, we discovered that there was no need to
        pass in baseURL at all This patch gets rid of that by only passingindividual specified
        arguments, rather than passing all the arguments, as applet parameters.

        * khtml/rendering/render_applet.cpp: (RenderApplet::processArguments): Remove the
        call to KJavaApplet::processArguments, because we only want the individual arguments.
        * kwq/KWQKJavaAppletWidget.h: Implement setAppletClass, setAppletName, setArchives, and
        setCodeBase. Remove processArguments.
        * kwq/KWQKJavaAppletWidget.mm: (KJavaAppletWidget::setParameter): Lowercase all the
        parameters as we put them in the dictionary, since this is the semantics required by Java.

=== Safari-99 ===

2003-09-07  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3411827 -- REGRESSION: text drawing after text-shadow does not respect smoothing style (asahi.com)

        * kwq/KWQPainter.mm: (QPainter::clearShadow): Call CGContextSetShadowWithColor with a color of NULL,
        which actually clears the shadow, rather than CGContextSetShadow, which sets a black shadow (even
        if it is zero pixels in size).

=== Safari-98 ===

2003-09-05  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

	Fix for this bug:

	<rdar://problem/3226083>: REGRESSION (Panther): white box 
	overlaying select lists at nvidia.com drivers page

        * kwq/KWQListBox.mm:
        (QListBox::QListBox): Re-add releaseGState fix that Darin
	added, but then removed. It turns out that we do need 
	this workaround in place to get proper drawing.

	Fix for this bug:

	<rdar://problem/3310943>: REGRESSION (Panther): textareas 
	in forms sometimes draw blank (bugreporter)

        * kwq/KWQTextArea.mm:
        (-[KWQTextArea initWithFrame:]): Same fix as above.

2003-09-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed - REGRESSION (85-92): Javascript on page isn't triggered by typed characters (onKeyUp)

	(This actually also requires an AppKit fix to be a full fix.)

        * kwq/KWQListBox.mm:
        (-[KWQTableView keyDown:]): Added. Send event through DOM.
        (-[KWQTableView keyUp:]): Likewise.
        (-[KWQTableView becomeFirstResponder]): Added. Report focus change
	to DOM.
	* kwq/KWQTextArea.mm:
        (-[KWQTextAreaTextView keyUp:]): Added. Send event through DOM.
        * kwq/KWQTextField.mm:
        (-[KWQTextField textView:shouldHandleEvent:]): Pass NSKeyUp events too
	(not going to work until we get an AppKit fix).

2003-09-04  John Sullivan  <sullivan@apple.com>

	- fixed 3399880 -- Repro crash when filling out a form to
	download Macromedia software. I managed to check in this
	ChangeLog comment a few days ago without actually checking
	in the changed file, weird.

        Reviewed by Chris

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementForView:]):
	check for nil widget before dereferencing

2003-09-04  David Hyatt  <hyatt@apple.com>

	Fix for 3408630, leak of child frame parts caused by a missing deref when frames
	get detached from their parent frame list.
	
        Reviewed by mjs

        * kwq/KWQKHTMLPart.mm:
        (KHTMLPart::frameDetached):

2003-09-04  Darin Adler  <darin@apple.com>

        * layout-tests/apple-only/base/www.msn.com/index-expected.txt: Update for residual style fix.
        * layout-tests/fast/invalid/003-expected.txt: Update for residual style fix.

2003-09-04  Darin Adler  <darin@apple.com>

        * kwq/KWQRenderTreeDebug.cpp: (write): Fix clip rectangle computation.
        * layout-tests: Update test results.

=== Safari-97 ===

2003-09-03  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

        * khtml/khtml_part.cpp:
	(KHTMLPart::clear): Un-ifdef cleanup of frames, and add similar
	cleanup for objects. Replace delete with deref.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::createPart): Add an extra ref to KHTMLParts since
	both the bridge and the parent part want to deref.

2003-09-03  David Hyatt  <hyatt@apple.com>

	Fix for 3404398, leak in residual style code.  The code that built up the
	residualStyleStack was messed up and discarded tags.
	
        Reviewed by mjs

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::popBlock):

2003-09-02  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

	Fix for this bug:

	<rdar://problem/3399169>: 4 leaks of DOMString objects (Mail)

	Remove circular reference between AttributeImpl and AttrImpl objects.
	This was causing the leak.

        * khtml/xml/dom_elementimpl.cpp:
        (AttributeImpl::allocateImpl):

2003-09-02  David Hyatt  <hyatt@apple.com>

	Fix for 3359408, DirWS should not be used when collapsing/stripping spaces,
	since only ASCII spaces are supposed to be collapsed/stripped.
	
        Reviewed by mjs

        * khtml/rendering/bidi.cpp:

2003-09-02  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3403388 -- decoder mishandles pages which fill the decoding buffer (mainly ISO-2022-JP)

        * kwq/KWQTextCodec.mm: (KWQTextDecoder::convertUsingTEC): Keep decoding, passing in no additional bytes,
        until we get noErr, don't ever stop after a kTECOutputBufferFullStatus error.

2003-09-02  David Hyatt  <hyatt@apple.com>

	Fix for 3404452, paint errors on mezzoblue.com's links list.  There was a simple
	math error in the invalidation rect computation.
	
        Reviewed by mjs

        * khtml/rendering/render_flow.cpp:
        (RenderFlow::repaint):
        
2003-09-01  John Sullivan  <sullivan@apple.com>

	- WebCore part of fix for 3402489 -- REGRESSION (7B48-7B55): Some 
	printed web pages are too small (width is half a page)

	This was a regression caused by the fix for 3378810.

        Reviewed by Maciej

        * kwq/WebCoreBridge.h:
	add adjustingViewSize flag to forceLayout and forceLayoutForPageWidth:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge forceLayoutAdjustingViewSize:]):
	respect new flag while we are set up for printing.
        (-[WebCoreBridge forceLayoutForPageWidth:adjustingViewSize:]):
	ditto
        (-[WebCoreBridge adjustFrames:]):
	pass NO for new flag here

2003-09-01  John Sullivan  <sullivan@apple.com>

        * kwq/KWQPainter.mm:
        (QPainter::drawLine):
	Removed the ERROR that warns of the CG memory trashing bug, now
	that we are enough builds away from it that it is (almost?) never
	reported anymore.

=== Safari-96 ===

2003-08-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	- fixed 3397775 21 leaks from CSS parser running PLT
	
        * khtml/css/css_ruleimpl.cpp:
        (CSSMediaRuleImpl::~CSSMediaRuleImpl): Clear the parent for all contained
	rules.
        (CSSMediaRuleImpl::append): Call insertRule.
        (CSSMediaRuleImpl::insertRule): set parent of the rule to this media rule.
        (CSSRuleListImpl::append): Call insertRule to cover all the relevant
	additional handling, instead of adding straight to the list.
        * khtml/css/css_ruleimpl.h:

2003-08-29  John Sullivan  <sullivan@apple.com>
	
	- fixed 3399880 -- Repro crash when filling out a form to 
	download Macromedia software

        Reviewed by Chris

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementForView:]):
	check for nil widget before dereferencing

2003-08-28  David Hyatt  <hyatt@apple.com>

	Fix for 3381377, fix the calcBlockMinMaxWidth function to not use the
	renderobject's computed margins except when it has to.  This makes
	table cells with align=right not mess up and fixes margin problems
	in general with floated elements and table cells.

	Since XUL boxes also use a similar function and since it had a similar
	error, vertical XUL boxes have been patched as well.
	
        Reviewed by gramps

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_flexbox.cpp:

2003-08-28  David Hyatt  <hyatt@apple.com>

	Fix for 3398463, a regression caused by an unintended line movement.
	<br/> was no longer being treated just like <br> in HTML.
	
        Reviewed by gramps

        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::parseTag):

=== Safari-95 ===

2003-08-27  Richard Williamson   <rjw@apple.com>

	Fixed 3359408.  DON'T treat unicode whitespace as whitespace when collapsing spaces.

        Reviewed by David Hyatt.

        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_text.cpp:
        (RenderText::trimmedMinMaxWidth):
        (RenderText::calcMinMaxWidth):
        (RenderText::containsOnlyWhitespace):
        * khtml/xml/dom_stringimpl.cpp:

2003-08-27  David Hyatt  <hyatt@apple.com>

	Fix for 3396962, hang on quote.com.  Fieldsets with display:inline should be treated
	like inline-blocks. This matches WinIE's behavior.
	
        Reviewed by mjs

        * khtml/rendering/render_form.cpp:
        (RenderFieldset::setStyle):
        * khtml/rendering/render_form.h:

2003-08-26  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - follow-on to fix for 3310943 -- REGRESSION (Panther): textareas in forms sometimes draw blank (bugreporter)

        * kwq/KWQListBox.mm: (QListBox::QListBox): Remove call to releaseGState. This was here to
        work around a problem we thought was an AppKit bug, but it turns out it was caused by
        NSView hackery in WebKit. We now do the WebKit part in a way that does not create the problem.

2003-08-26  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3031562 -- most forms don't work in certain configurations because of a bug in KWQVariant

        * kwq/KWQVariant.mm: (QVariant::QVariant): Set the b element of the union, not the d element,
        in the constructor for bool.

2003-08-26  David Hyatt  <hyatt@apple.com>

	Fix for 3395950, better support for self-collapsing blocks.  Make them obey
	clear properly and also change the definition of self-collapsing to match
	the CSS2.1 specification.
	
        Reviewed by gramps

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:

2003-08-26  David Hyatt  <hyatt@apple.com>

	Fix for 3335175, www.calstone.com renders as blank.  The fix is to deliberately
	introduce an error into our HTML parsing code that causes us to honor self-closing
	XML-style <script/> tags.  This matches Mozilla and Opera behavior (both of them
	have this bug), but it does not match WinIE.
	
        Reviewed by mjs

        * khtml/html/htmltokenizer.cpp:

2003-08-26  David Hyatt  <hyatt@apple.com>

	Fix for 3286229, popup menu misplaced.  <form> needs to be allowed as a child of
	<h1>-<h6> tags.  All other browsers allow this.
	
        Reviewed by darin

        * khtml/html/dtd.cpp:

2003-08-26  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - re-fixed 3366542 -- filename with non-ASCII name left out of Content-Disposition for <input type=file>

        * khtml/html/html_formimpl.cpp: (HTMLFormElementImpl::formData): Added missing # sign.

2003-08-26  David Hyatt  <hyatt@apple.com>

	Fix for 3394107, make sure the display mutation code doesn't mutate objects with
	display: none set.
	
        Reviewed by darin

        * khtml/css/cssstyleselector.cpp:

2003-08-22  David Hyatt  <hyatt@apple.com>

	Fix for 3388363, copying a word in a list item copied too much.  The code that checked
	for the bullet would add in too much text sometimes.
	
        Reviewed by john

        * kwq/KWQKHTMLPart.mm:
        (isTextFirstInListItem):
        (KWQKHTMLPart::attributedString):

2003-08-21  Darin Adler  <darin@apple.com>

        * Makefile.am: Work around DLCFN issue to prevent constant churn of config.h.
        * config.h: Regenerated without DLCFN.

2003-08-21  Darin Adler  <darin@apple.com>

        * khtml/khtmlview.h: Formatting tweak.

2003-08-21  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3386673>: a particular fidelity.com "Log in" link does nothing because of cross-domain JavaScript rules

        Reviewed by mjs.

        * config.h:
        * khtml/ecma/kjs_window.cpp:
        (Window::get): allow other frames to get the location object
        (Window::isSafeScript): added JS logging
        (Location::get): don't allow other frames to access location attributes
        (LocationFunc::tryCall): don't allow other frames to call functions on the location object

2003-08-21  Richard Williamson   <rjw@apple.com>
	
	Fixed 3378810.  Avoid resizing frame from drawRect: when printing.  This will corrupt the graphics context.

        Reviewed by Hyatt.

        * khtml/khtmlview.cpp:
        (KHTMLView::adjustViewSize):
        * khtml/khtmlview.h:
        * khtml/rendering/render_canvas.cpp:
        (RenderCanvas::layout):
        * kwq/KWQScrollView.mm:
        (QScrollView::resizeContents):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge adjustViewSize]):

=== Safari-94 ===

2003-08-21  David Hyatt  <hyatt@apple.com>

	Fix for 3387302, floats weren't being allowed to be relatively positioned.  The
	fix is trivial.  Stop making floating/relpositiion setting an if/else and just make
	it two ifs.
	
        Reviewed by darin

        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):

2003-08-21  David Hyatt  <hyatt@apple.com>

	Fix for 3384635, breakable unicode characters that were preceded by multiple spaces
	accidentally added in those spaces to their widths.
	
        Reviewed by rjw and gramps

        * khtml/rendering/bidi.cpp:

2003-08-20  David Hyatt  <hyatt@apple.com>

	Fix for 3384609.  Objects that want to dodge floats should fill the line width instead
	of the containing block width only if their widths are auto.  If widths are specified
	explicitly, then ccontaining block width should be honored.
	
        Reviewed by john

        * khtml/rendering/render_box.cpp:
        (RenderBox::calcWidth):
        * khtml/rendering/render_table.cpp:
        (RenderTable::calcWidth):

2003-08-20  Richard Williamson   <rjw@apple.com>

	UCFindTextBreak will report false if we have a sequence of 0xa0 0x20 (nbsp, sp), so we explicity check for that case.  Filed 3386852 to track this problem, meanwhile added a work-around.  This problem was revealed after adding the fix for 3242508.

        Reviewed by Dave.

        * khtml/rendering/break_lines.cpp:

2003-08-20  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3248069 -- Safari does not support ISO Latin 10 (ISO-8859-16, romanian) coding.

        * kwq/mac-encodings.txt: Added ISO-8859-16, which maps to ISO Latin-10.
        * kwq/KWQCharsetData.c: Regenerated.
        * kwq/KWQCharsets.mm: Add definition of kCFStringEncodingISOLatin10, since this encoding
        is currently only in TextCommon.h, not in CFStringEncodingExt.h.

2003-08-20  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3384963 - REGRESSION: assertion in copyPathRemovingDots, crash parsing URL in snippet editor
	
        * kwq/KWQKURL.mm:
        (copyPathRemovingDots): It's OK if the path is entirely empty.

2003-08-20  David Hyatt  <hyatt@apple.com>

	Fix for 3385211, <td>s should ignore the float property in quirks mode.  This
        patch cleans up the adjustments of <td>s and <table>s and moves the code into
        the style selector (instead of cluttering up the rendering code).

	Fix for 3385476, generated content not built correctly.  All generated content
	should be placed inside a containing object that actually gets the pseudo-style.
	
        Reviewed by rjw

        * ChangeLog:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/cssstyleselector.h:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_object.cpp:
        (RenderObject::createObject):

2003-08-20  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3292036 - albertsons.com world leak of 2 WebDataSource and 2 WebHTMLRepresentation objects
	
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::canCachePage): Test for parentPart() even if there
	is no document.

2003-08-20  Richard Williamson   <rjw@apple.com>

	Fixed 3242508.  Japanese (and other non latin1 scripts) line breaking incorrect when mixed with latin1.

        Reviewed by Dave.

        * khtml/rendering/break_lines.cpp:

	Checkin fix for earlier bug that was already approved!

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):

2003-08-19  David Hyatt  <hyatt@apple.com>

	Fixes for 3380766 and 3381867.  One is a table bug with amazon.com where colspans
	were losing percentage width values.  The other is a bug where floats aren't dirtying
	objects into which they intrude when doing layout.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/table_layout.cpp:
        (AutoTableLayout::calcEffectiveWidth):

2003-08-19  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3379336>: flash on front page of http://www.westportmotorsports.com is broken

        Reviewed by darin.

        * khtml/rendering/render_frames.cpp:
        (RenderPartObject::updateWidget): Ignore the PARAM tags and only use attributes inside the OBJECT tag when the EMBED tag is omitted.

2003-08-19  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3343681 -- clicking on a disabled submit button submits the form!

        This turned out to be a problem with code in dispatchGenericEvent that sent
        DOMActivate events even when the form element was disabled.

        * khtml/xml/dom_nodeimpl.h: Add virtual disabled() member function.
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::dispatchGenericEvent): Don't send DOM activate events for disabled elements.
        (NodeImpl::handleLocalEvents): Don't send mouse events for disabled elements. But we do
        want those events to pass through the bubble and capture phases, just avoid triggering
        any listeners on this node itself.
        (NodeImpl::disabled): Added default implementation that returns false.

        * khtml/html/html_formimpl.h: Removed the disabled() function's inline implementation
        since it's now virtual and it's not helpful to inline virtual functions.
        * khtml/html/html_formimpl.cpp:
        (HTMLGenericFormElementImpl::disabled): Moved this method into the .cpp file since it's
        now virtual and it's not helpful to inline virtual functions.

2003-08-18  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3380411 -- Unicode supplementary characters cut in half in text control with maxlength set

        * kwq/KWQTextField.mm:
        (-[KWQTextField setMaximumLength:]): Enforce maximum length based on number of composed character
        sequences rather than on number of UTF-16 values. This helps with both surrogate pairs (the supplementary
        characters mentioned in the bug report) and composed character sequences.
        (-[KWQTextField setStringValue:]): Ditto.
        (-[KWQTextFieldFormatter isPartialStringValid:newEditingString:errorDescription:]): Ditto.
        (-[NSString _KWQ_numComposedCharacterSequences]): Added. Computes the length of a string in terms of
        number of composed character sequences.
        (-[NSString _KWQ_truncateToNumComposedCharacterSequences:]): Added. Truncates a string in terms of
        number of composed character sequences.

2003-08-18  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3299893 -- oncontextmenu support

        * kwq/WebCoreBridge.h: Added sendContextMenuEvent: method.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge sendContextMenuEvent:]): Added.
        Calls sendContextMenuEvent on the part.

        * kwq/KWQKHTMLPart.h: Added sendContextMenuEvent member function.
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::sendContextMenuEvent): Added. Sets up
        a suitable mouse event and calls dispatchMouseEvent for CONTEXTMENU_EVENT.

        * khtml/ecma/kjs_dom.cpp: Added oncontextmenu to DOMNode's list of properties.
        (DOMNode::getValueProperty): Added case for OnContextMenu.
        (DOMNode::putValue): Added case for OnContextMenu.
        * khtml/ecma/kjs_dom.h: Added constant for OnContextMenu.
        * khtml/html/html_elementimpl.cpp: (HTMLElementImpl::parseAttribute):
        Added case for ATTR_ONCONTEXTMENU.
        * khtml/misc/htmlattrs.in: Added oncontextmenu.
        * khtml/xml/dom2_eventsimpl.cpp:
        (EventImpl::typeToId): Added case for CONTEXTMENU_EVENT.
        (EventImpl::idToType): Added case for CONTEXTMENU_EVENT.
        * khtml/xml/dom2_eventsimpl.h: Added CONTEXTMENU_EVENT.

        * khtml/ecma/kjs_dom.lut.h: Regenerated.
        * khtml/misc/htmlattrs.c: Regenerated.
        * khtml/misc/htmlattrs.h: Regenerated.

2003-08-18  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3381295 -- regular expression matches for text with UTF-16 surrogates will give incorrect results

        * kwq/KWQRegExp.mm: (QRegExp::match): Removed local copy of convertCharacterOffsetsToUTF8ByteOffsets
        and its reverse. Instead use convertUTF16OffsetsToUTF8Offsets and its reverse, now available from
        <JavaScriptCore/ustring.h>.

        - added test for the URI encoding and decoding functions in JavaScriptCore

        * layout-tests/fast/js/global/encode-URI-test-expected.txt: Added.
        * layout-tests/fast/js/global/encode-URI-test.html: Added.

2003-08-15  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3380418>: Ignore specified string encoding when constructing file, mailto and help URLs

        Reviewed by mjs, darin.

        * kwq/KWQKURL.mm:
        (KURL::KURL): store the URL string as UTF-8 when the URL is file, mailto and help.

2003-08-17  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3366542 -- filename with non-ASCII name left out of Content-Disposition for <input type=file>

        * khtml/html/html_formimpl.cpp: (HTMLFormElementImpl::formData):
        Do the &-encoding thing on the filename. This is what Gecko does.

2003-08-14  Maciej Stachowiak  <mjs@apple.com>

        Fixed by Darin, reviewed by me (and originally figured out by John).

	- fixed 3375592 - New Yahoo Maps doesn't work right
	
        * kwq/KWQTextCodec.mm:
        (KWQTextDecoder::convertUTF16): Don't pass through null characters.
        (KWQTextDecoder::appendOmittingNullsAndBOMs): Ditto.
        (KWQTextDecoder::convertUsingTEC): Ditto.

=== Safari-93 ===

2003-08-14  Vicki Murley  <vicki@apple.com>

        Reviewed by John. 

        * WebCore.pbproj/project.pbxproj: deleted WebCore.order from the project.

2003-08-14  Vicki Murley  <vicki@apple.com>

        Reviewed by John. 

        * WebCore.order: Removed. We now point to the WebCore order file in /AppleInternal/OrderFiles.
        * WebCore.pbproj/project.pbxproj: change sectorder flag to point to /AppleInternal/OrderFiles/WebCore.order

2003-08-14  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

	Fix for this bug:

	<rdar://problem/3095893>: Image Capture: "Build web page" doesn't work with Japanese folder name.

        * kwq/KWQKURL.mm:
        (KURL::getNSURL): Try UTF-8 first and fallback to ISO Latin-1 when creating an NSURL.
	This will handle the two-byte character in file name case mentioned in the bug.

2003-08-14  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3375270 -- writing to frame parent from a button press crashes in viewportMousePressEvent
        
        The fix turned out to be to ref the view around handling events in the view, since processing
        the event could cause the view and part to go away. Since the view refs the part, ref'ing just
        the view seems to work perfectly.
        
        * kwq/KWQKHTMLPart.mm: Fixed namespace access to use "using" instead of explicit namespaces.
        (KWQKHTMLPart::setView): Not-entirely-related cleanup. Use the "ref before deref" idiom here.
        (KWQKHTMLPart::sendResizeEvent): Ref the KHTMLView while sending the resize event.
        (KWQKHTMLPart::mouseDown): Ref the KHTMLView while sending the viewport mouse down event.
        (KWQKHTMLPart::mouseDragged): Ref the KHTMLView while sending the viewport mouse dragged event.
        (KWQKHTMLPart::mouseUp): Ref the KHTMLView while sending the viewport mouse up or double click event.
        (KWQKHTMLPart::mouseMoved): Ref the KHTMLView while sending the viewport mouse moved event.

2003-08-13  David Hyatt  <hyatt@apple.com>

	Fix for 3372896, spaces left at ends of lines.  Patch the selection code
	to be smarter about detecting ends of lines and adding in spaces.
	
        Reviewed by gramps

        * khtml/khtml_part.cpp:
        (KHTMLPart::selectedText):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):

2003-08-12  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken Kocienda.

	- fixed 3365242 - non-repro abort in HTMLTokenizer at ajc.com
	
        * khtml/khtml_part.cpp:
        (KHTMLPart::write): ref the part around actually processing the
	data, since a script could cause the part to go away.

2003-08-12  David Hyatt  <hyatt@apple.com>

	Fix for 3262190, <li> bullets in mail were overly massive.  The bezier path the
	painter stroked was not setting the line width from QPen's width, so it ended up
	just using the current line width instead (which happened to be much larger in
	Mail).
	
        Reviewed by darin

        * kwq/KWQPainter.mm:
        (QPainter::drawEllipse):
        (QPainter::drawArc):
        (QPainter::_drawPoints):

2003-08-12  John Sullivan  <sullivan@apple.com>

	- fixed 3370614 -- REGRESSION (81-85): partial inline input from Japanese 
	input method can disappear

        Reviewed by Hyatt

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::updateFromElement):
	call w->text() before element()->value(), because w->text() has a side
	effect of updating element()->value() in the inline input case
        (RenderTextArea::updateFromElement):
	same for text areas

2003-08-12  David Hyatt  <hyatt@apple.com>

	Fix for 3374566, list bullets don't display if list-style-type is none but a list-style-image
	is specified.  The spec says list-style-type: none does not apply to list-style-image,
	and this fixes Microsoft's list bullet on their security pages.
	
        Reviewed by john

        * khtml/rendering/render_list.cpp:
        (RenderListItem::setStyle):

2003-08-12  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3226083 -- REGRESSION (Panther): white box overlaying select lists at nvidia.com drivers page

        * kwq/KWQListBox.mm: (QListBox::QListBox): Call releaseGState on the clip view
        that we make for the list box. This prevents the incorrect graphics state caching
        that causes the problem, although it's not entirely clear why this is necessary.
        This may ultimately turn out to be an AppKit bug, and if so we can roll out this change
        when the AppKit itself is fixed.

2003-08-12  David Hyatt  <hyatt@apple.com>

	Fix for 3373462, XML shows up as blank because the root is inline.  The fix is
	to just disallow inline roots.
	
        Reviewed by kocienda

        * khtml/css/cssstyleselector.cpp:

2003-08-11  David Hyatt  <hyatt@apple.com>

	Fix for 3349142, blocks inside inlines with generated content cause the generated
	content to get all screwed up, especially if you try to print.  This patch fixes
	generated content to be continuation-aware (and vice versa), so that the content
	behaves correctly when inlines get split.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_container.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::addChild):
        * khtml/rendering/render_inline.cpp:
        (RenderInline::isInlineContinuation):
        (RenderInline::addChildToFlow):
        (RenderInline::cloneInline):
        (RenderInline::splitInlines):
        * khtml/rendering/render_inline.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::continuation):
        (RenderObject::isInlineContinuation):
        * khtml/rendering/render_object.h:

2003-08-11  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPart.h: Fixed some small typo-ish strangenesses.

2003-08-08  David Hyatt  <hyatt@apple.com>

	Fix for 3368672, don't allow frames and framesets to be positioned or relpositioned.
	
        Reviewed by darin

        * ChangeLog:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_object.cpp:
        (RenderObject::requiresLayer):
        * khtml/rendering/render_object.h:

2003-08-07  David Hyatt  <hyatt@apple.com>

	Fix for 3368463, assert/crash on libraries.uc.edu page.  A stylesheet was making 
	a <p> a table-column, which is totally nonsensical.  Since this isn't supported in
	WinIE, it just got ignored.  The fix I chose matches what Mozilla does, which is
	to not allow table-column renderobjects to have children.

	Fix for 3364412, FM pro file that happens to use a <col> element crashes.  Make sure
	to patch bidiiterator to have a null check for this bizarre case.  Technically <col>
	should never have been a table-column, since it's not in the HTML namespace, but
	that fix will have to wait until we get @namespace support in CSS.
	
        Reviewed by john

        * ChangeLog:
	* khtml/rendering/bidi.cpp
        * khtml/rendering/render_table.cpp:
        (RenderTableCol::canHaveChildren):
        * khtml/rendering/render_table.h:

2003-08-05  Dave Hyatt  <hyatt@apple.com>

	Fix for 3370654.  Make sure the max width computation for blocks with inline children actually
	ignores non-pre text runs that consist entirely of whitespace.
	
        Reviewed by mjs

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_text.cpp:
        (RenderText::trimmedMinMaxWidth):
        * khtml/rendering/render_text.h:

2003-08-08  John Sullivan  <sullivan@apple.com>

	- fixed 3362481 -- REGRESSION (89-90): clicking in a field causes 
	page to move; esp. bad if the field moves out from under the mouse

        Reviewed by Darin

        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::currentEventIsMouseDownInWidget):
	new method

        * kwq/KWQTextArea.mm:
        (-[KWQTextAreaTextView becomeFirstResponder]):
	only scroll to reveal if currentEventIsMouseDownInWidget is false

        * kwq/KWQTextField.mm:
        (-[KWQTextField setHasFocus:]):
	ditto

=== WebCore-92.1 ===

2003-08-07  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fixed 3366234 -- repro crash in CSS parser: function that can't be parsed (www.bi-flugplatz-magdeburg.de)

        * khtml/css/parser.y: Allocate a Function object for the "can't parse function" case, since
        the other code involved cannot handle 0 for the function.
        * khtml/css/parser.cpp: Regenerated.

=== Safari-92 ===

2003-08-07  Ken Kocienda  <kocienda@apple.com>

       Reviewed by Darin

       Fix for this bug:

       <rdar://problem/3367434>: newly-added KURL assertion failing reproducibly for JavaScript URL (www.thai.com)

       The assertion is correct. The issue was in calling the function
       with bad input. Non-hierarchical URLs should not have their "path"
       elements submitted to a function that will replace dots.

       The fix is to avoid calling this function with such non-hierarchical
       URLs.

         * kwq/KWQKURL.mm:
         (KURL::parse)

2003-08-07  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Maciej

	There was a bug in this code that caused a relative URL that was
	being resolved against an empty base URL to process incorrectly.
	The bug is that the resolution was being done twice. The first
	time was correct handling of this case, but then the code did
	not return at this point, and instead proceeded on through the
	code path that is used to handle resolution of a relative URL
	against a non-empty base. This double processing is clearly
	wrong, and we found this bug as the result of the recent addition 
	of an assertion in some related code.

        * kwq/KWQKURL.mm:
        (KURL::KURL)

2003-08-06  Darin Adler  <darin@apple.com>

        Reviewed by Richard.

        - fixed 3347114 -- remove vestiges of posing, including init routine, from WebKit

        * kwq/KWQTextArea.mm: (-[KWQTextAreaTextView keyDown:]): Remove check for old
        versions of AppKit that let the WebKit posing handle key down events.
        * kwq/KWQTextField.mm: Removed fieldEditorDidMouseDown: methods.

        * WebCore.pbproj/project.pbxproj: Removed WebCoreFirstResponderChanges.h.
        * kwq/WebCoreFirstResponderChanges.h: Removed.

2003-08-06  Richard Williamson   <rjw@apple.com>

	Fixed development build problem.  WebCore.exp needed a newline at EOF.
	
        * WebCore-combined.exp:

2003-08-06  Richard Williamson   <rjw@apple.com>

	Fixed 3348630.  Pick up about 1% by moving implementation of _unicodeDirection to WebCore and inlining.

        Reviewed by Ken.

        * WebCore-combined.exp:
        * WebCore.exp:
        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQString.h:
        * kwq/WebCoreUnicode.cpp:
        * kwq/WebCoreUnicode.h:

2003-08-06  John Sullivan  <sullivan@apple.com>

	- fixed 3366587 -- Mail quits instantly (no crashlog) trying
	to reply to a particular message

        Reviewed by Richard

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):
	Return nil immediately if startNode is nil.

2003-08-06  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Chris Blumenberg.

	- fixed 3366173 - crash in DOM::DomShared::ref loading www.berkheiser.net
	
        * khtml/ecma/kjs_html.cpp:
        (Image::putValue): Check for NULL before refing, because we set
	onLoadListener with a function that returns NULL if passed a value
	that's not a function.

2003-08-06  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin and Dave.

	- fixed 3364433 - repro crash in khtml::RenderBlock::nodeAtPoint
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::removeFromObjectLists): When finding the right
	parent block to remove a float from, don't stop at floating or
	positioned elements. They could well have floats in their
	m_floatingObjects list due to overhang, and failing to remove them
	leads to crashes.

2003-08-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

        * kwq/KWQPainter.mm:
        (QPainter::drawLine): Print a warning in debug builds when drawing
	a dashed line. Also, revert accidental commenting of lines that
	set the dash style.

2003-08-04  Dave Hyatt  <hyatt@apple.com>

	Fix for 3127909, copied text matched the document source instead of the
	rendered HTML.  This patch makes sure that the TextRuns are walked instead
	of just blindly pulling the text out of the DOM node.
	
        Reviewed by rjw

        * khtml/khtml_part.cpp:
        (KHTMLPart::selectedText):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):

2003-08-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin and Dave.

	- fixed 3363557 - REGRESSION (90-91): float:left element inside position:absolute element positioned wrong

        * khtml/rendering/render_block.cpp:
        (RenderBlock::calcInlineMinMaxWidth): Remove attempt to break line
	after flaot that follows a non-float. Removing this code fixes the
	regression and leaves pepboys and the meyerweb matrix theme
	working properly. Also, I could not find any evidence in the CSS2
	spec that what this code is trying to do is right.

2003-08-05  Ken Kocienda  <kocienda@apple.com>

        Reviewed by John

        Fix for this bug:

        <rdar://problem/3364251>: Modify KURL to call improved NSURL creation API

        * kwq/KWQKURL.mm:
        (KURL::getNSURL): Modify to use CFURLCreateAbsoluteURLWithBytes to create
        the NSURL.

2003-08-05  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Maciej

	In KWQKURL.mm, we copy the contents of a URL path from a source buffer
	to a destination buffer. In the loop, we often access dst[-1]. It was
	not entirely clear that this did not underrun the buffer. Upon further
	inspection, it seems clear that it does not, but this small change
	makes this more clear, and adds an assertion that all is well with
	regard to indexing into the dst buffer.

        * kwq/KWQKURL.mm:
        (copyPathRemovingDots)

2003-08-01  Richard Williamson   <rjw@apple.com>

	Fixed 3095376.  Implemented correct selection behavior for rtl scripts.
	We still use our Arabic and Hebrew layout scheme.

	Fixed 3360487.  Implemented selection of ATSU rendered code.

	Fixed 3360242.	Return nil from _bodyBackgroundColor when no 
	background color specified.  This was requested by Doug D.

        Reviewed by Maciej.

        * khtml/rendering/font.cpp:
        (Font::drawHighlightForText):
        * khtml/rendering/font.h:
        * khtml/rendering/render_text.cpp:
        (TextRun::paintSelection):
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::checkSelectionPoint):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::bodyBackgroundColor):
        * kwq/KWQPainter.h:
        * kwq/KWQPainter.mm:
        (QPainter::drawHighlightForText):
        * kwq/WebCoreTextRenderer.h:

2003-08-01  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- fixed 3265419 - homepage preview doesn't show Images with names longer than 17 chars
	
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::recursive_toHTML):

2003-08-01  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3339255 - REGRESSION (73-85): javascript failure at gia.apple.com

	I fixed this by making sure to cancel any pending redirects before
	telling the bridge to load a URL. We don't want a race between
	getting back a response and the redirect timer.

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge provisionalLoadStarted]): New method - call equivalent part method.
	We count on the other side of the bridge to call this once it knows a load will
	really happen (not cancelled by policy, etc).
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::provisionalLoadStarted): cancel pending redirects.

=== Safari-91 ===

2003-07-31  Dave Hyatt  <hyatt@apple.com>

	Fix for 3347286, hang on pepboys.com.  Text-indent had numerous bugs that
	resulted in an infinite loop because some incorrect values were being compared.
	This patch changes floats to ignore text-indent when positioning themselves
	(as they should).

	The maxwidth computation also didn't deal properly with text-indent, applying it
	multiple times instead of once, and also only applying it for text and not for
	inline replaced elements (images, form controls, etc.).

	With these changes pepboys.com renders correctly.  This patch also conveniently fixes
	the last rendering error on meyerweb's Matrix stylesheet.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:

2003-07-31  Richard Williamson   <rjw@apple.com>

	Fixed 3359152.  SPI to get the background color for a frame.

        Reviewed by hyatt.

        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::bodyBackgroundColor):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge bodyBackgroundColor]):

2003-07-31  Dave Hyatt  <hyatt@apple.com>

	Fix for "The Matrix" stylesheet on meyerweb.com and for 26(!) of the
	layout tests.  Basically when laying out a line, you have a beginning, and end,
	and midpoints in between that tell you what whitespace to skip over.  It was
	possible to end up with the last midpoint being a start point that was past the
	end of the line, and in that case, we would sometimes not strip off the trailing
	space at the end of the line like we should.

	This patch adds a simple function to check for this condition.  It strips off the
	out-of-bounds midpoint, and then shaves off the trailing space from the previous
	midpoint if it's necessary to do so.

	Also fix the way spaces are counted so that we don't add in spaces for text that 
	is not part of any bidi runs.
	
        Reviewed by john

        * khtml/rendering/bidi.cpp:

2003-07-30  Richard Williamson   <rjw@apple.com>

	Preparation for 3095376.

        Reviewed by Maciej.

        * WebCore-combined.exp:
        * WebCore.exp:
        * khtml/rendering/font.cpp:
        (Font::checkSelectionPoint):
        * khtml/rendering/font.h:
        * khtml/rendering/render_text.cpp:
        (TextRun::checkSelectionPoint):
        * kwq/KWQFontMetrics.h:
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        (QFontMetrics::checkSelectionPoint):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:
        * kwq/WebCoreTextRendererFactory.m:
        (WebCoreInitializeTextRun):
        (WebCoreInitializeEmptyTextStyle):

2003-07-30  Dave Hyatt  <hyatt@apple.com>

	Fix for 3274144, floats in Help Viewer overlapped when they shouldn't have.
	lineWidth was overflowing (and positionNewFloats was also sometimes not called
	when it should have been).
	
        Reviewed by darin

        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_block.cpp:

2003-07-30  Dave Hyatt  <hyatt@apple.com>

	Add support for setting the text-shadow's color.  This uses a new CG API,
	so updating to a fairly recent Panther is required.
	
        Reviewed by rjw

        * khtml/css/cssparser.cpp:
        (CSSParser::parseShadow):
	* kwq/KWQPainter.mm:
        (QPainter::setShadow):

2003-07-30  John Sullivan  <sullivan@apple.com>

	- fixed 3346460 -- images > area (2048x2048) are compressed vertically 
	when displayed as src of img tag

        Reviewed by Darin

        * khtml/rendering/render_image.cpp:
        (RenderImage::layout):
	Just comment out the code that imposes a maximum image size (incorrectly);
	maybe KDE folks want to make this work, but we don't need to try to
	prevent large images.

2003-07-30  John Sullivan  <sullivan@apple.com>

	- WebCore part of fix for 3284525 -- AutoFill fills in 
	only e-mail address field of New Account form on Apple Store Japan

	There were two problems: the regex library being used by
	KWQRegExp.mm didn't handle unicode at all, and the way we
	were using word boundaries in our regular expressions didn't
	work with Japanese.

        Reviewed by Darin

        * kwq/KWQKHTMLPart.mm:
        (regExpForLabels):
	Redid the way word boundaries are used; the old way didn't
	work with PCRE, and also didn't work with Japanese. 

        * kwq/KWQRegExp.h:
	removed treatStartAsStartOfInput parameter to match() that Trey had added; 
	it was being used incorrectly and was not necessary.

        * kwq/KWQRegExp.mm:
        (compareStringOffsets), (createSortedOffsetsArray),
        (convertCharacterOffsetsToUTF8ByteOffsets),
        (convertUTF8ByteOffsetsToCharacterOffsets):
	Code copied from JavaScriptCore/regexp.cpp to convert between
	byte and character offsets. Darin preferred that I copy these
	methods rather than make them public in JavaScriptCore/regexp.h.
        (QRegExp::KWQRegExpPrivate::compile):
	converted from regex.h style to pcre.h style 
        (QRegExp::KWQRegExpPrivate::~KWQRegExpPrivate):
	ditto
        (QRegExp::match):
	ditto
        (QRegExp::search):
	removed parameter to match()
        (QRegExp::searchRev):
	ditto

        * kwq/KWQString.mm:
        (QString::replace):
	removed parameter to match()

2003-07-30  Richard Williamson   <rjw@apple.com>

	Fixed 3349598.  Deal gracefully with <li> items that
	are not in a <ol> or <ul>, instead of crashing!

        Reviewed by Ken.

        * kwq/KWQKHTMLPart.mm:
        (listParent):
        (KWQKHTMLPart::attributedString):

2003-07-29  Richard Williamson   <rjw@apple.com>

	Use the new KURL getNSURL() method to create an NSURL.

        Reviewed by darin.

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString):

2003-07-29  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3311756 -- REGRESSION (76-77): radio buttons in different forms act as the same set
	by rolling out old fix for 3158411 -- radio button groups are supposed to be per-form
        The real bug at flyglobespan.com is what's fixed below.

        * khtml/html/html_formimpl.h:
        * khtml/html/html_formimpl.cpp:
        (HTMLFormElementImpl::radioClicked):
        (HTMLInputElementImpl::~HTMLInputElementImpl):
        (HTMLInputElementImpl::setType):
        (HTMLInputElementImpl::parseAttribute):
        (HTMLInputElementImpl::attach):
        (HTMLInputElementImpl::reset):
        (HTMLInputElementImpl::setChecked):
        (HTMLInputElementImpl::isEditable):
        * khtml/xml/dom_docimpl.cpp:
        * khtml/xml/dom_docimpl.h:

        - fixed 3158411 -- re-opened form is one form in other browsers, multiple forms in Safari
        (flyglobespan.com)

        * khtml/html/htmlparser.cpp: (KHTMLParser::getElement): Don't open a form if we encounter
        a form element inside another form.

2003-07-29  John Sullivan  <sullivan@apple.com>

	- fixed 3346707 -- AutoFill does not fill in email address on 
	Apple Store new account page

        Reviewed by Darin

        * kwq/KWQRegExp.h:
        * kwq/KWQRegExp.mm:
        (QRegExp::searchRev):
	This method (that Trey had added) used a placeholder 2nd parameter
	that was always -1 and should have been ignored. But it was
	being passed into QRegExp::match as the starting index, which
	happened to work in many cases, but not if the byte of memory
	before the string happened to be a null character. Fixed by
	eliminating the placeholder parameter entirely.

2003-07-28  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3343050 - nil-deref in saveInterpreterBuiltins running Sherlock via MallocDebug in Panther7B20
	- fixed 3343942 - Safari crashes when clicking on link w/ JavaScript turned off
	
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::saveInterpreterBuiltins): Don't attempt to save
	when JavaScript is off.
        (KWQKHTMLPart::restoreInterpreterBuiltins): Don't attempt to restore
	when JavaScript is off.
        (KWQKHTMLPart::saveWindowProperties): Remove ERROR, since that
	case is normal when JS is off.
        (KWQKHTMLPart::saveLocationProperties): Remove ERROR, since that
	case is normal when JS is off.
        (KWQKHTMLPart::restoreWindowProperties): Remove ERROR, since that
	case is normal when JS is off.
        (KWQKHTMLPart::restoreLocationProperties): Remove ERROR, since that
	case is normal when JS is off.

2003-07-28  Dave Hyatt  <hyatt@apple.com>

	Fix build bustage on my buggy panther compiler.
	
        Reviewed by darin

        * kwq/KWQLineEdit.mm:
        (QLineEdit::~QLineEdit):

2003-07-28  Dave Hyatt  <hyatt@apple.com>

	Fix for 3343250, XML didn't know how to make implicit tbodies when starting new elements,
	nor did it know to skip implicit elements when popping its element stack.
	
        Reviewed by darin

        * khtml/xml/xml_tokenizer.cpp:
        (XMLHandler::startElement):
        (XMLHandler::endElement):

2003-07-25  Dave Hyatt  <hyatt@apple.com>

	Rename box and inline-box to -khtml-box and -khtml-inline-box.
	
        Reviewed by john

        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssvalues.c:
        (hash_val):
        (findValue):
        * khtml/css/cssvalues.h:
        * khtml/css/cssvalues.in:

2003-07-25  Dave Hyatt  <hyatt@apple.com>

	Fix for 3343529, inline blocks crashing Safari.  There were lots of problems with
	inlne-blocks.  This code gets basic inline-blocks working properly (with no crashes).

	Several functions have been patched to take an isRootLineBox parameter.  This is used
	to tell whether you're supposed to examine the root line box for a block or the block
	itself.  In the case of baselinePosition and lineHeight, it indicates whether the caller
	wants to measure the outside or inside of the box.  

	The outside of an inline-block is like a replaced element (e.g., an image), but the 
	inside is like a block, e.g., you want measurements for
	the line height and baseline position of a root line box for that block.

	Similarly, createInlineBox has been patched in order to know whether you're making a
	root inline box *inside* the inline-block or an inline box that *encompasses* the
	inline-block element (like you'd do for an image).

	A number of places had isInline() calls and needed to be patched to also check
	isInlineBlockOrInlineTable().  How to treat the inline-block again basically depends
	on whether the caller is looking at the outside of the block (in which case you're like
	an inline replaced element) or the inside of the block (in which case you're just like
	a block).
	
        Reviewed by darin

        * ChangeLog:
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcWidth):
        (RenderBox::calcHeight):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::createInlineBox):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::baselinePosition):
        (RenderButton::baselinePosition):
        (RenderSubmitButton::baselinePosition):
        (RenderSelect::baselinePosition):
        * khtml/rendering/render_form.h:
        * khtml/rendering/render_line.cpp:
        (InlineFlowBox::verticallyAlignBoxes):
        (InlineFlowBox::computeLogicalBoxHeights):
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::lineHeight):
        (RenderListMarker::baselinePosition):
        * khtml/rendering/render_list.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::sizesToMaxWidth):
        (RenderObject::getVerticalPosition):
        (RenderObject::lineHeight):
        (RenderObject::baselinePosition):
        (RenderObject::createInlineBox):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::lineHeight):
        (RenderReplaced::baselinePosition):
        * khtml/rendering/render_replaced.h:
        * khtml/rendering/render_table.cpp:
        * khtml/rendering/render_table.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::lineHeight):
        (RenderText::baselinePosition):
        (RenderText::createInlineBox):
        * khtml/rendering/render_text.h:

2003-07-25  Dave Hyatt  <hyatt@apple.com>

	Fix for 3343527, crash when attempting to access rules in the CSS OM.
	Our KWQListImpl doesn't null check accesses, so anything out
	of bounds would cause a crash.
	
        Reviewed by mjs

        * kwq/KWQListImpl.mm:
        (KWQListImpl::at):

2003-07-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	 - fixed 3332460 - nil-deref in khtml::RenderWidget::eventFilter with onchange handler

        * khtml/rendering/render_form.cpp:
        (RenderTextArea::handleFocusOut): Check if we still have an
	element. It could have gone away while handling an event that
	replaced some or all of the document, and if we're gonna be
	destroyed soon then there's no point doing this work anyway.

2003-07-25  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	- fixed 3332460 - nil-deref in khtml::RenderWidget::eventFilter with onchange handler
	
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::eventFilter): We want to ref element() across this call, but it could get
	unset, so store it in a local variable.
        * kwq/KWQLineEdit.h:
        * kwq/KWQLineEdit.mm:
        (QLineEdit::~QLineEdit): invalidate our KWQTextField.
        * kwq/KWQTextField.h:
        * kwq/KWQTextField.mm:
        (-[KWQTextField invalidate]): Set widget to NULL.
        (-[KWQTextField action:]): Do nothing if widget is NULL.
        (-[KWQTextField controlTextDidBeginEditing:]): Likewise.
        (-[KWQTextField controlTextDidEndEditing:]): Likewise.
        (-[KWQTextField controlTextDidChange:]): Likewise.
        (-[KWQTextField control:textShouldBeginEditing:]): Likewise.
        (-[KWQTextField control:textShouldEndEditing:]): Likewise.
        (-[KWQTextField control:didFailToFormatString:errorDescription:]): Likewise.
        (-[KWQTextField control:didFailToValidatePartialString:errorDescription:]): Likewise.
        (-[KWQTextField control:isValidObject:]): Likewise.
        (-[KWQTextField control:textView:doCommandBySelector:]): Likewise.
        (-[KWQTextField stringValue]): Likewise.
        (-[KWQTextField setStringValue:]): Likewise.
        (-[KWQTextField setFont:]): Likewise.
        (-[KWQTextField nextKeyView]): Likewise.
        (-[KWQTextField previousKeyView]): Likewise.
        (-[KWQTextField nextValidKeyView]): Likewise.
        (-[KWQTextField previousValidKeyView]): Likewise.
        (-[KWQTextField fieldEditorDidMouseDown:]): Likewise.
        (-[KWQTextField textView:shouldHandleEvent:]): Likewise.
        (-[KWQTextField textView:didHandleEvent:]): Likewise.
        (-[KWQTextField setHasFocus:]): Likewise.

2003-07-24  John Sullivan  <sullivan@apple.com>

	- fixed 3332622 -- Safari Abbreviates Attribute Names in EMBED tags

        Reviewed by Richard

        * khtml/html/htmltokenizer.h:
	bumped fixed max length of attributes from 14 to 1024.
	Theoretically they could be any arbitrary length, but it's
	more risk than it's worth to rewrite the code that uses the
	fixed-size buffer that is based on this value.

2003-07-24  Dave Hyatt  <hyatt@apple.com>

	Change all uses of "konq-" in CSS to "khtml-".  

	Also rename the CSS3 properties that have either buggy or 
	incomplete implementations to "-khtml-property" for forward
	compatibility (so that people don't have to worry about a buggy
	Safari if/when they use the official property names).
	
        Reviewed by john

        * khtml/css/cssparser.cpp:
        (CSSParser::parseRule):
        (CSSParser::parseValue):
        (CSSParser::parseDeclaration):
        (CSSParser::parseFontFamily):
        (CSSParser::parseShadow):
        * khtml/css/cssproperties.c:
        (hash_prop):
        (findProp):
        * khtml/css/cssproperties.h:
        * khtml/css/cssproperties.in:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/cssvalues.c:
        (hash_val):
        (findValue):
        * khtml/css/cssvalues.h:
        * khtml/css/cssvalues.in:
        * khtml/css/html4.css:
        * khtml/css/parser.cpp:
        * khtml/css/parser.h:
        * khtml/css/parser.y:
        * khtml/css/quirks.css:
        * khtml/css/tokenizer.cpp:
        * khtml/css/tokenizer.flex:
        * khtml/html/html_blockimpl.cpp:
        (HTMLDivElementImpl::parseAttribute):
        (HTMLParagraphElementImpl::parseAttribute):
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::addHTMLAlignment):
        * khtml/html/html_inlineimpl.cpp:
        (HTMLFontElementImpl::parseAttribute):
        * khtml/html/html_tableimpl.cpp:
        (HTMLTablePartElementImpl::parseAttribute):
        (HTMLTableCellElementImpl::parseAttribute):
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcHorizontalMargins):
        * khtml/rendering/render_flexbox.cpp:
        * khtml/rendering/render_style.h:
        * khtml/rendering/render_table.cpp:
        (RenderTableCell::setStyle):

=== Safari-90 ===

2003-07-23  Dave Hyatt  <hyatt@apple.com>

	Fix opacity to respect clipping.
	
        Reviewed by rjw

        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):

2003-07-23  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 2/3 of 3279864 -- remove class_poseAs calls from WebKit (will also remove init routine)

        * kwq/KWQTextArea.h: Add drawing state variable so we can tell the difference
        between calls to draw the insertion point inside and calls to draw outside the
        redraw machinery.
        * kwq/KWQTextArea.mm:
        (-[KWQTextArea displayRectIgnoringOpacity:]): Added. Set drawing flag while in here.
        This is the method used by KWQWidget to draw.
        (-[KWQTextArea textView:shouldDrawInsertionPointInRect:color:turnedOn:]): Added.
        Calls setNeedsDisplay (the NSView version, not the NSTextView override) instead
        of immediately drawing when asked to draw outside the normal redraw machinery.
        (-[KWQTextAreaTextView keyDown:]): Call interceptKeyEvent before handling each
        key down event.
        * kwq/KWQTextField.h: Add drawing state variable so we can tell the difference
        between calls to draw the insertion point inside and calls to draw outside the
        redraw machinery.
        * kwq/KWQTextField.mm:
        (-[KWQTextField displayRectIgnoringOpacity:]): Added. Set drawing flag while in here.
        This is the method used by KWQWidget to draw.
        (-[KWQTextField textView:shouldDrawInsertionPointInRect:color:turnedOn:]): Added.
        Calls setNeedsDisplay (the NSView version, not the NSTextView override) instead
        of immediately drawing when asked to draw outside the normal redraw machinery.
        (-[KWQTextField textView:shouldHandleEvent:]): Call interceptKeyEvent before
        handling each key down event.
        (-[KWQTextField textView:didHandleEvent:]): Call fieldEditorDidMouseDown: after
        handling each mouse down event.

        * kwq/KWQWidget.mm: (QWidget::paint): Add comment about dependency on
        displayRectIgnoringOpacity: use in KWQTextArea and KWQTextField.

        * kwq/WebCoreFirstResponderChanges.h: Added a comment about obsolescence.

        - Xcode wanted to change this, because it now knows JavaScriptCore is a framework

        * WebCore.pbproj/project.pbxproj: Munged by Xcode.

2003-07-23  Dave Hyatt  <hyatt@apple.com>

	Fix for 3340885, invalid colors were being mapped to transparentColor,
	thus causing invisible text!
	
        Reviewed by kocienda

        * khtml/css/cssparser.cpp:
        (CSSParser::parseColorFromValue):

2003-07-23  Richard Williamson   <rjw@apple.com>

	Fixed for 3259840.  Use ATSU for scripts we don't handle internally,
	i.e.:  Syriac, Thaana, Devanagari, Bengali, Gurmukhi, Gujarati, Oriya, Tamil, Telugu, Kannada, Malayalam, Sinhala, Thai, Lao, Tibetan, Myanmar, Hangul Jamo, Khmer, Mongolian

	Also fixed issues with our rendering of Arabic.

	Changed the internal API to take WebCoreTextRun and WebCoreTextStyle
	parameters instead of scads on individual parameters.  Much cleaner.

        Reviewed by Maciej.

        * WebCore-combined.exp:
        * WebCore.exp:
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:
        * kwq/WebCoreTextRendererFactory.m:
        (WebCoreMakeTextRun):
        (WebCoreMakeEmptyTextStyle):

2003-07-23  Dave Hyatt  <hyatt@apple.com>

	Clean up the mess left by a couple of previous checkins.  I had
	patched computeLength and computeLengthFloat to take a CSSStyleSelector,
	but then I came up with a simpler solution that didn't require that
	the selector be passed in as an argument.  I forgot, however, to revert
	the functions back to their original forms.  This patch does that.
	
        Reviewed by john

        * khtml/css/css_valueimpl.cpp:
        (CSSPrimitiveValueImpl::computeLength):
        (CSSPrimitiveValueImpl::computeLengthFloat):
        * khtml/css/css_valueimpl.h:
        * khtml/css/cssstyleselector.cpp:

2003-07-23  Dave Hyatt  <hyatt@apple.com>

	Temporary hack to ensure that the layout tests will not all
	be failures if/when the layout tests regression gets fixed.
	Will remove once we can run the tests.
	
        Reviewed by ken

        * khtml/rendering/render_block.cpp:

2003-07-22  Dave Hyatt  <hyatt@apple.com>

	Allow HTML and BODY to be any display type.  This patch primarily eliminates the
	RenderBody class and makes the code that deals with background propagation smart
	enough to locate the correct renderers for the HTML and BODY elements (by crossing
	back into the DOM tree).
	
        Reviewed by darin

        * ForwardingHeaders/rendering/render_body.h: Removed.
        * WebCore.pbproj/project.pbxproj:
        * khtml/html/html_baseimpl.cpp:
        (HTMLBodyElementImpl::insertedIntoDocument):
        * khtml/html/html_baseimpl.h:
        * khtml/rendering/render_body.cpp: Removed.
        * khtml/rendering/render_body.h: Removed.
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::paintRootBoxDecorations):
        (RenderBox::paintBoxDecorations):
        (RenderBox::repaint):
        * khtml/rendering/render_inline.cpp:
        (RenderInline::paintObject):
        * khtml/rendering/render_inline.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::isBody):
        * khtml/rendering/render_object.h:
        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::createRenderer):

2003-07-22  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3108604 -- add Shift JIS X0213 and HK-SCS to the Text Encoding menu

        * kwq/mac-encodings.txt: Added "Shift_JIS_X0213-2000". Changed all non-HKSCS
        Big5 encodings to use the DOS variant of Big5 as requested by Peter Edberg,
        but left Big5-HKSCS alone.
        * kwq/KWQCharsets.mm: Added kCFStringEncodingBig5_DOSVariant constant.
        * kwq/KWQCharsetData.c: Regenerated.

        - fixed 3100151 -- subframes without explicit charset settings should inherit from parent, not use default

        * khtml/khtml_part.cpp: (KHTMLPart::write): Get the default encoding from the parent
        part, if there is one.

2003-07-22  Dave Hyatt  <hyatt@apple.com>

	Fix for 3293898, list bullets in ordered lists with an inside list
	position were rendering as though they had a width of 0.  This was
	a bug in KWQFontMetrics, which needed to handle the case where a
	length of -1 was passed in to the width method (in which case
	you should use the length of the whole string).
	
        Reviewed by john

        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):

2003-07-22  Dave Hyatt  <hyatt@apple.com>

	Fix for mozilla.org front page.  This patch re-architects 
	align="left" and align="right" (for rtl and ltr directionality
	respectively).  The attributes are mapped to custom text-align
	values, konq-left and konq-right, just as was done with the
	center/middle attributes for alignment.

	A number of "hack" style rules have been dropped from html4.css
	and replaced with this C++ code that now works in the general
	case for any children of align="left/right" divs and tds.

	In addition, absmiddle support has been added for <td>s.

	For RTL blocks, there is also a regression fix (this was probably
	the #1 culprit for mangled placement of blocks in Hebrew Web
	pages).  The old code was doing byzantine math that happened to
	work out.  When I tried to simplify it before 1.0, I missed a spot
	and basically broke margin handling on RTL blocks completely.
	
        Reviewed by mjs

        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssvalues.c:
        (hash_val):
        (findValue):
        * khtml/css/cssvalues.h:
        * khtml/css/cssvalues.in:
        * khtml/css/html4.css:
        * khtml/html/html_blockimpl.cpp:
        (HTMLDivElementImpl::parseAttribute):
        (HTMLParagraphElementImpl::parseAttribute):
        * khtml/html/html_tableimpl.cpp:
        (HTMLTablePartElementImpl::parseAttribute):
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcHorizontalMargins):
        * khtml/rendering/render_style.h:

2003-07-21  Dave Hyatt  <hyatt@apple.com>

	Fix for 3333557, crash on www.dremedia.com.  markDescendants in RenderBlock
	was not passing in its argument in the recursive step, so the float wasn't
	getting properly cleared out of everyone's lists.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:

2003-07-21  Dave Hyatt  <hyatt@apple.com>

	Fix for 3182596, percentage height tables with cells that specify
	tiny percentage heights used that height even if it was smaller
	than the cell's minimum required height.
	
        Reviewed by darin

        * khtml/rendering/render_table.cpp:
        (RenderTableSection::layoutRows):

2003-07-21  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed 3316867 -- tabbing to textarea below visible part of page doesn't scroll down

        * kwq/KWQTextArea.mm: (-[KWQTextAreaTextView becomeFirstResponder]): Added call to
        _KWQ_scrollFrameToVisible to match the one in KWQTextField.

2003-07-21  Dave Hyatt  <hyatt@apple.com>

	Fix removeAttributeNode.  This is David Faure's patch.
	
        Reviewed by me

        * khtml/xml/dom_elementimpl.cpp:
        (NamedAttrMapImpl::removeAttribute):

2003-07-21  Dave Hyatt  <hyatt@apple.com>

	Checking in David Faure's patch that fixes getElementsByTagName(*).
	
        Reviewed by me

        * khtml/xml/dom_nodeimpl.cpp:
        (NodeBaseImpl::getElementsByTagNameNS):
        (TagNodeListImpl::nodeMatches):

2003-07-18  Dave Hyatt  <hyatt@apple.com>

	Enable domain() and setDomain() to work for all documents (XML
	as well as HTML).

	Implement onload for frames.
	
        Reviewed by mjs

        * khtml/ecma/kjs_window.cpp:
        (Window::isSafeScript):
        (WindowFunc::tryCall):
        * khtml/html/html_baseimpl.cpp:
        (HTMLFrameElementImpl::parseAttribute):
        (HTMLIFrameElementImpl::parseAttribute):
        * khtml/html/html_documentimpl.cpp:
        * khtml/html/html_documentimpl.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::checkEmitLoadEvent):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::domain):
        (DocumentImpl::setDomain):
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::dispatchWindowEvent):

2003-07-18  Dave Hyatt  <hyatt@apple.com>

	Fix for 3334082, XML documents can access HTML/XML docs in other
	domains.  The basic bug is that we made a change right before
	1.0 to allow a parent document to access a child frame's document
	if the child frame had no document.  What we didn't notice was
	that the ptr was obtained from the part by asking for an HTML
	document.  For XML documents that failed the cast, we got back
	null as well, which means that for non-HTML XML documents we
	always return true from isSafeScript.

	This patch makes sure our addition uses the raw xmlDoc pointer,
	so that there are no mistakes, and it restores the code that
	denies access when you aren't an HTML document.

	(It is a separate bug that we just disallow cross-frame
	communication in XML documents right now that I'll file as
	a follow-up to this one.)
	
        Reviewed by darin, rjw, mjs

        * khtml/ecma/kjs_window.cpp:
        (Window::isSafeScript):

2003-07-15  Dave Hyatt  <hyatt@apple.com>

	Fix for 3300362, crash on myuhc.com.  The residual style code
	was messing up and inserting nodes in the wrong place (and also
	updating the current member variable when it wasn't supposed to).

	Fix for 3331793, nil deref because (astoundingly) someone was
	using text-shadow and exposed a bug with the color handling
	of the shadow.
	
        Reviewed by darin

        * khtml/html/htmlparser.cpp:
	* khtml/html/htmlparser.h
        (KHTMLParser::reopenResidualStyleTags):
        (KHTMLParser::popBlock):

2003-07-17  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- fixed 3283076 - crash when doing 2nd query on the eBay channel (Sherlock) -- JavaScript locking issue?

	I added a bit of minimal extra locking to WebCore to make sure
	multithreaded apps that use WebKit on the main thread but do
	JavaScript on other threads as well continue to work nicely.

        * khtml/ecma/kjs_proxy.cpp:
        (KJSProxyImpl::initScript): Lock interpreter around possible allocations or collections.
        * khtml/ecma/kjs_window.cpp:
        (Window::clear): Lock interpreter around possible allocations or collections.

2003-07-17  Ken Kocienda  <kocienda@apple.com>

        Reviewed by John

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::createPart): Now uses NSURL instead of NSString
        (KWQKHTMLPart::redirectionTimerStartedOrStopped): Ditto
        (KWQKHTMLPart::userAgent): Ditto
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::setIconURL): Ditto
        (KHTMLPartBrowserExtension::setTypedIconURL): Ditto
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::showApplet): Ditto
        * kwq/KWQLoader.mm:
        (KWQServeRequest): Ditto
        (KWQCheckCacheObjectStatus): Ditto
        * kwq/WebCoreBridge.h: Changed quite a number of methods to use NSURL 
	instead of NSString
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge didNotOpenURL:]): Now uses NSURL instead of NSString
        (-[WebCoreBridge scrollToAnchorWithURL:]): Ditto
        (-[WebCoreBridge URL]): Ditto

2003-07-17  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

        * kwq/KWQKHTMLPart.h: _submittedFormURL is now a KURL, not a QString
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURL): Now uses NSURL in API instead of NSString
        (KWQKHTMLPart::openURLRequest): Ditto
        (KWQKHTMLPart::didNotOpenURL): Ditto
        (KWQKHTMLPart::submitForm): Ditto. Plus update _submittedFormURL usages.
        (KWQKHTMLPart::urlSelected): Ditto
        (KWQKHTMLPart::setView): Ditto
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Now uses NSURL in API instead of NSString
        * kwq/KWQKURL.h: Added constructor that takes an NSURL
        * kwq/KWQKURL.mm:
        (KURL::KURL): Ditto.
        * kwq/WebCoreBridge.h: Updated bridge APIs to use NSURL instead of NSString
	in several places.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:contentType:refresh:lastModified:pageCache:]): Ditto

2003-07-16  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - cure problem where we keep competing to check in config.h with/without HAVE_FOUNDATION_SOURCSE

        * Makefile.am: Remove the HAVE_FOUNDATION_SOURCES line.
        * config.h: Check in without that line.

2003-07-16  Vicki Murley  <vicki@apple.com>

        Reviewed by kocienda. 

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::attributedString): set linkStartLocation to zero to fix deployment build 

2003-07-15  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Richard
	
        * kwq/KWQKURL.h:
        * kwq/KWQKURL.mm:
        (StringHasCaseInsensitivePrefix): Helper method for the new functions below
        (StringByAddingPercentEscapes): Ditto
        (URLStringByAddingPercentEscapes): Ditto
        (KURL::getNSURL): Added convenience function to get an NSURL from a KURL
        (KURL::getNSData): Added convenience function to get an NSData from a KURL

2003-07-15  Richard Williamson   <rjw@apple.com>

	Fixed 3315951:  Add support for <OL>, <UL> in attributed string conversion.
	Fixed 3315952:  Add support for <IMG> in attributed string conversion.
	Fixed 3315953:  Added support for <A> in attributed string conversion.	

        Reviewed by John (and earlier by Darin).

        * khtml/rendering/render_list.h:
        * kwq/KWQKHTMLPart.mm:
        (fileWrapperForElement):
        (listParent):
        (inList):
        (KWQKHTMLPart::attributedString):

2003-07-14  Dave Hyatt  <hyatt@apple.com>

	Fix a problem where ems used for non-font values like width
	and line-height would not zoom. (r=darin)

	The rest is r=rjw.
	
	An implementation of the CSS2 text-shadow property. 

	It uses a CoreGraphics API for drawing shadows 
	(via a custom API on QPainter) to paint the shadows.

        At the moment there are two limitations in CG's API.  The first
        is that the shadow color cannot be set.  This will be fixed for
        Panther, and the code passes the color through in preparation
        for this fix.

	The second limitation is that CG only supports one shadow effect
	and not multiple shadow effects.  The parsing code on the CSS
        side is set up to go ahead and parse all of the shadow effects,
        but the code that makes use of shadows will simply look at the
        first one for now.  CG will not support multiple shadow effects
        in the Panther time frame, so it will be a while before this
        is revisited.

	This patch also fixes a slew of bugs with colors in KHTML.  When
	we took the CSS parser and all of its associated code from Lars,
	that code was using QRgb values that assumed RGBA (like the current
	Qt toolkit uses).  The code even made use of an "invalid color"
	that wasn't really invalid (kind of like the z-index hack we refused
	to take, i.e., unlikely but not invalid).

	Our KWQColor implementation has been rewritten in this patch to
	work the way the current Qt toolkit expects.  That is, the top
	eight bits actually do contain an alpha channel, and you can obtain
	the alpha component using the qAlpha method and build a quadruple
	using the qRgba method.

	This patch adds support for rgba quadruples to CSS, so you can now
	say, e.g.,color: rgba(255,0,0,0.5); in CSS.
	
        * khtml/css/css_valueimpl.cpp:
        (ShadowValueImpl::~ShadowValueImpl):
        * khtml/css/css_valueimpl.h:
        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        (parseColor):
        (CSSParser::parseColor):
        (CSSParser::parseColorFromValue):
        (CSSParser::parseShadow):
        * khtml/css/cssparser.h:
        * khtml/css/cssstyleselector.cpp:
        * khtml/misc/helper.h:
        * khtml/rendering/render_line.cpp:
        (InlineFlowBox::paintDecorations):
        * khtml/rendering/render_style.cpp:
        (StyleVisualData::StyleVisualData):
        (opacity):
        (flexibleBox):
        (StyleCSS3NonInheritedData::operator==):
        (textShadow):
        (StyleCSS3InheritedData):
        (StyleCSS3InheritedData::operator==):
        (StyleCSS3InheritedData::shadowDataEquivalent):
        (RenderStyle::RenderStyle):
        (RenderStyle::inheritFrom):
        (RenderStyle::operator==):
        (RenderStyle::inheritedNotEqual):
        (RenderStyle::diff):
        (ContentData::clearContent):
        (RenderStyle::setTextShadow):
        (ShadowData::operator==):
        * khtml/rendering/render_style.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::paintObject):
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::diff):
        * kwq/KWQColor.h:
        * kwq/KWQColor.mm:
        (qRgb):
        (qRgba):
        (qAlpha):
        (QColor::QColor):
        (QColor::setNamedColor):
        (QColor::getNSColor):
        * kwq/KWQNamespace.h:
        * kwq/KWQPainter.h:
        * kwq/KWQPainter.mm:
        (QPainter::drawRect):
        (QPainter::drawLine):
        (QPainter::_fillRect):
        (QPainter::fillRect):
        (QPainter::setShadow):
        (QPainter::clearShadow):

2003-07-14  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3244447 -- add KOI8-U charset support
        - fixed 3327152 -- unicodeFFFE and unicodeFEFF are handled backwards by WebCore
        - fixed 3327157 -- x-mac-ukrainian should be mapped to MacCyrillic
        - fixed 3327160 -- shift-jis, shift_jis, x-sjis should be mapped to the DOS variant of Shift JIS
        - fixed 3327162 -- most Simplified Chinese encoding choices should be mapped to the DOS variant of EUC-CN
        - fixed 3327166 -- use DOS variant of EUC_KR

        * kwq/KWQCharsets.mm: Added some defines so we could use encodings that don't
        have any kCFStringEncoding constant in a header file.
        * kwq/mac-encodings.txt: Change table entries in accordance with the above bug reports.
        * kwq/KWQCharsetData.c: Regenerated.

        - other changes, inspired by investigation of various bugs

        * kwq/KWQButton.mm: (-[KWQButton sendConsumedMouseUpIfNeeded]): Make robust against cases where
        sending the consumed mouse up event destroys the QButton.

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::reopenResidualStyleTags): Rearrange code slightly for clarity, added comment.
        (KHTMLParser::freeBlock): Removed unnecessary line of code.

2003-07-14  Dave Hyatt  <hyatt@apple.com>

	Fix for 3294626, no scrollbar on ESPN.  Fix lowestPosition to
	always crawl into all children.
	
        Reviewed by darin

        * khtml/rendering/render_flow.cpp:
        (RenderFlow::lowestPosition):
        (RenderFlow::rightmostPosition):

2003-07-11  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3132021 -- certain Japanese characters are misrendered because of incorrect partial-character handling

        We didn't have code to handle kTECPartialCharErr.

        * kwq/KWQTextCodec.mm:
        (KWQTextDecoder::createTECConverter): Added. Broken out from convertUsingTEC.
        (KWQTextDecoder::appendOmittingBOMs): Added. Broken out from convertUsingTEC.
        (KWQTextDecoder::convertOneChunkUsingTEC): Added. Broken out from convertUsingTEC.
        This also has much of the partially-decoded character handling.
        (KWQTextDecoder::convertUsingTEC): Simplified by breaking into functions, and added
        handling to use the same buffer we use for the other decoders to hold partially-decoded
        characters.
        (KWQTextDecoder::convert): Add a partial-character handling test mode where the decoder
        is passed only a single byte at a time; controlled by an #if.

2003-07-11  Dave Hyatt  <hyatt@apple.com>

	Fix for 3187101, before/after content not dynamic.  This patch
	compares the ContentData of the old style and the new style and
	if they are different, it blows away and recreates the render
	objects for the generated content.  Otherwise it will dynamically
	update the styles of the generated content render objects (which
	should fix the printer/screen bug for rjw).

	Note that createObject had an extra call to setStyle, which was
	causing most objects to set the same style context on themselves
	twice.  This was exposed as I was fixing the above problem.
	
        Reviewed by darin

        * ChangeLog:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_object.cpp:
        (RenderObject::createObject):
        * khtml/rendering/render_style.cpp:
        (RenderStyle::contentDataEquivalent):
        * khtml/rendering/render_style.h:

2003-07-11  Dave Hyatt  <hyatt@apple.com>

	Fix pseudostyles to inherit from the element's style that they are
	specified for.  This is incorrect both for ::first-line and
	::first-letter, but it is at least right for ::before and ::after.

	Fix iframes and objects and embeds so that they will render borders
	when borders are specified (as well as background images).

	Patch iframes so that they correctly let the parent document's
	background show through when the Web page inside the iframe has
	no specified background.  Also patched iframes to understand not
	to blit in this case and to not blit when opacity has been specified
	on the iframe.
	
        Reviewed by darin

        * khtml/css/cssstyleselector.cpp:
        * khtml/khtmlview.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::paintRootBoxDecorations):
        * khtml/rendering/render_canvas.cpp:
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::setStyle):
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::calcMinMaxWidth):
        (RenderWidget::setStyle):
        (RenderWidget::paintObject):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::paint):

2003-07-11  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - roll in change from KHTML to remove user and password from referrer

        * khtml/khtml_part.cpp: (KHTMLPart::begin): Call setUser(""), setPass(""),
        and setRef(""), then also set the referrer to "" if the protocol does not
        start with http.

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge referrer]): Remove check to exclude
        file URL referrers because KHTMLPart now excludes all non-http referrers.

        * kwq/KWQKURL.h: Add setUser and setPass functions. Also sort by order within
        the URL so it's clear no methods are omitted.
        * kwq/KWQKURL.mm:
        (KURL::setUser): Added. Adds or removes the username, adding or removing
        delimiters as needed. For now only the remove part is compiled in.
        (KURL::setPass): Added. Adds or removes a password, adding or removing
        delimiters as needed. For now only the remove part is compiled in.

        * kwq/KWQString.h: Add QSTRING_NULL macro to allow us to work around the fact
        that there is no global QString::null object in KWQ without having to do a
        relatively ineffecient conversion from a non-constant char * of 0 each time.
        We can use this anywhere QString::null appears and perhaps get some small code
        savings or performance boost.

        - small cleanup

        * kwq/KWQTextCodec.mm: (QTextCodec::fromUnicode): Remove unneeded checks that
        repeat optimizations I already put in QString.

2003-07-11  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - added a function Dave needs for various work he's doing that goes
          from a document to the corresponding element in the parent document

        * khtml/xml/dom_docimpl.h: Add ownerElement member function.
        * khtml/xml/dom_docimpl.cpp: (DocumentImpl::ownerElement):
        Added. Gets to the parent part and finds the right element.

2003-07-11  Dave Hyatt  <hyatt@apple.com>

	An initial implementation of the CSS opacity property.  Seems
	to work perfectly except for native widgetry (NSViews).  Images,
	text, borders, and underlines are all properly blended.
	
        Reviewed by rjw

        * config.h:
        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssproperties.c:
        (hash_prop):
        (findProp):
        * khtml/css/cssproperties.h:
        * khtml/css/cssproperties.in:
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::adjustZIndex):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_inline.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::transparentAncestor):
        (RenderLayer::isTransparent):
        (commonTransparentAncestor):
        (RenderLayer::updateTransparentState):
        (RenderLayer::beginTransparencyLayers):
        (RenderLayer::endTransparencyLayers):
        (RenderLayer::paint):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_style.cpp:
        (StyleVisualData::StyleVisualData):
        (RenderStyle::diff):
        * khtml/rendering/render_style.h:
        * kwq/KWQPainter.h:
        * kwq/KWQPainter.mm:
        (QPainter::beginTransparencyLayer):
        (QPainter::endTransparencyLayer):

2003-07-11  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

        - fixed 3305391 -- repro crash in QPixmap::QPixmap after click in SVG using Adobe SVG plugin

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge elementAtPoint:]): Remove code that tried to determine
        if something is an image by looking at the node type. Instead look at the object in the render
        tree and ask it if it's an image. Also use logic that exactly matches what RenderImage uses.

        * kwq/KWQDOMNode.h: Remove unused isImage function.
        * kwq/KWQDOMNode.cpp: Ditto.

2003-07-11  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3300220 -- repro crash in closeURL when choosing from popup menus on www.drivewire.com

        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::dispatchGenericEvent): Removed unused local variable. Since we update all documents,
        there was no longer any need to keep that pointer around, but we still had this obsolete code.
        This had nothing to do with the bug, just a related cleanup.
        (NodeImpl::dispatchWindowEvent): Add check for nil. We ref the document pointer, but we don't
        ref the document itself. So we do need to check for the case where the document went away.

2003-07-10  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - fixed 3217731 -- after going back to a page, forms are submitted with the wrong encoding (back/forward cache)

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::openURLFromPageCache): Put decoder from document into the part.

=== Safari-89 ===

2003-07-10  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3302021 - v74 and v85 hang with http://e-www.motorola.com/
	- fixed a bug with saving and restoring location object properties
	
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::saveLocationProperties): Save the location object's properties, not
	the window's (!)
        (KWQKHTMLPart::saveInterpreterBuiltins): New function to save builtin properties of
	the interpeter.
        (KWQKHTMLPart::restoreInterpreterBuiltins): Similarly to restore them.
        (KWQKHTMLPart::openURLFromPageCache): Restore interpreter builtins too.
        * kwq/KWQPageState.h:
        * kwq/KWQPageState.mm:
        (-[KWQPageState initWithDocument:URL:windowProperties:locationProperties:interpreterBuiltins:]): Handle interpreter builtins.
        (-[KWQPageState invalidate]): Likewise.
        (-[KWQPageState dealloc]): Likewise.
        (-[KWQPageState interpreterBuiltins]): New method.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge saveDocumentToPageCache]): Handle interpeter builtins.

2003-07-10  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

        * config.h: Check in newly generated version which has changed due to changes
        in configure.in.

2003-07-10  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

        - fixed 3317693 -- REGRESSION: many web pages are rendering with wrong layout (columns in HelpViewer, etc.)

        This is a workaround for the code generation bug in gcc that causes this problem with
        gcc 3.3 in optimized builds. We can remove it once both we and B&I are using a newer
        gcc with the fix. The bug number for the gcc problem is 3321716.

        * khtml/rendering/render_box.cpp:
        (workAroundBug3321716): Added. A function that does nothing and takes an integer parameter.
        (RenderBox::setStyle): Add a couple of calls to workAroundBug3321716 in the right places.

2003-07-09  Richard Williamson   <rjw@apple.com>

	Fixed 3141257.  Animate multiple copies of the same
	image on the same page.

        Reviewed by hyatt.

        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::paint):
        * kwq/KWQPixmap.mm:
        (QPixmap::operator=):
        * kwq/WebCoreImageRenderer.h:

2003-07-08  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - removed Jaguar-specific code

        * kwq/KWQComboBox.mm: Remove fudge factor used to move text down and work
        around problem where pop-up menu text draws too high, bug 3030474.

        * kwq/KWQTextCodec.mm: (KWQTextDecoder::convertUsingTEC): Remove hack used
        to work around the lack of TECSetBasicOptions in Jaguar, bug 3201405.

        * config.h: The people with Foundation source trees slug it out with the people
        without Foundation trees, as one line of this file changes back and forth.

2003-07-08  Dave Hyatt  <hyatt@apple.com>

	Make sure that the contents width and height of the view are
	used as the root height and width when a view exists.  This
	ensures that the root element background properly tiles over 
	the entire height of the document.  (This used to be ensured
	by growing the height of the <html> element, but that violates
	the CSS2 spec.)

	This fixes bugs 3317809, 3299789, and 3318066.
	
        Reviewed by john

        * khtml/rendering/render_box.cpp:
        (RenderBox::paintRootBoxDecorations):

2003-07-08  Chris Blumenberg  <cblu@apple.com>

        * WebCore.pbproj/project.pbxproj: Xcode-ified
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::parseTag): fulfilled promise to Darin that I would add a comment about using tolower() instead of | 0x20

2003-07-08  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3272398>: Safari strips/modifies underscores in EMBED tags

        Reviewed by darin.

        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::parseTag): use tolower() to lowercase a char, don't use | 0x20 because that will cause chars like '_' to turn into junk

2003-07-08  Dave Hyatt  <hyatt@apple.com>

	Implementation of inline-block and a prototype of the XUL
	box model.

	Fix for min-font size issues that prevented us from having
	a min font size.  The primary fix is to store the original
	specified CSS size as a separate value (distinct from the
	computed rendering size).  This allows that size to be computed
	without the application of integer rounding or zoom factors
	or minimum font size corrections.

	Fix for table crasher, bug #3296552.

        Reviewed by john (table crasher, inline-block, XUL box model) and
	darin (font size fixes).

        * WebCore.pbproj/project.pbxproj:
        * khtml/css/css_valueimpl.cpp:
        (CSSPrimitiveValueImpl::computeLength):
        (CSSPrimitiveValueImpl::computeLengthFloat):
        * khtml/css/css_valueimpl.h:
        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):
        * khtml/css/cssproperties.c:
        (hash_prop):
        (findProp):
        * khtml/css/cssproperties.h:
        * khtml/css/cssproperties.in:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/cssstyleselector.h:
        * khtml/css/cssvalues.c:
        (hash_val):
        (findValue):
        * khtml/css/cssvalues.h:
        * khtml/css/cssvalues.in:
        * khtml/khtml_part.cpp:
        (KHTMLPart::setZoomFactor):
        * khtml/khtmlview.cpp:
        (KHTMLView::print):
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/font.cpp:
        (Font::update):
        * khtml/rendering/font.h:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::contentHeight):
        (RenderBox::containingBlockWidth):
        (RenderBox::calcWidth):
        (RenderBox::calcHeight):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        * khtml/rendering/render_flexbox.cpp: Added.
        * khtml/rendering/render_flexbox.h: Added.
        * khtml/rendering/render_object.cpp:
        (RenderObject::createObject):
        (RenderObject::sizesToMaxWidth):
        (RenderObject::handleDynamicFloatPositionChange):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::paint):
        * khtml/rendering/render_style.cpp:
        (StyleFlexibleBoxData::StyleFlexibleBoxData):
        (StyleFlexibleBoxData::operator==):
        (RenderStyle::RenderStyle):
        (RenderStyle::operator==):
        (RenderStyle::diff):
        * khtml/rendering/render_style.h:
        * khtml/rendering/table_layout.cpp:
        (FixedTableLayout::calcWidthArray):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):
        (DocumentImpl::attach):

2003-07-07  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- fixed 3295916 - b/c JavaScriptCore and WebCore are installing in wrong location, private headers are public

        * WebCore.pbproj/project.pbxproj: Install in WebKit.framework/Versions/A/Frameworks.

=== Safari-88 ===

2003-07-03  John Sullivan  <sullivan@apple.com>

	- fixed 3167770 -- visited and unvisited link colors are too 
	close in default stylesheet
	- fixed 3315344 -- default active link color should be red as
	in other browsers

        Reviewed by Hyatt

        * khtml/css/html4.css:
	Changed a:link and a:visited colors to match Mozilla
	(a slightly lighter blue for link, and a purpley shade instead
	of navy for visited). Also changed a:link:active and 
	a:visited:active to be red instead of black.

2003-07-03  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        * khtml/html/html_formimpl.cpp: (HTMLSelectElementImpl::parseAttribute):
        Remove livepage.apple.com hack since the site has been changed.

2003-07-02  Darin Adler  <darin@apple.com>

        Rolled out accidentally-checked-in changes.

        * kwq/KWQCharsetData.c:
        * kwq/KWQCharsets.mm:
        * kwq/KWQTextArea.mm:
        * kwq/mac-encodings.txt:
        * kwq/make-charset-table.pl:

2003-07-02  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - fixed 3299715 -- unrepro nil-deref in KHTMLPart::xmlDocImpl handling timer

        * khtml/khtmlview.cpp: (KHTMLView::timerEvent): Add check for nil.

        - fixed clean builds

        * Makefile.am: Delete the config-timestamp.

        - added some other nil checks (perhaps inspired by some other bug reports, I can't remember)

        * khtml/html/html_inlineimpl.cpp: (HTMLAnchorElementImpl::defaultEventHandler):
        Added a check for nil document or nil view.
        * khtml/xml/dom_nodeimpl.cpp: (NodeImpl::dispatchEvent): ref/deref view for safety.

2003-07-02  Ken Kocienda  <kocienda@apple.com>

        Reviewed by David

	Fix some more build problems with warnings being issued
	when casting and calling methods.

        * kwq/KWQScrollView.mm:
        (QScrollView::addChild):
        (QScrollView::resizeContents):
        (QScrollView::repaintContents):

2003-07-01  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin

	A host of changes to work around a compiler bug which issues
	warnings when making objective-c method calls on objects that have 
	been typecast for the purpose of the call.

        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQFileButton.mm:
        (KWQFileButton::setFilename):
        (KWQFileButton::sizeForCharacterWidth):
        (KWQFileButton::frameGeometry):
        (KWQFileButton::setFrameGeometry):
        (KWQFileButton::baselinePosition):
        (KWQFileButton::filenameChanged):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::passWidgetMouseDownEventToWidget):
        * kwq/KWQLineEdit.mm:
        (QLineEdit::setAlignment):
        * kwq/KWQListBox.mm:
        (QListBox::~QListBox):
        (QListBox::clear):
        (QListBox::setSelectionMode):
        (QListBox::insertItem):
        (QListBox::endBatchInsert):
        (QListBox::setSelected):
        (QListBox::isSelected):
        (QListBox::sizeForNumberOfLines):
        * kwq/KWQTextEdit.mm:
        (QTextEdit::setAlignment):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementForView:]):
        (-[WebCoreBridge setSelectionFrom:startOffset:to:endOffset:]):
        (-[WebCoreBridge attributedStringFrom:startOffset:to:endOffset:]):
        * kwq/WebCoreDOMDocument.mm:
        (+[WebCoreDOMDocumentType documentTypeWithImpl:DOM::]):
        (+[WebCoreDOMImplementation implementionatWithImpl:DOM::]):
        (+[WebCoreDOMDocument documentWithImpl:DOM::]):
        (-[WebCoreDOMDocument importNode::]):
        * kwq/WebCoreDOMNode.mm:
        (+[WebCoreDOMNode nodeWithImpl:DOM::]):
        (-[WebCoreDOMNode insert:before:]):
        (-[WebCoreDOMNode replace:child:]):
        (-[WebCoreDOMNode removeChild:]):
        (+[WebCoreDOMNodeList nodeListWithImpl:DOM::]):
        (+[WebCoreDOMNamedNodeMap namedNodeMapWithImpl:DOM::]):
        (-[WebCoreDOMNamedNodeMap setNamedItem:]):
        (+[WebCoreDOMAttr attrWithImpl:DOM::]):
        (+[WebCoreDOMDocumentFragment documentFragmentWithImpl:DOM::]):
        (+[WebCoreDOMElement elementWithImpl:DOM::]):
        (+[WebCoreDOMEntityReference entityReferenceWithImpl:DOM::]):
        (+[WebCoreDOMCharacterData commentWithImpl:DOM::]):
        (+[WebCoreDOMComment commentWithImpl:DOM::]):
        (+[WebCoreDOMText textWithImpl:DOM::]):
        (+[WebCoreDOMCDATASection CDATASectionWithImpl:DOM::]):
        (+[WebCoreDOMProcessingInstruction processingInstructionWithImpl:DOM::]):

2003-06-30  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3310066>: All images use wrong map if page has image map of name ""

        Reviewed by dave.

        * config.h:
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::getMap): return 0 if getMap is called with a NULL string instead of treating it like an empty string

2003-06-30  John Sullivan  <sullivan@apple.com>

	- fixed gcc3.3 incompatibility

        Reviewed by Darin

        * kwq/KWQComboBox.mm:
        (QComboBox::updateCurrentItem):
	cast result of getView() in a local variable to work around
	compiler bug where casting in a method call doesn't work (all other
	callers of getView() in this file were already using a local
	variable)

2003-06-26  Chris Blumenberg  <cblu@apple.com>

	More changes to make WebKit and WebCore compile with gcc 3.3.

        Reviewed by darin.

        * kwq/WebCoreBridge.h:

2003-06-26  Chris Blumenberg  <cblu@apple.com>

	Made WebCore compile with gcc 3.3.

        Reviewed by darin.

        * config.h:
        * kwq/KWQLineEdit.mm:
        (QLineEdit::selectAll):
        (QLineEdit::setEdited):
        * kwq/KWQString.h:
        * kwq/KWQString.mm:

=== Safari-85.1 ===

2003-06-15  Vicki Murley  <vicki@apple.com>

        Reviewed by darin.

        * WebCore.pbproj/project.pbxproj: remove SECTORDER_FLAGS variable, so that we don't use order file for our Panther submission

=== Safari-85 ===

2003-06-14  Chris Blumenberg  <cblu@apple.com>

	Fixed: <rdar://problem/3293367>: REGRESSION (83-84): nil-deref in addMetaData loading page in pop-up at live365.com

        Reviewed by darin.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:contentType:refresh:lastModified:pageCache:]): only call addMetaData if didOpenURL

2003-06-13  Darin Adler  <darin@apple.com>

        Reviewed by Don.

	- fixed 3293031 -- REGRESSION (83-84): extra entry in history when going to page that redirects (live365.com)

        * khtml/khtmlpart_p.h: Initialize m_executingJavaScriptFormAction to false.
        We had left it uninitialized when we fixed 3289047.

2003-06-13  David Hyatt  <hyatt@apple.com>

	Fix for 3292630, misrendered page because of bad doctype.  Add
	this bad doctype to our list of quirky doctypes to fix the
	problem, since the screwed up strict mode rendering is actually
	correct.
	
        Reviewed by john

        * khtml/html/doctypes.cpp:
        (findDoctypeEntry):
        * khtml/html/doctypes.gperf:

2003-06-13  Richard Williamson  <rjw@apple.com>

	Fixed 3282087.  Don't use our <pre> optimizations
	if text contains non-ascii, and consequently may
	result in font substitution.

        Reviewed by Darin.

        * khtml/rendering/render_text.cpp:
        (RenderText::RenderText):
        (RenderText::allAscii):
        (RenderText::shouldUseMonospaceCache):
        * khtml/rendering/render_text.h:

2003-06-13  Richard Williamson  <rjw@apple.com>

        Fixed 3291537.
        Reviewed by John.

        * kwq/KWQObject.mm:
        (QObject::killTimer):
        Only remove the timer is it hasn't fired (and is therefore valid).
        It is NOT permissible to reference a timer's userInfo if it is invalid.

=== Safari-84 ===

2003-06-12  David Hyatt  <hyatt@apple.com>

	Fix for 3289113, body.scrollTop doesn't return the right
	value.  Fix scrollLeft and scrollTop for body tags to just
	use the view's offset.  This matches WinIE behavior.
	
        Reviewed by john

        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLElement::getValueProperty):
        (KJS::HTMLElement::putValue):
        * khtml/ecma/kjs_html.h:
        * khtml/ecma/kjs_html.lut.h:

2003-06-12  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3289405 -- repro crash in KWQPopUpButtonCell at umax.de

        * kwq/KWQComboBox.mm: (-[KWQPopUpButtonCell trackMouse:inRect:ofView:untilMouseUp:]):
        Use the bridge that we got earlier in the function to find the right part. This is
        simpler, and more reliable. The old way would run into trouble if the widget or
        any of the other objects in the chain got destroyed during the event handling.

2003-06-12  Darin Adler  <darin@apple.com>

        Fixed by Richard, reviewed by me.

	- fixed 3289047 -- REGRESSION: can't go back after using form at attwireless.com

        * khtml/khtmlpart_p.h: Add an "executing JavaScript form action" flag.
        * kwq/WebCoreBridge.h: Add an "executing JavaScript form action" flag parameter to
        the reportClientRedirectToURL method.

        * khtml/khtml_part.cpp: (KHTMLPart::submitForm): In the JavaScript case, set a
        flag to say we are executing a JavaScript form action.
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::redirectionTimerStartedOrStopped): Pass the
        isJavaScriptFormAction state over the bridge.

2003-06-11  David Hyatt  <hyatt@apple.com>

	Fix for 3288875, :after/:before content not getting destroyed
	after printing on alistapart.com.  Make the update method for
	pseudos smart enough to destroy generated content when it is
	no longer needed.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
	(RenderBlock::setStyle);
        * khtml/rendering/render_container.cpp:
        (RenderContainer::updatePseudoChild):
        * khtml/rendering/render_container.h:
        * khtml/rendering/render_inline.cpp:
        (RenderInline::setStyle):

2003-06-11  David Hyatt  <hyatt@apple.com>

	Fix for 3288035, the wrong value was being filled in for
	textfields.  Fixed a bug in QString's assignment operator
	that made empty strings become null strings upon assignment.
	Also ensured that the form control never sets the value to
	null but always uses empty instead.
	
        Reviewed by john

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::slotTextChanged):
        * kwq/KWQString.mm:
        (QString::setLatin1):

2003-06-10  David Hyatt  <hyatt@apple.com>

	Fix for 3287870, the <embed hidden=true> feature didn't work.
	hidden should turn the embed into a plugin with a width and
	height of 0.
	
        Reviewed by gramps

        * khtml/html/html_objectimpl.cpp:
        (HTMLEmbedElementImpl::HTMLEmbedElementImpl):
        (HTMLEmbedElementImpl::attach):
        
2003-06-10  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3285820 -- REGRESSION: iframe set up with innerHTML shows up empty (discovered at www.kbs.co.kr)

        * kwq/KWQKHTMLPart.mm: (KHTMLPart::frameDetached): Remove the frame from the parent's
        m_frames list so it's not accidentally reused, since our naming scheme gives frames in
        the same place in the scheme of things the same name.

2003-06-10  David Hyatt  <hyatt@apple.com>

	Fix for 3270813, crash in the code for the CSS content property.
	When copying a DOMString, I missed a required ref.
	
        Reviewed by darin

        * khtml/rendering/render_style.cpp:
        (RenderStyle::setContent):

2003-06-10  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3285120 -- crash in CSSParser::parseColor (originally seen with Panther Mail while indexing)

        * khtml/css/parser.y: Moved DIMEN rule out of unary_term, needed because a term production
        assumes that the values that come out of unary_term are all fValue, not string.
        * khtml/css/parser.cpp: Regenerated.

2003-06-10  Vicki Murley  <vicki@apple.com>

        Reviewed by john.

        * WebCore.order: new order file for 1.0

2003-06-10  Darin Adler  <darin@apple.com>

        Reviewed by Don.

	- fixed 3286343 -- REGRESSION: crashing on pages with text area elements

        * khtml/rendering/render_form.cpp: (RenderTextArea::detach):
        Do cleanup in detach rather than in destructor.
        * khtml/rendering/render_form.h: Remove destructor, add detach.

2003-06-09  Richard Williamson  <rjw@apple.com>

	Fixed 3281761.
	This was a real doozie.  It boiled down to a frame
	attempting to access a siblings window object when that
	frame wasn't loaded and didn't have a document.

        Reviewed by Dave.

        * khtml/ecma/kjs_window.cpp:
        (Window::get):
        (Window::isSafeScript):
        (FrameArray::get):
	Made the isSafeScript more tolerant.  Always allow JS to execute
	if the active domain is nil (local).  Also allow JS to execute
	if the target part has no document yet.

        * khtml/khtml_part.cpp:
        (KHTMLPart::init):
        (KHTMLPart::openURL):
        (KHTMLPart::jScript):
        (KHTMLPart::scheduleRedirection):
        (KHTMLPart::findFrame):
	Flag redirects during load so we can later avoid
	cancelling the redirect when the document would otherwise
	normally load.

        * khtml/khtmlpart_p.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge addData:]):
	Document may now be nil.  Replace assert with conditional check.

2003-06-09  John Sullivan  <sullivan@apple.com>

	- finished fixing crash in 3275675 -- REGRESSION: crash when replacing <div> which contains iframe (at www.kbs.co.kr)

        Reviewed by Darin

        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::resizeWidget):
	check for nil element() before ref/deref'ing

2003-06-09  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - first step in fixing 3275675 -- REGRESSION: crash when replacing <div> which contains iframe (at www.kbs.co.kr)

        * khtml/rendering/render_object.h: Made m_node protected, so RenderWidget can zero it out.
        * khtml/rendering/render_replaced.cpp: (RenderWidget::detach): Set m_node to 0 here.
        RenderWidget does this strange thing of staying around after the DOM node is gone, but we need
        to get rid of the dangling pointer to the DOM node.

        * khtml/rendering/render_frames.cpp:
        (RenderFrame::slotViewCleared): Do nothing if element() is 0, since we are on our way out anyway.
        (RenderPartObject::slotViewCleared): Ditto.

2003-06-09  John Sullivan  <sullivan@apple.com>

	- fixed 3284312 -- repro nil-deref in 
	khtml::RenderTable::cellAbove at pi.nersc.gov

        Reviewed by Darin

        * khtml/rendering/render_table.cpp:
        (RenderTable::cellAbove):
	When the section had 0 rows, we were trying to index the -1st
	row. Fixed by falling into the "didn't find anything" case when
	the row we're going to look in is < 0.

2003-06-09  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3277733 -- REGRESSION: \ in JavaScript mishandled when encoding is Japanese (istweb.apple.com)
        
        This is the third time I've fixed handling of backslash and yen sign. Each time I fixed part
        of the problem but either didn't fix the whole thing or caused a regression. This time I did
        more experiments with other browsers, and I came to the conclusion that all other browsers keep
        the backslash character internally unchanged, and only change to the yen sign when displaying
        rather than decoding to the Unicode "yen sign" character. This makes the backslash character
        different from any other, and requires special code, but it's the only way to match the other
        browsers' behavior. This seems to work great; I retested all the backslash/yen bugs from the
        past to make sure I didn't cause new regressions. The only loose end is the DOM API. It's not
        clear whether the DOM API should return the strings with backslashes or with yen signs, but
        we can probably ship 1.0 without getting that 100% right.

        * kwq/KWQTextCodec.h: Added backslashAsCurrencySymbol() member function.
        * kwq/KWQTextCodec.mm:
        (QTextCodec::fromUnicode): Removed the old workaround for tilde problems, which is not needed
        now that we are back to using "force ASCII" mode, so tildes are always tildes. Updated the comment
        about the backslash hack to better reflect the new situation and change it to use the new
        backslashAsCurrencySymbol() member function.
        (QTextCodec::backslashAsCurrencySymbol): Added. Returns the yen sign for the encodings where
        it's appropriate. Later might do the same thing with the won sign for Korean, depending on what
        we discover as we research bug 3221037 (Korean currency symbol should replace backslash).
        (KWQTextDecoder::convertUsingTEC): Add back the call to TECSetBasicOptions since we once-again
        want to use force-ASCII mode; we turn backslashes into yen signs at a higher level now; internally
        they are kept as backslashes.

        * khtml/xml/dom_docimpl.h: Made setDecoder no longer be inline, and added a decoder member
        function so callers could get the decoder (they need it to figure out what to do with
        backslashes).
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::setDecoder): Made this no longer be an inline. Also made sure it derefs the
        existing decoder. This probably does not happen in practice, but the old version would leak
        if it was ever called twice on the same document.

        * kwq/KWQString.mm: (QString::replace): Made sure that the case of replacing a character
        with the same character has an early out, since that's now the common case with this
        "map backslash to currency character if needed" feature.

        * khtml/xml/dom_stringimpl.h: Made capitalize() const and added a new replace() member function.
        * khtml/xml/dom_stringimpl.cpp: (DOMStringImpl::replace): Implemented this new function
        that replaces one character with another. Returns the existing string if there is no replacing
        to do, otherwise makes a new one.

        * khtml/rendering/render_object.h: Added backslashAsCurrencySymbol() member function.
        * khtml/rendering/render_object.cpp: (RenderObject::backslashAsCurrencySymbol): Added.
        Helper function so render objects have an easier time digging for the "do I need to turn
        the backslashes into currency symbols" flag.

        * kwq/KWQKHTMLPart.h: Added backslashAsCurrencySymbol() member function.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::setTitle): Convert title to use yen sign.
        (KWQKHTMLPart::setStatusBarText): Convert status bar text to use yen sign.
        (KWQKHTMLPart::runJavaScriptAlert): Convert message text to use yen sign.
        (KWQKHTMLPart::runJavaScriptConfirm): Convert message text to use yen sign.
        (KWQKHTMLPart::runJavaScriptPrompt): Convert message text and default value to use yen sign,
        convert result back from yen sign to backslash.
        (KWQKHTMLPart::attributedString): Convert pieces of text to use yen sign when building up
        the attributed text.
        (KWQKHTMLPart::backslashAsCurrencySymbol): Added.
        Helper function so render objects have an easier time digging for the "do I need to turn
        the backslashes into currency symbols" flag.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge selectedString]): Convert text to use yen sign before returning to WebKit.
        (-[WebCoreBridge elementAtPoint:]): Convert title and alt strings to use yen sign before
        returning them to WebKit.

        * khtml/rendering/render_form.cpp:
        (RenderSubmitButton::rawText): Convert button label to use yen sign.
        (RenderLineEdit::updateFromElement): Convert text for line edit to use yen sign.
        (RenderLineEdit::slotTextChanged): Convert yen sign to backslash on the way in from line edit.
        (RenderSelect::updateFromElement): Convert text for select items to use yen sign.
        (RenderTextArea::updateFromElement): Convert text for text areas to use yen sign.
        (RenderTextArea::text): Convert yen sign to backslash on the way in from text area.
        * khtml/rendering/render_image.cpp:
        (RenderImage::paintObject): Convert alt text to use yen sign before drawing it.
        * khtml/rendering/render_text.cpp:
        (RenderText::RenderText): Convert text to use yen sign before drawing it.
        (RenderText::setText): Ditto.

        - fix a problem that was bugging the shit out of me where we kept rebuilding config.h

        * Makefile.am: Use the config-timestamp file to decide when to remake config.h so
        we don't end up making it over and over again. Also don't bother to grep out NO_LICENSE
        any more since that's long gone.
        * .cvsignore: Ignore the config-timestamp file.

=== Safari-83 ===

2003-06-09  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

	- fixed 3280538 -- JavaScript infinite loop loading frame b/c scrollHeight is always zero (easons.ie)

        * khtml/xml/dom_docimpl.h: Added updateLayout method.
        * khtml/xml/dom_docimpl.cpp: (DocumentImpl::updateLayout): Added. Code moved here
        from KJS::Window::updateLayout so it can be shared. Named this updateLayout() to match
        the name from KJS::Window.

        * khtml/ecma/kjs_window.cpp: (Window::updateLayout): Call updateLayout()
        instead of updateRendering(); the extra logic here was moved into updateLayout().
        * khtml/ecma/kjs_dom.cpp: (DOMNode::getValueProperty): Ditto.

        * khtml/ecma/kjs_html.cpp: (KJS::HTMLElement::getValueProperty): Call updateLayout()
        on the document before computing the BodyScrollHeight or BodyScrollWidth, much as
        we already do in kjs_dom.cpp for ScrollHeight and ScrollWidth and other properties.

2003-06-05  David Hyatt  <hyatt@apple.com>

	Fix for crash on an XHTML frameset page.  It was assuming
	that all docs were HTML. The bug # is 3277973.
	
        Reviewed by john

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::updatePolicyBaseURL):
        (KWQKHTMLPart::setPolicyBaseURL):

2003-06-05  David Hyatt  <hyatt@apple.com>

	Fix for 3281030, stylesheets can't be enabled properly via
	script.  Test case from Dirk.  The fix is to make the setting
	of the state happen independently of the attribute setting.
	
        Reviewed by john

        * khtml/dom/html_head.cpp:
        (HTMLLinkElement::setDisabled):
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::setDisabledState):
        (HTMLLinkElementImpl::parseAttribute):
        * khtml/html/html_headimpl.h:

2003-06-05  Chris Blumenberg  <cblu@apple.com>

        Fixed: <rdar://problem/3268751>: REGRESSION: crash in KWQValueListImpl selecting connection speed at news.com

        Reviewed by darin.

        * kwq/KWQButton.mm:
        (QButton::clicked): Don't call clicked if the button was destroyed inside of sendConsumedMouseUpIfNeeded.

2003-06-05  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3279206 -- REGRESSION: new page does not load after selecting item from list and hitting 'Go' button

        * khtml/html/html_formimpl.cpp: (HTMLInputElementImpl::encoding): Use value() in a couple of places
        that were still directly using m_value.

2003-06-05  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3278079 -- REGRESSION: UTF-8 page claiming to be UTF-16 in XML header gives garbage characters

        * khtml/misc/decoder.cpp: (Decoder::setEncoding): Add EncodingFromXMLHeader as one of the
        types where we know the encoding is an 8-bit one. The reason this is a regression is that we
        used to ignore the encoding in the XML header altogether.

2003-06-04  John Sullivan  <sullivan@apple.com>

	- fixed 3279957 -- REGRESSION: assertion failure at launch in 
	Decoder::~Decoder() importing bookmarks

	Richard actually wrote this fix.
        Reviewed by me, Darin

        * kwq/WebCoreEncodings.mm:
        (+[WebCoreEncodings decodeData:]):
	don't use stack-based decoder; use new instead. 

2003-06-04  David Hyatt  <hyatt@apple.com>

	Fix for 3273300, leaks in cssyyparse.  Function forgot to delete
	its args value list when destroyed.
	
        Reviewed by gramps

        * khtml/css/cssparser.h:

2003-06-03  David Hyatt  <hyatt@apple.com>

	Fix for 3259647, crash when printing a table page.  This is fixed
	on the KDE KHTML trunk.  The loop shouldn't be broken out of
	when you have column elements so that all sections can recalc
	their cell grids as needed.
	
        Reviewed by kocienda

        * khtml/rendering/render_table.cpp:
        (RenderTable::recalcSections):

=== Safari-82 ===

2003-06-03  Richard Williamson   <rjw@apple.com>

	Fixed 3275565.  Ref count the decoder.

        Reviewed by Ken.

        * khtml/khtml_part.cpp:
        (KHTMLPart::clear):
        * khtml/misc/decoder.cpp:
        (Decoder::Decoder):
        (Decoder::~Decoder):
        * khtml/misc/decoder.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::~DocumentImpl):
        * khtml/xml/dom_docimpl.h:
	

2003-06-02  David Hyatt  <hyatt@apple.com>

	Fix for 3276099.  value() was wrong for radio buttons.  Needed
	to get it from the attribute since I was no longer caching
	anything in m_value.
	
        Reviewed by kocienda

        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::value):

2003-06-02  Ken Kocienda  <kocienda@apple.com>

        Code written by darin
        Reviewed by me

	Fix for this bug:

	<rdar://problem/3272162>: repro crash in khtml::CachedImage::checkNotify() on particular page

        * khtml/ecma/kjs_html.cpp:
        (Image::putValue): ref onLoadListener when setting a value to onLoad
        (Image::~Image): deref onLoadListener when destructing the image.

2003-06-02  David Hyatt  <hyatt@apple.com>

	Fix for 3263679, color: # doesn't parse.  Fix is to add an
	error-handling case for # by itself to parser.y.
	
        Reviewed by gramps/ken

        * khtml/css/parser.cpp:
        * khtml/css/parser.y:

=== Safari-81 ===

2003-06-02  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3256787 -- HOMEPAGE:\000 characters being added by Safarin in Form submission,
        causing an exception in property list parsing

        * kwq/KWQTextCodec.mm: (QTextCodec::fromUnicode): Encode \ as 5C instead of 815F
        when encoding Shift-JIS. This should make the Apple Store work again. The only thing
        we lose is the ability to send an actual Shift-JIS backslash (815F), but I think that
        is almost never needed. In other browsers you can't even type a backslash in Shift-JIS.

2003-06-02  Ken Kocienda  <kocienda@apple.com>

        * config.h:

2003-06-02  David Hyatt  <hyatt@apple.com>

	Fix for 3275136.  Make sure that when the checked attribute
	is set dynamically (something we were ignoring before my previous
	patch) that we also properly update the radio button array in
	the document.
	
        Reviewed by gramps

        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::parseAttribute):
        (HTMLInputElementImpl::attach):
        (HTMLInputElementImpl::reset):

2003-05-30  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Chris.

	- fixed 3169067 - PEOPLESOFT: left frame missing; frame RenderRoot height and width are both zero

        * khtml/khtml_part.cpp: (KHTMLPart::gotoAnchor): Update layout before scrolling.

2003-05-30  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	- fixed 3273544 - REGRESSION: Page disappears at http://www.urban-advantage.com/
	
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::getElementById): Return null when the ID is the
	empty string. Otherwise we'll return the first element in the
	document, usually the top-level HTML element, which is wrong and
	does not match other browsers.

2003-05-30  Richard Williamson  <rjw@apple.com>

	As part of some cleanup when fixing 3272516 changed use of
	@"" for cache keys to NSString declarations.

        Reviewed by Ken.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:contentType:refresh:lastModified:pageCache:]):

2003-05-30  David Hyatt  <hyatt@apple.com>

	Fix for 3269129 and 3269220.  setAttribute('value') didn't work
	for inputs.  Basically defaultValue and defaultChecked have never
	worked.  This patch fixes the problem by making sure that for both
	value and checked you have a two-tier system where you look first
	for the value as altered by the control (or by setting the DOM
	property) and if that isn't set then you look at the default value.

	This allows setAttribute (which changes the *default*) to work in
	the cases where the control has not overridden the default 
	with a different value.
	
        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::HTMLInputElementImpl):
        (HTMLInputElementImpl::state):
        (HTMLInputElementImpl::parseAttribute):
        (HTMLInputElementImpl::attach):
        (HTMLInputElementImpl::reset):
        (HTMLInputElementImpl::setChecked):
        (HTMLInputElementImpl::value):
        (HTMLInputElementImpl::setValue):
        (HTMLInputElementImpl::isCheckedRadioButtonForDocument):
        * khtml/html/html_formimpl.h:
        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::RenderLineEdit):
        (RenderLineEdit::calcMinMaxWidth):
        (RenderLineEdit::updateFromElement):
        (RenderLineEdit::slotTextChanged):
        * khtml/rendering/render_form.h:

2003-05-30  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - added "sjis" as a synonym for "Shift_JIS"; this might fix 3235161,
        HOMEPAGE: Publishing page with Japanese characters w/ Safari generates an error,
        but I am currently unable to test the fix.

        * kwq/mac-encodings.txt: Added sjis to the Shift_JIS line.
        * kwq/KWQCharsetData.c: Regenerated.

2003-05-29  David Hyatt  <hyatt@apple.com>

	Fix for 3263156, stack overflow at www.liceo.edu.mx.  This
	site nests about 500 bold tags, only closes some of them, 
	and then opens 500 more, etc.

	The fix for this problem is to stop honoring tags in the parser
	after you see 20 identical tags.  We do this only for fontstyle HTML
	tags.
	
        Reviewed by john/darin

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::getElement):
        (KHTMLParser::allowNestedRedundantTag):
        * khtml/html/htmlparser.h:

2003-05-30  John Sullivan  <sullivan@apple.com>

        Reviewed by Chris

        * khtml/rendering/break_lines.cpp:
	Removed #ifdef/#else for which the two sides were identical
	that I noticed in passing.

2003-05-29  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3270373 - MALLORY: repro crash in +[KWQObjectTimerTarget stopDeferringTimers] while changing folder

        * kwq/KWQObject.mm:
        (QObject::killTimer): Remove the timer from the deferred list too - clients expect that a timer
	will never be delivered after the object was killed.
        (QObject::killTimers): Use killTimer on each timer for this object instead of trying
	to be tricky. 
        (-[KWQObjectTimerTarget timerFired]): Don't add a timer to the deferred list more than once,
	because there's no benefit in ganging up multiple firings while deferred, and it makes other
	things simpler.
        (+[KWQObjectTimerTarget stopDeferringTimers]): Make sure to remove the timer before firing it, 
	since it may also cancel itself, and we don't want to remove an extra timer in that case.

2003-05-29  Richard Williamson   <rjw@apple.com>

	Support for the 'estimatedProgress' method on
	WebView.  Added bridge access to the number of pending or still
	loading requests (from KHTML's perspective).  This is used to
	more accurately guess at the total remaining bytes to load.

        Reviewed by Chris.

        * kwq/KWQLoader.h:
        * kwq/KWQLoader.mm:
        (KWQServeRequest):
        (KWQNumberOfPendingOrLoadingRequests):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge numPendingOrLoadingRequests]):

2003-05-29  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Maciej

	Fix for this bug:

	<rdar://problem/3271697>: Search fails at travel site

        * khtml/html/html_formimpl.cpp:
        (HTMLFormElementImpl::parseAttribute): Allow form method to be set
	to GET from javascript.

2003-05-29  John Sullivan  <sullivan@apple.com>

	- fixed MIME type leaks that were most of 3272566 
	(several leaks after visiting amazon.com and emptying cache)

        Reviewed by Darin

        * kwq/KWQPixmap.mm:
        (QPixmap::QPixmap):
        (QPixmap::operator=):
	fixed two leaks of MIME string

2003-05-29  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3269564 -- dynamically-created forms look right, but don't post values when submitted

        * khtml/html/html_formimpl.h: Remove useless virtual setParent function.
        Since the inherited setParent is not virtual, it does no good to make the subclass
        override it with a virtual function.
        * khtml/html/html_formimpl.cpp: Remove useless virtual setParent.
        (HTMLGenericFormElementImpl::attach): Add code here, cribbed from setParent, to add
        a new form element to the form it's in.
        (HTMLButtonElementImpl::attach): A copy of the code is also needed here.

        * WebCore.pbproj/project.pbxproj: Let Project Builder be Project Builder.

2003-05-28  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3263157 - REGRESSION: tabbing into a secure password field shows contents

        * kwq/KWQTextField.mm:
        (-[KWQSecureTextField textDidEndEditing:]): Make sure to restore bullet mode if we
	accidentally lose it.

2003-05-27  Maciej Stachowiak  <mjs@apple.com>

        Rolled in fix from Safari-80~1-branch

    2003-05-27  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

        * WebKit.pbproj/project.pbxproj: Removed no longer needed and harmful flag.
	
2003-05-25  David Hyatt  <hyatt@apple.com>

	Fix for 3268589, static position miscomputed when the positioned object is the last item in its enclosing block and when its previous sibling is a text run that ends in a space.  In this case we need to clear our trailingSpaceObject so that we don't mist
akenly ignore the positioned object when building up bidi runs.

	Fix for 3260053, table-layout of inherit not supported.  This
	caused a crash.  The fix is to just add in the support for the inherit
	value to the style selector.
	
        Reviewed by john

        * khtml/rendering/bidi.cpp:
	* khtml/css/cssstyleselector.cpp
	
2003-05-26  John Sullivan  <sullivan@apple.com>

	- fixed 3262849 -- jump to nil in KWQKHTMLPart::searchForLabelsAboveCell 
	at techbargains.com

        Reviewed by Dave

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::searchForLabelsAboveCell):
	check for nil result of cellAboveRenderer->element()

2003-05-23  David Hyatt  <hyatt@apple.com>

	Fix for 3229799, images missing on geocities page.  Residual style
	needs to understand when you reopen tags at a malformed table 
	content boundary and make sure the newly-reopened tags also know
	they are malformed table content so that they get cleaned up
	properly.
	
        Reviewed by darin

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::handleResidualStyleCloseTagAcrossBlocks):
        (KHTMLParser::reopenResidualStyleTags):
        (KHTMLParser::popBlock):
        * khtml/html/htmlparser.h:

2003-05-22  David Hyatt  <hyatt@apple.com>

	Fix for 3248176, failed assertion on blizzard's world of warcraft
	page.  They dynamically changed the position of an element from
	absolute to relative, and this element was inside an inline.
	The setStyle() code has to be smart enough to split the inline
	flow when the element is no longer absolute positioned.

	This patch makes a splitFlow occur like it should and it also
	cleans up anonymous block creation with a new helper function
	on RenderObject, createAnonymousBlock.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_inline.cpp:
        (RenderInline::splitFlow):
        * khtml/rendering/render_object.cpp:
        (RenderObject::createAnonymousBlock):
        (RenderObject::handleDynamicFloatPositionChange):
        (RenderObject::setStyle):
        * khtml/rendering/render_object.h:

2003-05-22  David Hyatt  <hyatt@apple.com>

	Fix for 3259947.  Can't add clippings on iht.com.  The fix is
	to make sure all DOM properties that relate to attributes return ""
	and not "null" when the attribute isn't present or when the 
	DOMString is null.

	Also patching the code for text-indent to make sure that floats
	don't improperly consume text-indent.  This fixes two of the issues
	on diveintomark.
	
        Reviewed by mjs

        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::tryGet):
        (KJS::HTMLElement::getValueProperty):

2003-05-22  David Hyatt  <hyatt@apple.com>

	Make sure the overflow clip rect clips out the scrollbars
	so that child layers aren't able to draw on top of the
	scrollbars.

	Also fix scrollbars so that they are painted before the
	overflow clip rect is applied (just as backgrounds and borders
	are).

	These two fixes make the divtest example from Yahoo (sent by Mark
	Malone) work.
	
        Reviewed by john

        * khtml/rendering/render_box.cpp:
        (RenderBox::getOverflowClipRect):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):

2003-05-22  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3216039 -- calls to m_redirectionTimer.stop() do not always clear m_scheduledRedirection

        * khtml/khtml_part.h: Added cancelRedirection().
        * khtml/khtml_part.cpp:
        (KHTMLPart::~KHTMLPart): Call cancelRedirection() instead of m_redirectionTimer.stop().
        (KHTMLPart::restoreURL): Ditto.
        (KHTMLPart::openURL): Ditto.
        (KHTMLPart::closeURL): Ditto.
        (KHTMLPart::cancelRedirection): Added. Sets m_scheduledRedirection to noRedirectionScheduled
        and calls m_redirectionTimer.stop(), but is also safe to call after d is set to 0.
        (KHTMLPart::restoreState): Call cancelRedirection() instead of m_redirectionTimer.stop().

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURLFromPageCache): Call cancelRedirection() instead of m_redirectionTimer.stop().
        (KWQKHTMLPart::scrollToAnchor): Call cancelRedirection() instead of m_redirectionTimer.stop()
        (and setting m_scheduledRedirection).

2003-05-21  David Hyatt  <hyatt@apple.com>

	This patch deals with the main cause of regressions from
	the minimum font size removal.  Because we stored font sizes
	as integers, we ended up flooring font sizes, and when percentages
	were nested, the magnitude of error increased dramatically.

	This patch changes FontDef to store a float size instead of an
	integer size.  The style system thus always computes a precise
	floating point value for a font, with no error introduced and
	only once it has that final computed value does it round to the
	nearest pixel for the QFont.

	This fixes 3265628, www.anandtech.com.
	
        Reviewed by rjw

        * khtml/css/css_valueimpl.cpp:
        (CSSPrimitiveValueImpl::computeLengthFloat):
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/font.cpp:
        (Font::update):
        * khtml/rendering/font.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):

2003-05-21  David Hyatt  <hyatt@apple.com>

	Fix for 3257990, attributes in HTML should always be case-insensitive
	when matching CSS attribute selectors.  Instead of relying on 
	the strict mode check, I patched the code to use an isXMLDoc
	bool instead.

	Also fixing a problem where <pre>s are mistakenly justifying their
	text when text-align: justify is set.
	
        Reviewed by kocienda

        * ChangeLog:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/cssstyleselector.h:
        * khtml/rendering/bidi.cpp:

2003-05-21  Vicki Murley  <vicki@apple.com>

        Reviewed by john 
	- fixed 3234553: Safari and its frameworks should link using order files

        * WebCore.order: Added.
        * WebCore.pbproj/project.pbxproj: set SECTORDER_FLAGS = -sectorder __TEXT __text WebCore.order

2003-05-20  David Hyatt  <hyatt@apple.com>

        An implementation of fieldset and legend.  This is based off
	some KHTML trunk code, but only loosely.  I had to rewrite
	most of it in order to make fieldsets work properly with
	padding and in order to match the fieldset style of other
	browsers more closely.

	This code also fixes HTML4 buttons so that they don't fill the
	width of containing blocks.  This has been a long-standing
	bug.  Since legends behave the same way as buttons and floats,
	I made a new helper function, sizesToMaxWidth(), to denote an
	element that just uses its max intrinsic width when sizing
	instead of filling a containing block.

        This patch also fixes z-index so it properly only applies to the 
	root and to positioned/relpositioned elements.  
        
        Reviewed by darin

        * ChangeLog:
        * ForwardingHeaders/rendering/render_block.h: Added.
        * khtml/css/html4.css:
        * khtml/html/html_formimpl.cpp:
        (HTMLFieldSetElementImpl::HTMLFieldSetElementImpl):
        (HTMLFieldSetElementImpl::attach):
        (HTMLFieldSetElementImpl::createRenderer):
        (HTMLLegendElementImpl::HTMLLegendElementImpl):
        (HTMLLegendElementImpl::id):
        (HTMLLegendElementImpl::attach):
        (HTMLLegendElementImpl::createRenderer):
        * khtml/html/html_formimpl.h:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::calcWidthUsing):
        * khtml/rendering/render_canvas.cpp:
        * khtml/rendering/render_form.cpp:
        (RenderFieldset::RenderFieldset):
        (RenderFieldset::layoutLegend):
        (RenderFieldset::findLegend):
        (RenderFieldset::paintBoxDecorations):
        (RenderFieldset::paintBorderMinusLegend):
        (RenderLegend::RenderLegend):
        * khtml/rendering/render_form.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::sizesToMaxWidth):
        * khtml/rendering/render_object.h:

2003-05-19  David Hyatt  <hyatt@apple.com>

	Fix for 3262890, logical font sizes (e.g., large) cannot be applied
	to monospace tags like <pre> and <tt>.  The fix adds a notion of
	the current logicalSize in effect for a given FontDef so that
	shifts in family as you go down the style tree result in an
	auto-correction of the size.

	Note that with the addition of this cached logicalSize property,
	it will be possible to eliminate the two separate logical size
	tables and implement the monospace table as a "zoom factor" applied
	to the normal table (an idea long ago suggested by darin).
	
        Reviewed by darin

        * ChangeLog:
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/font.h:

=== Safari-80 ===

2003-05-19  Maciej Stachowiak  <mjs@apple.com>

        - fixed 3261096 - Make WebKit an umbrella framework

        * WebCore.pbproj/project.pbxproj: In a B&I build, compile as a
	sub-umbrella of WebKit.

2003-05-19  Ken Kocienda  <kocienda@apple.com>

        Reviewed by Darin
	
	Fixed build problem with declaring MIMEType as a category
	on NSObject. This method needs to be typed to return NSString.

        * kwq/KWQLoader.mm

2003-05-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3260940 - REGRESSION: reproducible crash freeing page cache item
	- fixed 3241041 - REGRESSION: repro world leak of 1 JavaScript interpreter

	The fix for these problems and probably other page cache wackiness
	was to use a refcounting scheme for KHTMLView instead of counting
	on the previous tricky ownership rules.
	
        * khtml/khtmlview.cpp:
        (KHTMLView::KHTMLView): Initialize _refCount to 1.
        (KHTMLView::~KHTMLView): Assert that _refCount is 0, to make sure no one is deleting
	views explicitly.
        * khtml/khtmlview.h:
        * khtml/rendering/render_frames.cpp:
        (RenderPart::~RenderPart): If our view is a KHTMLView, deref it.
        (RenderPart::setWidget): If the view is a KHTMLView, tell the superclass not to
	delete it and ref it.
        * khtml/rendering/render_frames.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::RenderWidget): Initizlize m_deleteWidget to false.
        (RenderWidget::~RenderWidget): Only delete widget if we're supposed to.
        (RenderWidget::setQWidget): Add extra delegeWidget argument that says whether
	to delete this widget when done - defaults to true.
        * khtml/rendering/render_replaced.h:
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::KWQKHTMLPart): Removed _ownsView boolean -- we'll always hang on
	to a ref to it now.
        (KWQKHTMLPart::~KWQKHTMLPart): Deref the view always instead of deleting it sometimes.
        (KWQKHTMLPart::setView): deref the old view if not null. ref the new view if not null.
	Drop tricky ownership rules.
        (KWQKHTMLPart::openURLFromPageCache): Remove no longer applicable comment about the
	importance of when setView is called.
        * kwq/KWQPageState.mm:
        (-[KWQPageState initWithDocument:URL:windowProperties:locationProperties:]): ref the
	document's view.
        (-[KWQPageState invalidate]): deref the document's view.
        (-[KWQPageState dealloc]): deref the document's view instead of deleting it.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge createKHTMLViewWithNSView:marginWidth:marginHeight:]): No more need
	to pass weOwnIt argument to setView. Also, deref the view after passing it to the
	KWQKHTMLView -- we own the initial ref since we allocated it.
        (-[WebCoreBridge removeFromFrame]): No more need to pass weOwnIt argument to setView.
        (-[WebCoreBridge installInFrame:]): Ditto.

2003-05-16  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Ken.

	- fixed 3256997 - reproducible world leak (of 1 JavaScript interpreter) using google images 

	This turned out to be a page cache bug, and nothing to do with
	JavaScript. The part and view were also leaked.
	
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURLFromPageCache): Make sure to reset the view
	before resetting the document, so that when we check if the
	document is in the page cache to determine if we can delete the
	old view, we'll be checking the old document instead of the new
	one.

2003-05-15  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- fixed 3168588 - Can't click on links at Nike site (Image onload handler problem)

	The fix was to implement the onload property for Image objects
	(which are entirely different from <img> HTML elements).

        * khtml/ecma/kjs_html.cpp:
        (Image::getValueProperty): Implement access to onload attribte.
        (Image::tryPut): Use putValue cause we're gonna use the hashtable now.
        (Image::putValue): Moved guts of tryPut here. Implement setting of
	onload attribute.
        (Image::notifyFinished): Fire onload event if there is a listener.
        (Image::Image): initialize onload listener to null.
        * khtml/ecma/kjs_html.h:
        * khtml/ecma/kjs_html.lut.h: Regenerated.

=== Safari-79 ===

2003-05-14  David Hyatt  <hyatt@apple.com>

	Fix for 3248193.  Floats with layers paint twice.  The fix
	is to make sure floats are not painted during the float phase
	if they also have a layer.
	
        Reviewed by john
	
        * khtml/rendering/render_block.cpp:

2003-05-14  David Hyatt  <hyatt@apple.com>

	Fix for 3258389, min-width should take precedence over max-width.
	I just had an "else" that shouldn't have been there, so that
	min-width would get checked even if max-width was also checked.
	
        Reviewed by kocienda

        * khtml/rendering/render_box.cpp:
        (RenderBox::calcWidth):

2003-05-14  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Don.

	- fixed 3257307 - REGRESSION: crash using onFocus="this.blur()"
	
        * kwq/KWQTextField.mm:

        (-[KWQTextField setHasFocus:]): Don't call
	KWQKHTMLPart::setDocumentFocus(widget) to start with, it might
	invoke a handler which could call blur(), and we don't want to do
	the selection handling after that; futhermore, it will get called
	anyway when we deliver the FocusIn event to the event
	filter. Also, sometimes unfocusing in the middle of a focus can
	leave us and AppKit in an inconsistent state; correct this. A
	comment explains the details.

2003-05-13  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by John.

	- fixed 3240129 - REGRESSION: www.ezprints.com navigation buttons don't show up (window.addEventListener)

	The problem here was that event handlers set using
	window.addEventListener were set as regular event handlers on the
	document object instead of as window event handlers - and the load
	event does not fire properly that way. 

	The fix was to add support for both HTML and non-HTML window event
	handlers. The old window event methods supported only "HTML"
	handlers, but were not named as such.

        * khtml/ecma/kjs_window.cpp:
        (Window::setListener): Use setHTMLWindowEventListener.
        (Window::getListener): Use getHTMLWindowEventListener.
        (WindowFunc::tryCall): use addWindowEventListener and removeWindowEventListener
	on the DocumentImpl instead of addEventListener and removeEventListener on the
	Document.
        * khtml/html/html_baseimpl.cpp:
        (HTMLBodyElementImpl::parseAttribute): Use setHTMLWindowEventListener
	instead of the old setWindowEventListener.
        * khtml/xml/dom_docimpl.cpp:
	(DocumentImpl::defaultEventHandler): Don't stop after the first
	window event handler - keep going, since there might now be more
	than one for the same event.
        (DocumentImpl::setHTMLWindowEventListener): Renamed from setWindowEventListener.
        (DocumentImpl::getHTMLWindowEventListener): Renamed from getWindowEventListener.
        (DocumentImpl::removeHTMLWindowEventListener): Renamed from removeWindowEventListener.
        (DocumentImpl::addWindowEventListener): Implemented - support adding non-HTML window
	event listeners, which, unlike html listeners, are nto exclusive - there may be more
	than one.
        (DocumentImpl::removeWindowEventListener): Implemented.
        (DocumentImpl::hasWindowEventListener): Check if a window has any handler at all
	for a prticular event.
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::addEventListener): Add ref/deref pair to protect against last ref of listener
	going away on remove. Correct comment about the removal.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::canCachePage): Check for an UNLOAD event handler
	using hasWindowEventListener instead of getHTMLWindowEventListener, to
	check for even addListener-style unload handlers.

2003-05-13  David Hyatt  <hyatt@apple.com>

	Fix for 3222607.  divs that specify a fixed width should have
	their minwidths increased to that width.  This is an issue
	on diveintomark's list as well as a blocker for Benoit.
	
        Reviewed by gramps

        * khtml/rendering/render_block.cpp:

2003-05-13  David Hyatt  <hyatt@apple.com>

	Fix for 3256376, absolute positioned content that had to be
	scrolled into view would not respond to events.  This is a 
	regression caused by fixing the size of the HTML element.

	I stopped all of the updating of layer widths/heights in
	setLayouted and in setWidth/Height of RenderBox and special-cased
	the sizing of the RenderCanvas layer so that it always encloses
	all content.

	This patch also contains a fix for 3211915, left/top positions
	not computed properly when auto or static.  The patch adds
	staticX/Y member variables to RenderBox that holds the cached
	values that can then be used by positioned elements to determine
	their correct positions in the flow.  RenderStyles also now
	remember both the original display of an element as well as
	the mutated display (e.g., when an inline becomes a block
	because of absolute positioning).
	
        Reviewed by darin (canvas fix) and kocienda (left/top fix)

        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::RenderBox):
        (RenderBox::position):
        (RenderBox::setStaticX):
        (RenderBox::setStaticY):
        (RenderBox::calcAbsoluteHorizontal):
        (RenderBox::calcAbsoluteVertical):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_canvas.cpp:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::createInlineBox):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::updateLayerPosition):
        * khtml/rendering/render_line.cpp:
        (InlineFlowBox::placeBoxesHorizontally):
        (InlineFlowBox::adjustMaxAscentAndDescent):
        (InlineFlowBox::computeLogicalBoxHeights):
        (InlineFlowBox::placeBoxesVertically):
        (InlineFlowBox::shrinkBoxesWithNoTextChildren):
        * khtml/rendering/render_object.cpp:
        (RenderObject::hasStaticX):
        (RenderObject::hasStaticY):
        (RenderObject::setNeedsLayout):
        (RenderObject::createInlineBox):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_style.cpp:
        (RenderStyle::diff):
        * khtml/rendering/render_style.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::createInlineBox):
        * khtml/rendering/render_text.h:

2003-05-13  Richard Williamson   <rjw@apple.com>

	Fixed 3014661.  We now display (a lame Lemay) image
	when an image fails to load.  We also display the 
	alt text if it fits within the image container
	above the missing image icon.  Alt text is also
	now shown if image loading is disabled.

        Reviewed by John.

        * khtml/misc/loader.cpp:
        (CachedImage::data):
        (Cache::init):
        * khtml/rendering/render_image.cpp:
        (RenderImage::paintObject):
        (RenderImage::reload):
        * kwq/KWQPixmap.h:
        * kwq/KWQPixmap.mm:
        (KWQLoadPixmap):
        (QPixmap::QPixmap):
        (QPixmap::isNull):
        * kwq/WebCoreImageRenderer.h:
        * kwq/WebCoreImageRendererFactory.h:

2003-05-12  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3254484 - Add a way to print JavaScript exceptions to the console via the debug menu

        * khtml/ecma/kjs_proxy.cpp:
        (KJSProxyImpl::evaluate): Pass the filename.
        * kwq/WebCoreJavaScript.h:
        * kwq/WebCoreJavaScript.mm:
        (+[WebCoreJavaScript shouldPrintExceptions]): Call through to JavaScriptCore.
        (+[WebCoreJavaScript setShouldPrintExceptions:]): Call through to JavaScriptCore.
        * khtml/ecma/kjs_events.cpp:
        (JSEventListener::handleEvent): Print exception if there is one.
        * khtml/ecma/kjs_window.cpp:
        (ScheduledAction::execute): Print exception in the function case.

2003-05-13  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3140822 -- relative URLs starting with query strings clobber path as the RFC says, but web says no

        * kwq/KWQKURL.mm: (KURL::KURL): Add a case for queries (as with anchors) to match
        the behavior of the web (albeit not the RFC).

2003-05-13  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3120355 -- importing IE favorites garbles non-ASCII characters (esp. bad for non-Roman languages)

        * kwq/WebCoreEncodings.h: Added decodeData:, removed all other (unused) methods.
        * kwq/WebCoreEncodings.mm: (+[WebCoreEncodings decodeData:]): Added. Calls the same
        decoder used to decode web pages.

2003-05-13  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3228186 -- REGRESSION: crash walking parent tree at housingscc.org in DOM::StyleBaseImpl::stylesheet()

        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::~ElementImpl): Unref the stylesheet with the style declaration in it
        when destroying the element.
        (ElementImpl::createDecl): Ref the stylesheet with the style declaration in it when
        making a style element for this. If we don't we could end up with a style declaration
        without a stylesheet, which can't be manipulated by the CSS parser.

        * khtml/html/html_elementimpl.cpp: (HTMLElementImpl::removeCSSProperty): Since this
        function has a side effect of changing the stylesheet for the style declaration, ref
        the new stylesheet and unref the old one.

2003-05-12  Richard Williamson  <rjw@apple.com>

        Fixed 3194614 and 3194751.  We avoid creating and render objects
        and loading any images if the document is in 'renderless' mode.
        
        Also, we now unique instances of the ObjC DOM wrappers.
        
        Reviewed by hyatt/darin.

        * khtml/misc/loader.cpp:
        * khtml/xml/dom_docimpl.cpp:
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_nodeimpl.cpp:
        * kwq/KWQLoader.h:
        * kwq/KWQLoader.mm:
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        * kwq/WebCoreDOMNode.mm:
        * kwq/WebDOMNode.h:

        Pass the reported MIME type of an image up to WebKit when
        creating an WebImageRenderer.  This is useful to help speed up
        the selection of an appropriate decoder.
        
        Reviewed by darin.

        * kwq/WebCoreImageRendererFactory.h:
        * kwq/KWQPixmap.h:
        * kwq/KWQPixmap.mm:

2003-05-12  Darin Adler  <darin@apple.com>

        Reviewed by Richard.

        - fixed 3240925 -- can't select or copy text from readonly INPUT elements

        An AppKit peculiarity. Calling setEditable:NO will have a side effect of
        doing setSelectable:NO unless you explicitly did setSelectable:YES.

        * kwq/KWQLineEdit.mm:
        (QLineEdit::QLineEdit): Call setSelectable:YES.

        * kwq/KWQTextField.mm:
        (-[KWQTextField setPasswordMode:]): When creating the password field, keep
        the setSelectable state synchronized.
        (-[KWQTextField setSelectable:]): If we already have a password field, be
        sure to keep its selectable state the same as the main field.

2003-05-12  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3255281 -- REGRESSION: objc_error in key loop code, closing tab containing aintitcool.com page

        * kwq/KWQTextField.mm:
        (-[KWQSecureTextField nextKeyView]): Change back to using our own nextKeyView
        implementation. By returning the nextKeyView from KWQTextField, we ended up making
        AppKit very upset about the key view loop. This undoes a change I made last
        Thursday, so the regression is very new and was never in a release.
        (-[KWQSecureTextField previousKeyView]): More of the same.
        (-[KWQSecureTextField nextValidKeyView]): Ditto.
        (-[KWQSecureTextField previousValidKeyView]): Ditto.

2003-05-11  David Hyatt  <hyatt@apple.com>

	The root element (HTML) tries to set itself to the lowest position
	of the canvas, before the canvas has necessarily even determined
	the correct lowest position.  This creates a timing problem.

	This code is legacy code anyyway, left over from before KHTML
	understood about overflow.  The HTML should not be resizing itself
	to enclose positioned content or floats.  They should just spill
	out of the HTML object, so the fix is easy: kill the legacy code.
	
	There's a second fix required as well, which is to make the canvas
	avoid scanning its positioned objects list when computing its
	lowest and rightmost position.  Fixed positioned objects can't
	be scrolled, so it's incorrect to show scrollbars because of
	fixed positioned objects (since they are locked to the viewport).
	
        Reviewed by darin/gramps

        * khtml/rendering/render_block.cpp:

2003-05-11  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

	- fixed 3242493 -- loop in khtml::RenderLayer::RenderZTreeNode at google cached copy of epower2go.biz page

        * khtml/rendering/render_layer.cpp: (RenderLayer::RenderZTreeNode::detach):
        Use an iterative algorithm rather than a recursive one to destroy the child
        nodes at each level of the tree, so our recursion is O(depth of tree) rather
        than O(size of tree).

2003-05-10  David Hyatt  <hyatt@apple.com>

	Fix the misrendering at the top of cnn.com (the extra tearing
	by the Google logo on the front page of cnn).  

	I am reducing the intrinsic margins of text fields down to 2px 
	to match buttons and selects.

	This is easily sufficient distance to avoid focus ring overlap and
	still looks nice, e.g., on www.google.com and amazon.com.
	
        Reviewed by mjs

        * khtml/rendering/render_form.h:

2003-05-10  David Hyatt  <hyatt@apple.com>

	A refinement of our intrinsic margin rules for form controls.
	Rather than always applying the intrinsic margin to form controls,
	this patch makes the application conditional.

	If the Web page explicitly specifies a width on a form control,
	the form control will honor that precise pixel-width and will not
	apply left/right intrinsic margins.  If a Web page specifies margins
	that the control should use, then the control will honor those
	margins.  The same rules apply for height and top/bottom margins.

        Reviewed by mjs

        * khtml/css/html4.css:
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcReplacedWidth):
        (RenderBox::calcReplacedHeight):
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::addIntrinsicMarginsIfNeeded):
        (RenderFormElement::setStyle):
        * khtml/rendering/render_form.h:

2003-05-10  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

	- fixed 3206695 -- Safari puts all of the mailto form content in email subject line, should put content in body

        The bug was caused by our KURL class not parsing the query out of the mailto URL properly.

        * kwq/KWQKURL.h: Removed parameter from prettyURL, unused in KHTML.
        * kwq/KWQKURL.mm:
        (KURL::prettyURL): Removed parameter, unused in KHTML.
        (KURL::parse): Parse queries even from non-hierarchical URLs. This fixes the bug.

        * WebCore-tests.exp: Updated for parameter removed from prettyURL.
        * WebCore-combined.exp: Regenerated.

2003-05-09  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

	- fixed 3131026 -- half-width yen character (x5C) shows up as a backslash

        To fix this, I had to reverse our previous decoding approach for the characters
        that are different in Shift-JIS and ASCII. Before, we would decode them as
        ASCII, and so they would be wrong in web pages, but right in URLs. Now, I decode
        them as Shift-JIS, so they are right for web pages. This does not break URLs,
        though, because back in February we added code to re-encode characters for URLs
        to fix bug 3124596. But there is a TEC bug we have to work around to make this
        work right for the tilde character.

        * kwq/KWQTextCodec.mm:
        (QTextCodec::fromUnicode): Work around the TEC bug that prevents the tilde
        character from surviving the round trip through the decoding process by explicitly
        changing decoded tildes back to ASCII tildes.
        (KWQTextDecoder::convertUsingTEC): Do not set kUnicodeForceASCIIRangeMask.

        * kwq/KWQCString.h: Added replace call for use by new code. Some other
        small improvements.
        * kwq/KWQCString.mm:
        (QCString::contains): Make this faster by not doing the case-insensitive
        and case-sensitive cases both in the same loop.
        (QCString::append): Changed the += calls to this name, and made the
        += operator override call these.
        (QCString::replace): Added.

        * WebCore-tests.exp: Changed to export append calls.
        * WebCore-combined.exp: Regenerated.

2003-05-09  David Hyatt  <hyatt@apple.com>

	Finally get tables cutting the right properties off and letting
	the right ones through in quirks mode.  Font-family *is* inherited
	through into tables in all other browsers.  We have been doing this
	wrong the whole time.  Also ensure that font-style and font-variant
	are reset.
	
        Reviewed by darin

        * khtml/css/quirks.css:

2003-05-09  David Hyatt  <hyatt@apple.com>

	Always allow KONQ_TEXT as a valid value, and don't restrict its
	use to lax CSS parsing.  (We want our UA sheets to be parsed
	strictly.)

	Fixes bug 3224791, color inheritance not being properly cut off
	in tables in quirks mode.
	
        Reviewed by mjs and darin

        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):

2003-05-09  David Hyatt  <hyatt@apple.com>

	Fix for 3253695, XML pages with <style>@import...</style> don't
	render.  The XML tokenizer is getting text in small chunks, and
	so it tries to load the sheet multiple times.  This fix patches
	the stylesheet code to properly decrement the loading sheet
	count when you abort a still-loading @import.
	
        Reviewed by darin

        * khtml/html/html_headimpl.cpp:
        (HTMLStyleElementImpl::childrenChanged):

2003-05-09  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3191943 -- XML parsing error occurs when loading shift-JIS Japanese XML file

        * khtml/misc/decoder.h: Add a new type of encoding, EncodingFromXMLHeader.
        * khtml/misc/decoder.cpp:
        (findXMLEncoding): Added.
        (Decoder::decode): Call findXMLEncoding to extract the encoding from the XML header.

2003-05-08  Darin Adler  <darin@apple.com>

        Reviewed by John and Ken.

	- fixed 3253461 -- stylesheet-reading code does not support BOM
	- fixed 3253359 -- XML parser does not allow UTF-8 BOM

        * kwq/KWQTextCodec.mm:
        (KWQTextDecoder::KWQTextDecoder): Initialize the new _littleEndian, _atStart,
        and _numBufferedBytes fields, not the old _flags, _state, and _haveBufferedByte fields.
        (KWQTextDecoder::convertUTF16): Moved the BOM-based endianness detection out of here;
        now done in toUnicode. Switched to use the new multibyte buffer, even though we only
        need one byte of it. Remove any BOM characters encountered within the text.
        (KWQTextDecoder::convertUsingTEC): Remove any BOM characters encountered within the text.
        (KWQTextDecoder::toUnicode): Do all the BOM detection at this level, including the
        UTF-8 BOM as well as the UTF-16 BOM.

        * khtml/misc/decoder.cpp: (Decoder::decode): Don't bother stripping the UTF-8 BOM.
        The QTextCodec object handles that now.

        * kwq/KWQXmlSimpleReader.mm: (QXmlSimpleReader::parse): Pass in the data in 16-bit character
        form, and specify the encoding when creating the parser. Both expat and KHTML
        want to do the decoding, so this is really just a way to get expat to back off.

2003-05-08  David Hyatt  <hyatt@apple.com>

	Fix the definition of isRoot() so that it doesn't depend on
	the object being in the render tree yet (and to avoid any
	virtual function calls as well).

	Make sure that requiresLayer() returns true if the object is
	the root.  This way the layer isn't destroyed when you e.g.,
	hit Cmd+ to increase font size.  

	This fixes bug 3252496.
	
        Reviewed by rjw

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_object.cpp:
        (RenderObject::isRoot):
        * khtml/rendering/render_object.h:
        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::createRenderer):

2003-05-08  David Hyatt  <hyatt@apple.com>

	Background-position-x and y should be length|percentage.  Number
	is not a valid option.  Need to remove this so that the quirk will
	kick in that translates numbers to pixels.  Fixes an issue on
	diveintomark's list.
	
        Reviewed by darin

        * khtml/css/cssparser.cpp:
        (CSSParser::parseValue):

2003-05-08  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

	- fixed part of the cause of 3251979 -- switching tabs hoses page layout

        * kwq/WebCoreSettings.mm: (-[WebCoreSettings _updateAllViews]): Only update views that are
        using this settings object. The old way would result in re-laying out all views every time
        you created a new one.

2003-05-08  Darin Adler  <darin@apple.com>

        Reviewed by Dave.

        - fixed regression caused by my last check-in; need to use the KHTMLView layout function

        * kwq/KWQWidget.mm: (QWidget::setFocus): Use KHTMLView's layout instead of RenderCanvas's.

	- fixed 3251913 -- when form field has focus, dragging across text elsewhere does not select it

        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::setSelection): Remove setFocusNode(0) call. Apparently not needed these days.
        I tested and everything works fine without it, and its side effect was the bug above.
        (DocumentImpl::setFocusNode): Remove clearSelection() call for similar reasons.

2003-05-08  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

	- fixed 3251985 -- REGRESSION: tabbing doesn't scroll text fields into view any more

        * kwq/KWQTextField.h: Add a _hasFocus field, which prevents us from focusing
        multiple times.
        * kwq/KWQTextField.mm:
        (+[KWQTextField initialize]): Set KWQTextFieldCell as the cell class. We need a cell
        subclass to detect when editing begins.
        (-[KWQTextField setPasswordMode:]): Don't pass a QLineEdit to the secure text field
        when creating it. It's no longer needed.
        (-[KWQTextField controlTextDidEndEditing:]): Call setHasFocus:NO, and do the actual
        work in there.
        (-[KWQTextField control:textShouldBeginEditing:]): Remove the work that was done in
        here. This is only called when you actually start typing, so it's too late.
        (-[KWQTextField becomeFirstResponder]): Keep the code to forward first responder to
        the password field, but get rid of the rest, because this code path does not cover
        all the ways to start editing.
        (-[KWQTextField currentEditorForEitherField]): Moved this method inside the
        KWQInternal category.
        (-[KWQTextField selectedRange]): Ditto.
        (-[KWQTextField setSelectedRange:]): Ditto.
        (-[KWQTextField setHasFocus:]): Added. This method does all the work we want to do
        when we get focus and when we relinquish focus, including scrolling to make the field
        visible.
        (-[KWQTextFieldCell editWithFrame:inView:editor:delegate:event:]):
        Call setHasFocus:YES on the KWQTextField.
        (-[KWQTextFieldCell selectWithFrame:inView:editor:delegate:start:length:]): Ditto.
        (+[KWQSecureTextField cellClass]): Use KWQSecureTextFieldCell as the cell class.
        We need a cell subclass to detect when editing begins and we can't use the normal
        technique because NSSecureTextField will raise an exception.
        (-[KWQSecureTextField nextKeyView]): Simplified to just call through to KWQTextField.
        (-[KWQSecureTextField previousKeyView]): Ditto.
        (-[KWQSecureTextField nextValidKeyView]): Ditto.
        (-[KWQSecureTextField previousValidKeyView]): Ditto.
        (-[KWQSecureTextField widget]): Ditto.
        (-[KWQSecureTextField fieldEditorDidMouseDown:]): Ditto.
        (-[KWQSecureTextFieldCell editWithFrame:inView:editor:delegate:event:]):
        Call setHasFocus:YES on the KWQTextField.
        (-[KWQSecureTextFieldCell selectWithFrame:inView:editor:delegate:start:length:]): Ditto.
        
        * kwq/KWQWidget.mm: (QWidget::setFocus): Do a layout before positioning the widget.
        The code dealt with calls after a layout and before a draw, before, but not calls
        before a layout.

2003-05-08  David Hyatt  <hyatt@apple.com>

	Fix for a problem where positioned/floating children with
	percentage width tables inside them  don't expand to fill 
	the width of their containing block.  

	The way to solve this is to detect this
	case and treat the block as though it has an infinite maxwidth.

	Note that this is a quirk only, since doing this for real would
	be crazy.  We're basically just matching broken WinIE behavior.
	
        Reviewed by kocienda

        * khtml/rendering/render_block.cpp:

=== Safari-78 ===

2003-05-08  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3174769 -- Safari doesn't ignore byte order mark at start of UTF-8 HTML document

        * khtml/misc/decoder.cpp: (Decoder::decode): Added handling of the UTF-8 BOM
        to the code that already handled the UTF-16 BOM.

2003-05-06  David Hyatt  <hyatt@apple.com>

	The purpose of this patch is to unify XML and HTML documents' root
	element handling.  Instead of having a special RenderHTML object
	for dealing with <html>, root element handling is now done in
	base classes so that it works with XML documents as well.

	The changes include:
	  * Rename RenderRoot to RenderCanvas to more accurately
	    reflect what this RenderObject represents in CSS2.
	  * Rename root() to canvas()
	  * Rename isHtml() to isRoot()
	  * Rename isRoot() to isCanvas().
	  * Eliminate RenderHTML and fold its functionality into base
	    classes (RenderBlock and RenderBox).
	  * isRoot() now means "are you the RenderObject for the root
	    element".  All isHtml() callers now say isRoot() instead.
	  
        Reviewed by gramps

        * ForwardingHeaders/rendering/render_canvas.h: Added.
        * ForwardingHeaders/rendering/render_html.h: Removed.
        * ForwardingHeaders/rendering/render_root.h: Removed.
        * WebCore.pbproj/project.pbxproj:
        * khtml/ecma/kjs_dom.cpp:
        * khtml/ecma/kjs_window.cpp:
        * khtml/html/html_baseimpl.cpp:
        (HTMLHtmlElementImpl::id):
        * khtml/html/html_baseimpl.h:
        * khtml/khtmlview.cpp:
        (KHTMLView::layout):
        (KHTMLView::print):
        (KHTMLView::slotPaletteChanged):
        (KHTMLView::paint):
        (KHTMLView::timerEvent):
        * khtml/khtmlview.h:
        * khtml/rendering/render_applet.cpp:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_body.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::paintRootBoxDecorations):
        (RenderBox::paintBoxDecorations):
        (RenderBox::paintBackgroundExtended):
        (RenderBox::containingBlockWidth):
        (RenderBox::repaint):
        (RenderBox::calcHeight):
        (RenderBox::availableHeight):
        (RenderBox::calcAbsoluteVertical):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_canvas.cpp: Added.
        (RenderCanvas::RenderCanvas):
        (RenderCanvas::~RenderCanvas):
        (RenderCanvas::calcHeight):
        (RenderCanvas::calcWidth):
        (RenderCanvas::calcMinMaxWidth):
        * khtml/rendering/render_canvas.h: Added.
        * khtml/rendering/render_container.cpp:
        (RenderContainer::removeChildNode):
        * khtml/rendering/render_flow.cpp:
        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::layout):
        (RenderFrameSet::userResize):
        * khtml/rendering/render_html.cpp: Removed.
        * khtml/rendering/render_html.h: Removed.
        * khtml/rendering/render_image.cpp:
        (RenderImage::paintObject):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::enclosingPositionedAncestor):
        (RenderLayer::convertToLayerCoords):
        (RenderLayer::constructZTree):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_line.cpp:
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::paintObject):
        * khtml/rendering/render_object.cpp:
        (RenderObject::containingBlock):
        (RenderObject::canvas):
        (RenderObject::container):
        (RenderObject::removeFromObjectLists):
        (RenderObject::detach):
        (RenderObject::nodeAtPoint):
        (RenderObject::scheduleRelayout):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        * khtml/rendering/render_root.cpp: Removed.
        * khtml/rendering/render_root.h: Removed.
        * khtml/rendering/render_table.cpp:
        (RenderTable::layout):
        * khtml/rendering/render_text.cpp:
        (RenderText::paintObject):
        * khtml/rendering/table_layout.cpp:
        (shouldScaleColumns):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::attach):
        (DocumentImpl::setSelection):
        (DocumentImpl::clearSelection):
        (DocumentImpl::prepareMouseEvent):
        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::createRenderer):
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::rendererIsNeeded):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::adjustPageHeight):
        (KWQKHTMLPart::forceLayoutForPageWidth):
        (KWQKHTMLPart::selectionRect):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge _setupRootForPrinting:]):

2003-05-07  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3127927 -- web view should not use primary selection color when it's not first responder

        * kwq/WebCoreBridge.h: Added usesInactiveTextBackgroundColor getter and setter.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge drawRect:]): Set the QPainter's usesInactiveTextBackgroundColor to match the
        value from the part.
        (-[WebCoreBridge selectionRect]): Fix nil-deref that happened in the no-KHTMLView case.
        (-[WebCoreBridge setUsesInactiveTextBackgroundColor:]): Added.
        (-[WebCoreBridge usesInactiveTextBackgroundColor]): Added.

        * kwq/KWQKHTMLPart.h: Added usesInactiveTextBackgroundColor, including getter and setter.
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::KWQKHTMLPart): Initialize usesInactiveTextBackgroundColor.

        * kwq/KWQPainter.h: Added setUsesInactiveTextBackgroundColor and made selectedTextBackgroundColor
        a const member function, not a static one.
        * kwq/KWQPainter.mm:
        (QPainter::QPainter): Initialize _usesInactiveTextBackgroundColor to false.
        (QPainter::selectedTextBackgroundColor): Return secondarySelectedControlColor instead of
        selectedTextBackgroundColor if _usesInactiveTextBackgroundColor is true.

        * khtml/rendering/render_text.cpp: (TextRun::paintSelection): Call selectedTextBackgroundColor
        on the painter object; it's no longer a static member function.

        * khtml/rendering/render_root.cpp: (RenderRoot::selectionRect): Fix nil-deref that happened
        in the no-selection case.

2003-05-07  Vicki Murley  <vicki@apple.com>

        Reviewed by darin.

	- modify the Mixed build style to build optimized with symbols

        * WebCore.pbproj/project.pbxproj: removed OPTIMIZATION_CFLAGS, use WebCore.exp

2003-05-07  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3109258 -- Unicode above U+FFFF not handled correctly when expressed as numeric entities

        * khtml/html/htmltokenizer.cpp: (HTMLTokenizer::parseEntity): Keep track of the entity in
        an unsigned integer that can hold 32 bits rather than a QChar. Convert to a pair of Unicode
        surrogate code points if necessary.
        
        * khtml/misc/stringit.h: Add a second pushed character, used for the case where we have a pair of
        surrogate characters for a single numeric entity.

        * khtml/html/htmltokenizer.h: Add missing DOM:: that was compiling only due to "using namespace DOM"
        in stringit.h. Replace EntityChar with EntityUnicodeValue.

2003-05-06  Darin Adler  <darin@apple.com>

        Reviewed by Chris.

	- fixed 3211756 -- form field contents on the left instead of right on page in RtL language

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::updateFromElement): Call setAlignment based on the style's direction.
        (RenderTextArea::updateFromElement): Ditto.
        * kwq/KWQLineEdit.h: Added setAlignment.
        * kwq/KWQLineEdit.mm: (QLineEdit::setAlignment): Added. Calls setAlignment on KWQTextField.
        * kwq/KWQTextArea.h: Added setAlignment.
        * kwq/KWQTextArea.mm: (-[KWQTextArea setAlignment:]): Added. Calls setAlignment on NSTextView.
        * kwq/KWQTextEdit.h: Added setAlignment.
        * kwq/KWQTextEdit.mm: (QTextEdit::setAlignment): Added. Calls setAlignment on KWQTextField.
        * kwq/KWQTextField.mm: (-[KWQTextField setAlignment:]): Added. Call setAlignment on secure
        text field too.

	- fixed 3250538 -- on pages labeled "US-ASCII", non-ASCII chars are not decoded as Latin-1
          as in other browsers

        * kwq/KWQTextCodec.mm:
        (effectiveEncoding): Added. Maps ISO Latin-1 and US-ASCII to Windows Latin-1.
        (QTextCodec::fromUnicode): Use effectiveEncoding.
        (KWQTextDecoder::convertUsingTEC): Use effectiveEncoding.

        - other changes

        * kwq/KWQCharsets.mm: (buildDictionaries): Make the first encoding in the file win for
        purposes of deciding which name is used. I thought this was happening before, but actually
        the last one was winning. Do this by using CFDictionaryAddValue, which does nothing if
        there's already a dictionary entry, instead of CFDictionarySetValue, which replaces.

2003-05-06  David Hyatt  <hyatt@apple.com>

	Make negative z-index content paint above the background of
	the stacking context element that encloses it.  This fixes
	gettyimages.com and hotwired.com.
	
        Reviewed by kocienda

        * khtml/css/html4.css:
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_inline.cpp:
        (RenderInline::paintObject):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):
        (RenderLayer::nodeAtPoint):
        (RenderLayer::RenderZTreeNode::constructLayerList):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_root.cpp:
        * khtml/rendering/render_table.cpp:
        (RenderTable::paint):
        * kwq/KWQRenderTreeDebug.cpp:
        (write):

2003-05-06  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 3245048 - "Block Pop-Up Windows" can easily be bypassed using javascript: URLs

	Closed the loophole by tracking what client redirects were
	triggered by user actions, and making sure the script interpreter
	knows.

        * khtml/ecma/kjs_window.cpp:
        (Window::put):
        (WindowFunc::tryCall):
        (Location::put):
        (LocationFunc::tryCall):
        * khtml/khtml_part.cpp:
        (KHTMLPart::executeScript):
        (KHTMLPart::clear):
        (KHTMLPart::scheduleRedirection):
        (KHTMLPart::slotRedirect):
        (KHTMLPart::urlSelected):
        * khtml/khtml_part.h:
        * khtml/khtmlpart_p.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge stringByEvaluatingJavaScriptFromString:]):

2003-05-06  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

        - used ObjectAlloc to find large numbers of allocations on startup and get rid of some

        * kwq/KWQColor.mm: (QColor::getNSColor): Keep a cache of 32 colors instead of returning a new
        one each time. Also use special cases for black and white.

2003-05-05  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Dave.

	- fixed 3241065 - popcap.com doesn't work in Safari, window.scrollBy fails to work in onLoad

	Make sure to do a layout before accessing any window properties or
	calling any window functions that require a layout to work
	properly.

        * khtml/ecma/kjs_window.cpp:
        (Window::get):
        (WindowFunc::tryCall):
        (Window::updateLayout):
        * khtml/ecma/kjs_window.h:

2003-05-05  David Hyatt  <hyatt@apple.com>

	Fix for 3247722. Make sure the grammar accepts properties with
	no values as declarations (albeit bad ones).
	
        Reviewed by darin

        * khtml/css/parser.cpp:
        * khtml/css/parser.y:

2003-05-05  David Hyatt  <hyatt@apple.com>

	Fix for 3248587.  Refine the crash fix for generated image
	content so that we still set the image's intrinsic width
	and height properly.
	
        Reviewed by john

        * khtml/rendering/render_image.cpp:
        (RenderImage::setPixmap):

2003-05-04  David Hyatt  <hyatt@apple.com>

	When using the content property in CSS, you can string together
	an intermixed list of strings and image URLs.  The old code
	only supported a single image URL, and if you tried to mix
	text in with images, you ended up crashing.

	The crash bug is 3248172.  The fix is to maintain a list of
	ContentData objects instead of just a single object and to
	ensure that a whole list of generated content gets made (and
	not just a single RenderObject).
	
        Reviewed by john

        * khtml/css/cssstyleselector.cpp:
	(applyRule)
        * khtml/rendering/render_container.cpp:
        (RenderContainer::insertPseudoChild):
        * khtml/rendering/render_image.cpp:
        (RenderImage::setStyle):
        (RenderImage::setContentObject):
        (RenderImage::updateFromElement):
        * khtml/rendering/render_image.h:
        * khtml/rendering/render_style.cpp:
        (RenderStyle::setContent):
        (ContentData::clearContent):
        * khtml/rendering/render_style.h:

2003-05-05  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed replaceOccurrencesOfString crash reported in bug 3247249 (not what the bug is about)

        * kwq/KWQTextArea.mm: (-[KWQTextArea text]): Use the length of the replaced text.

2003-05-04  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3131534 -- "javascript:window.open()" leads to page not found error

        * khtml/ecma/kjs_window.cpp: (WindowFunc::tryCall): For open() calls, if the
        first parameter is not present, use "" instead of "undefined" as the URL.

	- fixed 3244766 -- window.open() doesn't position window correctly along the y axis

        * kwq/KWQKHTMLPartBrowserExtension.mm: (KHTMLPartBrowserExtension::createNewWindow):
        Fixed the code that flips the y coordinate to take the window height into account.

2003-05-03  David Hyatt  <hyatt@apple.com>

	Add smallCaps boolean to the string drawing and measuring
	routines.  WebCore should be done after this patch, with
	the rest of the work being done entirely in WebKit.
	
        Reviewed by darin

        * khtml/rendering/font.cpp:
        (Font::drawText):
        (Font::floatWidth):
        (Font::floatCharacterWidths):
        (Font::width):
        * kwq/KWQFontMetrics.h:
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        * kwq/KWQPainter.h:
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:

2003-05-03  David Hyatt  <hyatt@apple.com>

	Rename layouted to needsLayout.  Add a layoutIfNeeded method
	and start using it in places that do if (needsLayout()) layout();
	
        Reviewed by kocienda

        * khtml/ecma/kjs_dom.cpp:
        (DOMNode::getValueProperty):
        * khtml/html/html_baseimpl.cpp:
        (HTMLFrameSetElementImpl::recalcStyle):
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/html/html_imageimpl.cpp:
        (HTMLImageElementImpl::width):
        (HTMLImageElementImpl::height):
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::parseAttribute):
        * khtml/khtmlview.cpp:
        (KHTMLView::layout):
        (KHTMLView::print):
        (KHTMLView::timerEvent):
        * khtml/rendering/bidi.cpp:
        * khtml/rendering/render_applet.cpp:
        (RenderApplet::layout):
        (RenderEmptyApplet::layout):
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::close):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        (RenderContainer::removeChildNode):
        (RenderContainer::removeChild):
        (RenderContainer::appendChildNode):
        (RenderContainer::insertChildNode):
        (RenderContainer::layout):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::layout):
        (RenderSubmitButton::updateFromElement):
        (RenderSelect::updateFromElement):
        (RenderSelect::calcMinMaxWidth):
        (RenderSelect::layout):
        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::layout):
        (RenderFrameSet::positionFrames):
        (RenderFrameSet::userResize):
        (RenderFrameSet::canResize):
        (RenderPart::setWidget):
        (RenderPartObject::updateWidget):
        (RenderPartObject::layout):
        * khtml/rendering/render_image.cpp:
        (RenderImage::setPixmap):
        (RenderImage::layout):
        * khtml/rendering/render_inline.cpp:
        (RenderInline::addChildToFlow):
        (RenderInline::splitInlines):
        (RenderInline::splitFlow):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::checkScrollbarsAfterLayout):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::layout):
        (RenderListMarker::setStyle):
        (RenderListMarker::layout):
        (RenderListMarker::setPixmap):
        * khtml/rendering/render_object.cpp:
        (RenderObject::RenderObject):
        (RenderObject::setNeedsLayout):
        (RenderObject::information):
        (RenderObject::dump):
        (RenderObject::setStyle):
        (RenderObject::invalidateLayout):
        (RenderObject::detach):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::paint):
        (RenderWidget::setQWidget):
        (RenderWidget::layout):
        * khtml/rendering/render_root.cpp:
        * khtml/rendering/render_table.cpp:
        (RenderTable::addChild):
        (RenderTable::layout):
        (RenderTable::paint):
        (RenderTable::close):
        (RenderTable::splitColumn):
        (RenderTable::appendColumn):
        (RenderTable::recalcSections):
        (RenderTableSection::addChild):
        (RenderTableSection::setCellWidths):
        (RenderTableSection::layoutRows):
        (RenderTableSection::recalcCells):
        (RenderTableRow::addChild):
        (RenderTableRow::layout):
        (RenderTableCell::paint):
        * khtml/rendering/render_text.cpp:
        (RenderText::setText):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):
        (DocumentImpl::updateStyleSelector):
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeBaseImpl::insertBefore):
        (NodeBaseImpl::replaceChild):
        (NodeBaseImpl::appendChild):
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::forceLayoutForPageWidth):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge needsLayout]):

2003-05-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Richard.

	- reformatted method prototypes to match AppKit style

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreDOMPrivate.h:
        * kwq/WebCoreHistory.h:
        * kwq/WebCoreResourceLoader.h:
        * kwq/WebCoreTextRenderer.h:
        * kwq/WebDOMDocument.h:
        * kwq/WebDOMElement.h:
        * kwq/WebDOMNode.h:

2003-05-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Darin.

	- fixed 2936175 - MALLORY: please implement onResize

        * khtml/khtmlview.cpp:
        (KHTMLView::resizeEvent): Put most of this in #if !APPLE_CHANGES,
	since we already do the relayout and such on resize elswhere.
        * kwq/KWQEvent.h: Add a minimal QResizeEvent.
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::sendResizeEvent): Send it to the view.
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge sendResizeEvent]): Send it to the part.

2003-05-02  David Hyatt  <hyatt@apple.com>

	Fix for 3184113, bottom margins didn't collapse with their children
	like they were supposed to.  The problem is fixed by separately
	caching whether or not the top and bottom margins can collapse
	with their kids instead of having one global canCollapse variable.
	
        Reviewed by kocienda

        * khtml/rendering/render_block.cpp:

2003-05-02  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - fixed 3236383 -- http://www.xy.com/ exception, crash loading main page

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::scheduleClose): Change to use closeWindowSoon, so that
        the delay is on the WebKit side so it can be tied to the WebView as a whole, not a particular bridge.

        * kwq/WebCoreBridge.h: Replaced closeWindow with closeWindowSoon.

        - rolled in a couple of harmless and eventually-possibly-useful changes inspired by changes
          OmniGroup made in their copy of WebCore

        * kwq/KWQListBox.mm: Make KWQTableView a KWQWidgetHolder.
        (-[KWQTableView widget]): Return the widget.
        * kwq/KWQScrollView.mm: (QScrollView::ensureVisible): First cut at implementing these.

2003-05-02  David Hyatt  <hyatt@apple.com>

	Make sure that recalcSections always clears out the needSectionRecalc
	boolean, even in the case where it finds column elements.

	Fixes the assert outlined in bug 3237651.
	
        Reviewed by john

        * khtml/rendering/render_table.cpp:
        (RenderTable::recalcSections):

2003-05-01  David Hyatt  <hyatt@apple.com>

	Fix for 3226030, percentage height tables inside table cells
	don't grow to fill the space inside the cell.  There was
	a missing edge case here for the case where the table was
	nested inside a table cell.
	
        Reviewed by darin

        * khtml/rendering/render_table.cpp:
        (RenderTable::layout):

2003-05-01  David Hyatt  <hyatt@apple.com>

	Add a cycle check when importing stylesheets to prevent
	infinite loops.
	
        Reviewed by john

        * khtml/css/css_ruleimpl.cpp:
        (CSSImportRuleImpl::init):

2003-05-01  David Hyatt  <hyatt@apple.com>

	Table rows don't know their precise dimensions, so repainting
	them fails.  For now, just make an invalidation of a table
	row due to CSS changes invalidate the whole table.

	This is what the old Safari table code used to do prior to the
	new table code landing.

	Fixes bug #3205092.
	
        Reviewed by darin/john

        * khtml/rendering/render_table.cpp:
        (RenderTableRow::repaint):
        * khtml/rendering/render_table.h:

2003-05-01  David Hyatt  <hyatt@apple.com>

	Fix for 3232637, don't let generated parentless image content
	try to do width/height/layout calculations.  It will do this
	all anyway, when it finally gets inserted into the rendering
	tree.
	
        Reviewed by john

        * khtml/rendering/render_image.cpp:
        (RenderImage::setPixmap):

2003-05-01  David Hyatt  <hyatt@apple.com>

	Fix for 3239404, a crash caused because a block-level :after
	element was being inserted as generated content inside an
	inline element.

	The fix is to mutate the display of the generated content to
	be inline when the parent of the generated content is also
	inline. 

	Section 12.1 of the CSS2 spec (at the very end of the spec)
	covers this special case.  Once we do the mutation it becomes
	impossible for generated content to cause a splitFlow, and so
	the crash is plugged.
	
        Reviewed by john

        * khtml/rendering/render_container.cpp:
        (RenderContainer::insertPseudoChild):

2003-05-01  David Hyatt  <hyatt@apple.com>

	Replace effectiveWidth and effectiveHeight with a 
	parameterized overflowWidth/Height, since this is much better
	terminology.

	Also fix event handling so that it no longer assumes (incorrectly)
	that being inside the overflow rect of an object means you are
	inside the object.  Now there are two separate checks, with the
	overflow check being used only to figure out if you should check
	inside your kids.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::repaint):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::repaint):
        * khtml/rendering/render_object.cpp:
        (RenderObject::nodeAtPoint):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_table.h:

=== Safari-77 ===

2003-04-30  David Hyatt  <hyatt@apple.com>

	Fix for 3244157, giantrobot.com misrenders with a lot of
	vertical space.  Overflow heights were being miscomputed for
	overflow:auto blocks.
	
        Reviewed by gramps

        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:

2003-04-30  David Hyatt  <hyatt@apple.com>

	Fix for 3210725, invalid n/a selector treated as valid.  This
	fix also makes the CSS1 test on the test suite for forward-compatible
	parsing completely pass (yay!), which was an issue on
	diveintomark's list.

        Reviewed by gramps

        * khtml/css/parser.cpp:
        * khtml/css/parser.y:

2003-04-30  David Hyatt  <hyatt@apple.com>

	Fixes for 3227983 and 3224521, both bugs involving bad letter-spacing
	property values.  This fixes all Movable Type blogs that had this
	error in their stylesheets.
	
        Reviewed by gramps

        * khtml/css/parser.cpp:
        * khtml/css/parser.y:

2003-04-30  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

	- fixed 3233819 -- MALLORY: onChange handler being called on SELECT even if selected item does not change

        * kwq/KWQComboBox.h: Added _currentItem variable, updateCurrentItem function, and replaced
        activated function with itemSelected function.
        
        * kwq/KWQComboBox.mm:
        (QComboBox::QComboBox): Call updateCurrentItem so _currentItem is up to date.
        (QComboBox::insertItem): Ditto.
        (QComboBox::clear): Ditto.
        (QComboBox::setCurrentItem): Ditto.
        (QComboBox::updateCurrentItem): Added. Returns true if current item has changed since the last time
        the function was called.
        (QComboBox::itemSelected): Only send the activate method if updateCurrentItem returns true.
        (-[KWQComboBoxAdapter action:]): Call itemSelected instead of calling activated directly.

2003-04-29  David Hyatt  <hyatt@apple.com>

	Fix for the Adam Rice float/padding test on diveintomark's list
	of bugs.  We weren't adding in the parent's border/padding in
	one case in the clearFloats function, which resulted in the
	float being incorrectly positioned.
	
        Reviewed by darin

        * khtml/rendering/render_block.cpp:

2003-04-29  David Hyatt  <hyatt@apple.com>

	This patch fixes the following bugs:

	(1) 3186174 - padding-left improperly applied to list items.
	The fix is in render_list.cpp and involves adding in the
	list item's border and padding so that outside markers end up
	outside the border box instead of just inside the padding box.

	(2) 3239571 - a stray !important after a ; causes the CSS parser
	to choke.  This patch adds a rule to parser.y to deal with
	!importants found in between property values and to just ignore
	them.

	(3) 3170647 - positioned boxes with auto widths ended up adding
	in their border/padding twice!  Make sure that when 
	calcAbsoluteHorizontal in render_box.cpp examines m_maxWidth that
	it subtracts out the border and padding and looks at content width.

	(4) 3186165 - Negative padding values were being incorrectly
	honored by Safari.  A patch to css_styleselector.cpp checks to
	see if the value specified by the rule is negative, and if so
	the rule is not applied.

	(5) 3132172 - The clip property could not be accessed via script
	because the cssText routine for CSS_RECT primitive values had
	not been implemented.  In css_valueimpl.cpp this code has now been
	filled in.
	
        Reviewed by mjs

        * khtml/css/css_valueimpl.cpp:
        (CSSPrimitiveValueImpl::cssText):
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/parser.cpp:
        * khtml/css/parser.y:
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcAbsoluteHorizontal):
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::paintObject):

2003-04-29  David Hyatt  <hyatt@apple.com>

	Fix for 3226138, crash on canada.gc.ca.  Make sure a failed
	@media parse doesn't crash by adding a null check.
	
        Reviewed by mjs

        * khtml/css/parser.cpp:
        * khtml/css/parser.y:

2003-04-29  David Hyatt  <hyatt@apple.com>

	The remainder of the overflow:auto patch.

	A minor table cell optimization has also been included.

	Also fixing one of rjw's inline table bugs.  Inline tables
	didn't clear their minmaxwidth bool when contents inside them
	changed size.
	
	r=mjs/gramps on overflow:auto stuff
	r=rjw on the table stuff

        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::parseAttribute):
        * khtml/rendering/render_block.cpp:
        * khtml/rendering/render_block.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::checkScrollbarsAfterLayout):
        * khtml/rendering/render_object.cpp:
        (RenderObject::nodeAtPoint):
        * khtml/rendering/render_table.cpp:
        (RenderTableCell::layout):
        * khtml/rendering/render_table.h:

2003-04-29  Darin Adler  <darin@apple.com>

        Reviewed by John.

	- fixed 3234633 -- page with moderately deep tag nesting causes crash when closed (www.4strokenationals.com)

        * khtml/xml/dom_nodeimpl.cpp: (NodeBaseImpl::~NodeBaseImpl): Avoid recursion by using a global
        list of child nodes to destroy and only doing the actual destruction at the top level.

2003-04-29  Darin Adler  <darin@apple.com>

        Mostly reviewed by Ken, some bits reviewed by John.

	- fixed 3188781 -- eliminate globally initialized objects from WebCore

        * kwq/KWQString.h: Change QChar::null to be a char constant, and QString::null to be a const char *.
        In the cases where the code still compiles after these changes, everything works fine. A few cases
        that didn't compile are fixed below.
        * kwq/KWQString.mm: Remove QString::null.
        (QString::mid): Return QString() instead of null.
        * kwq/KWQChar.mm: Remove the definition of QChar::null.

        * khtml/css/css_base.cpp: (CSSSelector::extractPseudoType): Use DOMString explicitly in one place
        where the code said QString::null. The trick where QString::null is really a const char * does not
        work in this case.
        * khtml/khtml_part.cpp: (KHTMLPart::reparseConfiguration): Use QString() instead of QString::null
        in one place. The trick where QString::null is really a const char * does not work in this case.
        * kwq/KWQKHTMLSettings.h: Use QString() for settingsToCSS, the trick where QString::null is really
        a const char * does not work in this case.
        * khtml/rendering/render_list.cpp: (RenderListMarker::paintObject): Use an isEmpty check here instead
        of comparing with QString::null. Not sure this change was strictly required, but it is simpler and
        may also make the code slightly faster.

        * kwq/KWQKFileDialog.h: Removed. This used QString::null in a way that is incompatible with the new
        "0" hack, but was not used any more.
        * kwq/KWQKFileDialog.mm: Removed.
        * ForwardingHeaders/kfiledialog.h: Empty this out, since there is no KWQKFileDialog.h any more.
        * WebCore.pbproj/project.pbxproj: Removed KWQKFileDialog.h and .mm.
       
        * khtml/html/htmltokenizer.cpp: Change the commentStart global array to be an array of char instead
        of QChar to avoid the static constructor; the code works fine with char anyway.
        * khtml/html/html_formimpl.cpp: Change the global constants in this file to be char instead of QChar.
        It works this way (and faster for KWQ), and avoids the static constructor.

        * khtml/rendering/bidi.h: Change BidiIterator from a class with constructors into a plain struct.
        The copy construct and assignment operator weren't needed anyway since they simply duplicated default
        assignment, and if we have a constructor then we can't use it as a global object, since we want to
        avoid static constructors. Do the same with BidiStatus, and also stop using bit fields. It's silly to
        use bit fields for something when we have only one global instance of it; just makes extra code size
        and saves a few bytes.
        * khtml/rendering/bidi.cpp:
        (BidiIterator::current): Move the non-breaking space global inside this function.
        (appendRunsForObject): Initialize BidiIterator object using brace notation.
        (buildCompactRuns): Initialize BidiIterator objects using brace notation and assignment.
        (RenderBlock::layoutInlineChildren): Initialize BidiStatus fields separately. Initialize BidiIterator
        objects using brace notation and assignment.
        (RenderBlock::findNextLineBreak): Initialize BidiIterator objects using brace notation and assignment.

        * khtml/rendering/render_frames.cpp: Removed an include of <iostream.h>. This pulled the entire
        C++ I/O library in, with lots of static constructors. Elsewhere, we are careful not to use the C++
        I/O library in WebCore except in Development versions. And this file didn't actually use the library,
        just included the header.

        * kwq/KWQNamespace.h: Remove all the color globals except for the ones used in KHTML: black, white,
        darkGray, gray, and lightGray. And for those, make the globals RGB constants instead of QColor objects.
        This gets rid of the global objects with constructors and works without any KHTML code changes.
        * kwq/KWQColor.mm: Remove the definition of the QColor constants from the Qt class.

        * kwq/KWQPainter.h: Add overloads for setPen and setBrush so they work with the "color" constants
        from Qt that are now RGB constants rather than QColor objects.
        * kwq/KWQPainter.mm:
        (QPainter::setPen): Set style to solid line and width to 0 when the parameter is an RGB constant.
        This is just like what you'd get if you constructed a QPen.
        (QPainter::setBrush): Set style to solid pattern when the parameter is an RGB constant.
        This is just like what you'd get if you constructed a QBrush.
        
        * khtml/misc/loader.h: Change m_LRULists to be a global pointer instead of a global array, so
        we don't have to statically construct LRUList objects.
        * khtml/misc/loader.cpp: (Cache::getLRUListFor): Allocate the global array the first time we
        pass through here.

2003-04-29  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3242460 -- crash in NSPopUpButtonCell at acheter-moins-cher.com

        * kwq/KWQComboBox.mm: (-[KWQPopUpButtonCell trackMouse:inRect:ofView:untilMouseUp:]):
        Defer QObject timers too as well as loading while tracking a pop-up.
        
        * kwq/KWQObject.h: Add defersTimers and setDefersTimers functions.
        * kwq/KWQObject.mm:
        (QObject::setDefersTimers): Added. When called with true starts deferring timers. When called
        with false schedules a "delay 0" task to deliver all the timers and stop deferring them.
        (-[KWQObjectTimerTarget sendTimerEvent]): Added. Contains guts of the old timerFired method.
        (-[KWQObjectTimerTarget timerFired]): Puts timer on the deferred timers list or calls sendTimerEvent.
        (+[KWQObjectTimerTarget stopDeferringTimers]): Remove timers items from the deferred timers list,
        and makes them fire, then stops deferring timers.

        * WebCore.pbproj/project.pbxproj: Reorder things a bit.

2003-04-29  Darin Adler  <darin@apple.com>

        Reviewed by Ken.

	- fixed 3230885 -- crash loading hixie test page in -[WebSubresourceClient connection:didReceiveData:]

        * khtml/rendering/render_style.cpp: (RenderStyle::setContent):
        Change code around so we don't deref the text object without checking
        the contentType. Also fix the leak of a DOMStringImpl in the case
        where we are asked to add a string, but the string pointer is 0.

2003-04-28  Richard Williamson  <rjw@apple.com>

        API changes from final review meeting.
        
        goBackOrForwardToItem: -> goToBackForwardItem:
        drop "Window" from WebUIDelegate method names.
        WebElementIsSelectedTextKey -> WebElementIsSelectedKey
        Cross-frame searchFor on WebView now public.
        
        Reviewed by Chris.

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:

2003-04-28  Darin Adler  <darin@apple.com>

        Reviewed by John.

        - re-fixed 3159076 -- turbotax.intuit.com forms have text fields instead of radio buttons

        * khtml/html/html_formimpl.cpp:  (HTMLInputElementImpl::attach): Only set the type
        if JavaScript hasn't set it explicitly already.

2003-04-25  David Hyatt  <hyatt@apple.com>

	Part two of the overflow patch.  This adds the scrollbars and
	patches the layers code, but it doesn't yet turn on the
	overflow:auto capability.
	
        Reviewed by mjs/gramps

        * ForwardingHeaders/qscrollbar.h: Added.
        * WebCore.pbproj/project.pbxproj:
        * khtml/ecma/kjs_dom.cpp:
        (DOMNode::getValueProperty):
        (DOMNode::putValue):
        * khtml/ecma/kjs_dom.h:
        * khtml/ecma/kjs_dom.lut.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::contentWidth):
        (RenderBox::repaintRectangle):
        (RenderBox::calcAbsoluteHorizontal):
        (RenderBox::calcAbsoluteVertical):
        (RenderBox::lowestPosition):
        * khtml/rendering/render_layer.cpp:
        (RenderScrollMediator::slotValueChanged):
        (RenderLayer::RenderLayer):
        (RenderLayer::~RenderLayer):
        (RenderLayer::updateLayerPosition):
        (RenderLayer::scrollOffset):
        (RenderLayer::subtractScrollOffset):
        (RenderLayer::scrollToOffset):
        (RenderLayer::updateScrollPositionFromScrollbars):
        (RenderLayer::setHasHorizontalScrollbar):
        (RenderLayer::setHasVerticalScrollbar):
        (RenderLayer::verticalScrollbarWidth):
        (RenderLayer::horizontalScrollbarHeight):
        (RenderLayer::moveScrollbarsAside):
        (RenderLayer::positionScrollbars):
        (RenderLayer::checkScrollbarsAfterLayout):
        (RenderLayer::paintScrollbars):
        (RenderLayer::paint):
        (RenderLayer::nodeAtPoint):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::clientWidth):
        (RenderObject::clientHeight):
        (RenderObject::scrollWidth):
        (RenderObject::scrollHeight):
        (RenderObject::nodeAtPoint):
        * khtml/rendering/render_object.h:
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::passWidgetMouseDownEventToWidget):
        * kwq/KWQNamespace.h:
        * kwq/KWQScrollBar.h: Added.
        * kwq/KWQScrollBar.mm: Added.
        (-[KWQScrollBar initWithQScrollBar:]):
        (-[KWQScrollBar scroll:]):
        (:m_valueChanged):
        (QScrollBar::~QScrollBar):
        (QScrollBar::setValue):
        (QScrollBar::setSteps):
        (QScrollBar::setKnobProportion):
        (QScrollBar::scrollbarHit):
